/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          if (XVECLEN (x2, 0) != 1)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (XINT (x2, 1))
            {
            case 2:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (!
#line 238 "../../gcc/config/lm32/lm32.md"
(flag_pic))
                return -1;
              return 1; /* movsi_got */

            case 3:
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (!
#line 246 "../../gcc/config/lm32/lm32.md"
(flag_pic))
                return -1;
              return 2; /* movsi_gotoff_hi16 */

            case 4:
              x4 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x4) != PLUS
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (!
#line 255 "../../gcc/config/lm32/lm32.md"
(flag_pic))
                return -1;
              return 3; /* movsi_gotoff_lo16 */

            default:
              return -1;
            }

        case LO_SUM:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!reloc_operand (operands[2], E_SImode)
              || !
#line 264 "../../gcc/config/lm32/lm32.md"
(!flag_pic))
            return -1;
          return 4; /* *movsi_lo_sum */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x3;
              operands[1] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (nonimmediate_operand (operands[0], E_QImode)
                      && general_operand (operands[1], E_QImode)
                      && 
#line 272 "../../gcc/config/lm32/lm32.md"
(lm32_move_ok (QImode, operands)))
                    return 5; /* *movqi_insn */
                  break;

                case E_HImode:
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && general_operand (operands[1], E_HImode)
                      && 
#line 285 "../../gcc/config/lm32/lm32.md"
(lm32_move_ok (HImode, operands)))
                    return 6; /* *movhi_insn */
                  break;

                case E_SImode:
                  if (nonimmediate_operand (operands[0], E_SImode)
                      && general_operand (operands[1], E_SImode)
                      && 
#line 299 "../../gcc/config/lm32/lm32.md"
(lm32_move_ok (SImode, operands)))
                    return 7; /* movsi_insn */
                  break;

                default:
                  break;
                }
              break;

            case PC:
              operands[0] = x2;
              if (register_operand (operands[0], E_SImode))
                return 21; /* indirect_jump */
              break;

            default:
              break;
            }
          if (GET_CODE (x2) != LABEL_REF
              || GET_CODE (x3) != PC)
            return -1;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          return 20; /* jump */

        case SIGN_EXTEND:
          switch (pattern0 (x1))
            {
            case 0:
              if (!
#line 321 "../../gcc/config/lm32/lm32.md"
(TARGET_SIGN_EXTEND_ENABLED || (GET_CODE (operands[1]) != REG)))
                return -1;
              return 8; /* *extendqihi2 */

            case 1:
              if (!
#line 341 "../../gcc/config/lm32/lm32.md"
(TARGET_SIGN_EXTEND_ENABLED || (GET_CODE (operands[1]) != REG)))
                return -1;
              return 10; /* *extendqisi2 */

            case 2:
              if (!
#line 361 "../../gcc/config/lm32/lm32.md"
(TARGET_SIGN_EXTEND_ENABLED || (GET_CODE (operands[1]) != REG)))
                return -1;
              return 12; /* *extendhisi2 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern0 (x1))
            {
            case 0:
              return 9; /* zero_extendqihi2 */

            case 1:
              return 11; /* zero_extendqisi2 */

            case 2:
              return 13; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case EQ:
          if (pattern1 (x1) != 0)
            return -1;
          return 14; /* *seq */

        case NE:
          if (pattern1 (x1) != 0)
            return -1;
          return 15; /* *sne */

        case GT:
          if (pattern1 (x1) != 0)
            return -1;
          return 16; /* *sgt */

        case GE:
          if (pattern1 (x1) != 0)
            return -1;
          return 17; /* *sge */

        case GTU:
          if (pattern2 (x1) != 0)
            return -1;
          return 18; /* *sgtu */

        case GEU:
          if (pattern2 (x1) != 0)
            return -1;
          return 19; /* *sgeu */

        case IF_THEN_ELSE:
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_CODE (x9) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x7 = XEXP (x2, 0);
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          switch (GET_CODE (x7))
            {
            case EQ:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 22; /* *beq */

            case NE:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 23; /* *bne */

            case GT:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 24; /* *bgt */

            case GE:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 25; /* *bge */

            case GTU:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 26; /* *bgtu */

            case GEU:
              x11 = XEXP (x7, 0);
              operands[0] = x11;
              if (!register_or_zero_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[1] = x12;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 27; /* *bgeu */

            default:
              return -1;
            }

        case CALL:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          if (!call_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          *pnum_clobbers = 1;
          return 29; /* *call_value */

        case PLUS:
          if (pattern1 (x1) != 0)
            return -1;
          return 34; /* addsi3 */

        case MINUS:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!register_or_zero_operand (operands[2], E_SImode))
            return -1;
          return 35; /* subsi3 */

        case MULT:
          if (pattern1 (x1) != 0
              || !
#line 726 "../../gcc/config/lm32/lm32.md"
(TARGET_MULTIPLY_ENABLED))
            return -1;
          return 36; /* mulsi3 */

        case UDIV:
          if (pattern3 (x1) != 0
              || !
#line 737 "../../gcc/config/lm32/lm32.md"
(TARGET_DIVIDE_ENABLED))
            return -1;
          return 37; /* udivsi3 */

        case UMOD:
          if (pattern3 (x1) != 0
              || !
#line 746 "../../gcc/config/lm32/lm32.md"
(TARGET_DIVIDE_ENABLED))
            return -1;
          return 38; /* umodsi3 */

        case NEG:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          return 39; /* negsi2 */

        case NOT:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              return 40; /* one_cmplsi2 */

            case IOR:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x11 = XEXP (x7, 0);
              operands[1] = x11;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[2] = x12;
              if (!register_or_L_operand (operands[2], E_SImode))
                return -1;
              return 44; /* *norsi3 */

            case XOR:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x11 = XEXP (x7, 0);
              operands[1] = x11;
              if (!register_or_zero_operand (operands[1], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[2] = x12;
              if (!register_or_L_operand (operands[2], E_SImode))
                return -1;
              return 45; /* *xnorsi3 */

            default:
              return -1;
            }

        case AND:
          if (pattern2 (x1) != 0)
            return -1;
          return 41; /* andsi3 */

        case IOR:
          if (pattern2 (x1) != 0)
            return -1;
          return 42; /* iorsi3 */

        case XOR:
          if (pattern2 (x1) != 0)
            return -1;
          return 43; /* xorsi3 */

        case ASHIFT:
          if (pattern2 (x1) != 0
              || !
#line 866 "../../gcc/config/lm32/lm32.md"
(TARGET_BARREL_SHIFT_ENABLED))
            return -1;
          return 46; /* *ashlsi3 */

        case ASHIFTRT:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (register_or_L_operand (operands[2], E_SImode)
              && 
#line 906 "../../gcc/config/lm32/lm32.md"
(TARGET_BARREL_SHIFT_ENABLED))
            return 47; /* *ashrsi3 */
          if (!constant_M_operand (operands[2], E_SImode)
              || !
#line 917 "../../gcc/config/lm32/lm32.md"
(!TARGET_BARREL_SHIFT_ENABLED))
            return -1;
          return 48; /* ashrsi3_1bit */

        case LSHIFTRT:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (register_or_L_operand (operands[2], E_SImode)
              && 
#line 955 "../../gcc/config/lm32/lm32.md"
(TARGET_BARREL_SHIFT_ENABLED))
            return 49; /* *lshrsi3 */
          if (!constant_M_operand (operands[2], E_SImode)
              || !
#line 966 "../../gcc/config/lm32/lm32.md"
(!TARGET_BARREL_SHIFT_ENABLED))
            return -1;
          return 50; /* lshrsi3_1bit */

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x13 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x13))
        {
        case CALL:
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XVECEXP (x1, 0, 1);
          if (pattern4 (x15) != 0)
            return -1;
          x16 = XEXP (x14, 0);
          operands[0] = x16;
          if (!call_operand (operands[0], E_SImode))
            return -1;
          x17 = XEXP (x13, 1);
          operands[1] = x17;
          return 28; /* *call */

        case SET:
          x17 = XEXP (x13, 1);
          switch (GET_CODE (x17))
            {
            case CALL:
              x18 = XEXP (x17, 0);
              if (GET_CODE (x18) != MEM
                  || GET_MODE (x18) != E_SImode)
                return -1;
              x15 = XVECEXP (x1, 0, 1);
              if (pattern4 (x15) != 0)
                return -1;
              x14 = XEXP (x13, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              x19 = XEXP (x18, 0);
              operands[1] = x19;
              if (!call_operand (operands[1], E_SImode))
                return -1;
              x20 = XEXP (x17, 1);
              operands[2] = x20;
              return 29; /* *call_value */

            case REG:
            case SUBREG:
              operands[0] = x17;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PC)
                return -1;
              x15 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x15) != USE)
                return -1;
              x21 = XEXP (x15, 0);
              if (GET_CODE (x21) != LABEL_REF)
                return -1;
              x22 = XEXP (x21, 0);
              operands[1] = x22;
              return 33; /* tablejumpsi */

            default:
              return -1;
            }

        case USE:
          x15 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x15) != RETURN)
            return -1;
          x14 = XEXP (x13, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 30; /* return_internal */

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x23 = XEXP (x3, 0);
      operands[0] = x23;
      if (!call_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      operands[1] = x2;
      *pnum_clobbers = 1;
      return 28; /* *call */

    case RETURN:
      if (!
#line 655 "../../gcc/config/lm32/lm32.md"
(reload_completed))
        return -1;
      return 31; /* *return */

    case SIMPLE_RETURN:
      return 32; /* *simple_return */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 51; /* nop */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x13 = XVECEXP (x1, 0, 0);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 52; /* blockage */

    default:
      return -1;
    }
}
