/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!equality_comparison_operator (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 34
      || GET_MODE (x2) != E_BImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      switch (pattern1 (x1))
        {
        case 0:
          return 2; /* addsi3 */

        case 1:
          if (!
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 7; /* addsf3 */

        case 2:
          if (!(
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 11; /* adddf3 */

        default:
          return -1;
        }

    case MULT:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 137 "../../gcc/config/or1k/or1k.md"
(!TARGET_SOFT_MUL))
            return -1;
          return 3; /* mulsi3 */

        case 1:
          if (!
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 9; /* mulsf3 */

        case 2:
          if (!(
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 13; /* muldf3 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern0 (x2, 
E_SImode) != 0
              || !
#line 147 "../../gcc/config/or1k/or1k.md"
(!TARGET_SOFT_DIV))
            return -1;
          return 4; /* divsi3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 10; /* divsf3 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !(
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 14; /* divdf3 */

        default:
          return -1;
        }

    case UDIV:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 155 "../../gcc/config/or1k/or1k.md"
(!TARGET_SOFT_DIV))
        return -1;
      return 5; /* udivsi3 */

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 6; /* subsi3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 8; /* subsf3 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !(
#line 186 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 12; /* subdf3 */

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SImode)
              || !
#line 195 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 15; /* floatsisf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_DImode)
              || !(
#line 195 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 16; /* floatdidf2 */

        default:
          return -1;
        }

    case FIX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 203 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 17; /* fix_truncsfsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DFmode)
              || !(
#line 203 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 18; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern2 (x1) != 0)
        return -1;
      return 19; /* ashlsi3 */

    case ASHIFTRT:
      if (pattern2 (x1) != 0)
        return -1;
      return 20; /* ashrsi3 */

    case LSHIFTRT:
      if (pattern2 (x1) != 0)
        return -1;
      return 21; /* lshrsi3 */

    case ROTATERT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!ror_reg_or_u6_operand (operands[2], E_SImode)
          || !
#line 231 "../../gcc/config/or1k/or1k.md"
(TARGET_ROR || TARGET_RORI))
        return -1;
      return 22; /* rotrsi3 */

    case AND:
      if (pattern3 (x1) != 0)
        return -1;
      return 23; /* andsi3 */

    case XOR:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_s16_operand (operands[2], E_SImode))
        return -1;
      return 24; /* xorsi3 */

    case IOR:
      if (pattern3 (x1) != 0)
        return -1;
      return 25; /* iorsi3 */

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (losum_ior_operand (operands[2], E_SImode))
        return 30; /* *movsi_lo_sum_iori */
      if (!losum_add_operand (operands[2], E_SImode))
        return -1;
      return 31; /* *movsi_lo_sum_addi */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case MEM:
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[0] = x3;
              operands[1] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (nonimmediate_operand (operands[0], E_QImode)
                      && input_operand (operands[1], E_QImode)
                      && 
#line 297 "../../gcc/config/or1k/or1k.md"
(register_operand (operands[0], QImode)
   || reg_or_0_operand (operands[1], QImode)))
                    return 26; /* *movqi_internal */
                  break;

                case E_HImode:
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && input_operand (operands[1], E_HImode)
                      && 
#line 297 "../../gcc/config/or1k/or1k.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)))
                    return 27; /* *movhi_internal */
                  break;

                case E_SImode:
                  if (nonimmediate_operand (operands[0], E_SImode)
                      && input_operand (operands[1], E_SImode)
                      && 
#line 297 "../../gcc/config/or1k/or1k.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)))
                    return 28; /* *movsi_internal */
                  break;

                default:
                  break;
                }
              break;

            case PC:
              operands[0] = x2;
              if (register_operand (operands[0], E_SImode))
                return 79; /* indirect_jump */
              break;

            default:
              break;
            }
          break;

        case HIGH:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (high_operand (operands[1], E_SImode))
                    return 29; /* movsi_high */
                }
            }
          break;

        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 78; /* jump */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      if (!general_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !
#line 351 "../../gcc/config/or1k/or1k.md"
(register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode)))
        return -1;
      return 32; /* *movdi */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_mem_operand (operands[1], E_QImode))
            return -1;
          return 33; /* zero_extendqisi2 */

        case E_HImode:
          if (!reg_or_mem_operand (operands[1], E_HImode))
            return -1;
          return 34; /* zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (reg_or_mem_operand (operands[1], E_QImode)
              && 
#line 397 "../../gcc/config/or1k/or1k.md"
(TARGET_SEXT))
            return 35; /* extendqisi2 */
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          return 37; /* *extendqisi2_mem */

        case E_HImode:
          if (reg_or_mem_operand (operands[1], E_HImode)
              && 
#line 397 "../../gcc/config/or1k/or1k.md"
(TARGET_SEXT))
            return 36; /* extendhisi2 */
          if (!memory_operand (operands[1], E_HImode))
            return -1;
          return 38; /* *extendhisi2_mem */

        default:
          return -1;
        }

    case LT:
      if (pattern4 (x1) != 0)
        return -1;
      if (reg_or_s16_operand (operands[1], E_SImode)
          && reg_or_0_operand (operands[0], E_SImode))
        return 41; /* *sf_insn */
      if (register_operand (operands[1], E_SFmode)
          && register_operand (operands[0], E_SFmode)
          && 
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
        return 51; /* *sf_fp_insn */
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[0], E_DFmode)
          || !(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 63; /* *sf_fp_insn */

    case LTU:
      if (pattern5 (x1) != 0)
        return -1;
      return 42; /* *sf_insn */

    case GT:
      if (pattern4 (x1) != 0)
        return -1;
      if (reg_or_s16_operand (operands[1], E_SImode)
          && reg_or_0_operand (operands[0], E_SImode))
        return 43; /* *sf_insn */
      if (register_operand (operands[1], E_SFmode)
          && register_operand (operands[0], E_SFmode)
          && 
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
        return 52; /* *sf_fp_insn */
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[0], E_DFmode)
          || !(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 64; /* *sf_fp_insn */

    case GTU:
      if (pattern5 (x1) != 0)
        return -1;
      return 44; /* *sf_insn */

    case GE:
      if (pattern4 (x1) != 0)
        return -1;
      if (reg_or_s16_operand (operands[1], E_SImode)
          && reg_or_0_operand (operands[0], E_SImode))
        return 45; /* *sf_insn */
      if (register_operand (operands[1], E_SFmode)
          && register_operand (operands[0], E_SFmode)
          && 
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
        return 53; /* *sf_fp_insn */
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[0], E_DFmode)
          || !(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 65; /* *sf_fp_insn */

    case LE:
      if (pattern4 (x1) != 0)
        return -1;
      if (reg_or_s16_operand (operands[1], E_SImode)
          && reg_or_0_operand (operands[0], E_SImode))
        return 46; /* *sf_insn */
      if (register_operand (operands[1], E_SFmode)
          && register_operand (operands[0], E_SFmode)
          && 
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
        return 54; /* *sf_fp_insn */
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[0], E_DFmode)
          || !(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 66; /* *sf_fp_insn */

    case GEU:
      if (pattern5 (x1) != 0)
        return -1;
      return 47; /* *sf_insn */

    case LEU:
      if (pattern5 (x1) != 0)
        return -1;
      return 48; /* *sf_insn */

    case UNEQ:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 55; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 67; /* *sf_fp_insn */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 56; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 68; /* *sf_fp_insn */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 57; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 69; /* *sf_fp_insn */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 58; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 70; /* *sf_fp_insn */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 59; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 71; /* *sf_fp_insn */

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 60; /* *sf_fp_insn */

        case 1:
          if (!(
#line 465 "../../gcc/config/or1k/or1k.md"
(TARGET_HARD_FLOAT) && 
#line 172 "../../gcc/config/or1k/or1k.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 72; /* *sf_fp_insn */

        default:
          return -1;
        }

    case NE:
    case EQ:
      return recog_1 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      if (!equality_comparison_operator (x4, E_VOIDmode)
          || pattern8 (x4) != 0)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x5;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          operands[3] = x4;
          switch (pattern12 (x2))
            {
            case 0:
              return 74; /* *cmovqi */

            case 1:
              return 75; /* *cmovhi */

            case 2:
              return 76; /* *cmovsi */

            default:
              return -1;
            }

        case LABEL_REF:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          operands[1] = x4;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          return 77; /* *cbranch */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 0:
          x8 = XVECEXP (x2, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 81; /* set_got_tmp */

        case 1:
          x8 = XVECEXP (x2, 0, 0);
          operands[1] = x8;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          return 85; /* load_locked_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 0:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_SImode)
            return -1;
          x8 = XVECEXP (x2, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 82; /* set_got */

        case 6:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x8 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          return 84; /* *msync */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!call_insn_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (pnum_clobbers != NULL
          && 
#line 994 "../../gcc/config/or1k/or1k.md"
(!SIBLING_CALL_P (insn)))
        {
          *pnum_clobbers = 1;
          return 89; /* *call_value */
        }
      if (!
#line 1004 "../../gcc/config/or1k/or1k.md"
(SIBLING_CALL_P (insn)))
        return -1;
      return 90; /* *sibcall_value */

    default:
      return -1;
    }
}
