/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      return 0;

    case ASHIFT:
      if (pattern21 (x4, 
E_SImode, 
LSHIFTRT, 
AND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XVECEXP (x1, 0, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern48 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x15))
    {
    case SET:
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern47 (x1, 
0, 
147) != 0)
        return -1;
      return 0;

    case CLOBBER:
      if (pattern47 (x1, 
1, 
0) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x1, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 33)
    return -1;
  return 0;
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_operand (operands[0], E_SImode)
          || !arith_reg_or_0_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!arith_reg_operand (operands[0], E_DImode)
          || !arith_reg_or_0_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode)
          || !not_p27_shift_count_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_HImode:
      if (!arith_reg_dest (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode
          || !arith_reg_operand (operands[1], E_HImode)
          || !const_int_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case GE:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case LSHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1
      || pattern120 (x1) != 0)
    return -1;
  return 0;
}

int
pattern127 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern133 (rtx x1, int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i2
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case CLOBBER:
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 147
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern159 (x5, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern159 (x5, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !treg_set_expr (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!arith_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 147
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 0
          || GET_MODE (x11) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern175 (x3, 
E_SImode); /* [-1, 0] */

        case E_QImode:
          if (pattern175 (x3, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_HImode:
          if (pattern175 (x3, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 0
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern176 (x3, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (pattern176 (x3, 
E_HImode) != 0)
            return -1;
          return 4;

        case E_SImode:
          if (pattern176 (x3, 
E_SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i3)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  return pattern198 (x5, 
i1); /* [-1, 0] */
}

int
pattern209 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern208 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern208 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern208 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case USE:
      res = pattern166 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode
          || GET_MODE (x4) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  return pattern114 (x3); /* [-1, 2] */
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  return pattern191 (x1); /* [-1, 2] */
}

int
pattern245 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern244 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern244 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern244 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case USE:
      res = pattern218 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern259 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern259 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern268 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern268 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !logical_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_arith_operand_1 (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern117 (x5, 
i1); /* [-1, 0] */
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != XOR
      || GET_MODE (x3) != E_SImode
      || pattern9 (x1) != 0)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[0] = x4;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[2] = x6;
      if (!
#line 1096 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) == 7 || INTVAL (operands[2]) == 15
       || INTVAL (operands[2]) == 23 || INTVAL (operands[2]) == 29
       || INTVAL (operands[2]) == 30 || INTVAL (operands[2]) == 31)))
        return -1;
      return 23; /* *cmp_div0s_7 */

    case XOR:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!
#line 1165 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) & 0xFFFFFFFF) == (1U << INTVAL (operands[3]))
   && (INTVAL (operands[3]) == 15
       || INTVAL (operands[3]) == 23 || INTVAL (operands[3]) == 29
       || INTVAL (operands[3]) == 30 || INTVAL (operands[3]) == 31)))
        return -1;
      return 25; /* *cmp_div0s_9 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XWINT (x3, 0))
    {
    case 31L:
      if (arith_reg_dest (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && treg_set_expr (operands[1], E_VOIDmode)
          && 
#line 3365 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 112; /* *rotcr */
      break;

    case 1L:
      if (pattern58 (x2, pnum_clobbers, 
E_DImode) == 0
          && 
#line 3752 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        {
          *pnum_clobbers = 1;
          return 126; /* ashldi3_k */
        }
      break;

    default:
      break;
    }
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode)
          || !p27_shift_count_operand (operands[2], E_SImode)
          || !
#line 3514 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 117; /* ashlsi3_k */

    case E_HImode:
      if (!arith_reg_dest (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !arith_reg_operand (operands[1], E_HImode)
          || !const_int_operand (operands[2], E_HImode))
        return -1;
      if (
#line 3680 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && satisfies_constraint_P27 (operands[2])))
        return 124; /* ashlhi3_k */
      if (pnum_clobbers == NULL
          || !
#line 3691 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      *pnum_clobbers = 1;
      return 125; /* *ashlhi3_n */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
      if (REGNO (x2) == 147
          && GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 1);
          operands[0] = x3;
          if (arith_reg_operand (operands[0], E_SImode)
              && 
#line 991 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !sh_in_recog_treg_set_expr ()))
            return 15; /* *negtstsi */
        }
      break;

    case MEM:
      res = recog_21 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (arith_reg_operand (operands[0], E_SImode)
          && 
#line 7157 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return 247; /* indirect_jump_compact */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      operands[0] = x2;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[1] = x4;
          switch (pattern81 (x3))
            {
            case 0:
              if (!
#line 4809 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 168; /* *extendqisi2_compact_reg */

            case 1:
              if (!
#line 4809 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 169; /* *extendhisi2_compact_reg */

            case 2:
              if (!
#line 4885 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 178; /* *extendqihi2_compact_reg */

            default:
              return -1;
            }

        case MEM:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == PLUS
              && GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              if (arith_reg_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  if (const_int_operand (operands[2], E_SImode))
                    {
                      switch (GET_MODE (x4))
                        {
                        case E_QImode:
                          if (
#line 4834 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A
   && sh_legitimate_index_p (QImode, operands[2], false, true)))
                            return 170; /* *extendqisi2_compact_mem_disp */
                          if (
#line 4848 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (QImode, operands[2], true, true)))
                            return 172; /* *extendqisi2_compact_mem_disp */
                          break;

                        case E_HImode:
                          if (
#line 4834 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A
   && sh_legitimate_index_p (HImode, operands[2], false, true)))
                            return 171; /* *extendhisi2_compact_mem_disp */
                          if (
#line 4848 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (HImode, operands[2], true, true)))
                            return 173; /* *extendhisi2_compact_mem_disp */
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
          operands[1] = x4;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (pre_dec_mem (operands[1], E_QImode)
                  && 
#line 4861 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
                return 174; /* *extendqisi2_predec */
              if (movsrc_no_disp_mem_operand (operands[1], E_QImode)
                  && 
#line 4873 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 176; /* *extendqisi2_compact_snd */
              break;

            case E_HImode:
              if (pre_dec_mem (operands[1], E_HImode)
                  && 
#line 4861 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
                return 175; /* *extendhisi2_predec */
              if (movsrc_no_disp_mem_operand (operands[1], E_HImode)
                  && 
#line 4873 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 177; /* *extendhisi2_compact_snd */
              if (pnum_clobbers != NULL
                  && mem_index_disp_operand (operands[1], E_HImode)
                  && 
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 184; /* *movhi_index_disp_load */
                }
              break;

            default:
              break;
            }
          if (GET_MODE (x5) != E_SImode)
            return -1;
          switch (GET_CODE (x5))
            {
            case PLUS:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 144
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  if (!gbr_displacement (operands[1], E_QImode)
                      || !
#line 7721 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 266; /* *movqi_gbr_load */

                case E_HImode:
                  if (!gbr_displacement (operands[1], E_HImode)
                      || !
#line 7721 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 267; /* *movhi_gbr_load */

                default:
                  return -1;
                }

            case REG:
              if (REGNO (x5) != 144)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_QImode:
                  if (!
#line 7728 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 268; /* *movqi_gbr_load */

                case E_HImode:
                  if (!
#line 7728 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 269; /* *movhi_gbr_load */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 150
          || GET_MODE (x3) != E_SFmode
          || GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_SFmode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != PRE_DEC
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 15
          || GET_MODE (x9) != E_SImode
          || !
#line 4909 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
        return -1;
      return 179; /* push_fpul */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (pattern134 (x5, 
MINUS, 
GTU) != 0)
    return -1;
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MINUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 147
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x5, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 147
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x8, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x6, 1);
  if (!rtx_equal_p (x13, operands[1])
      || !
#line 1961 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 53; /* subc */
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (arith_reg_operand (operands[1], E_SImode))
    {
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  switch (pattern224 (x8))
    {
    case 0:
      if (!
#line 3051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 105; /* *rotcr */

    case 1:
      if (!
#line 3431 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 116; /* *rotcr_neg_t */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      res = recog_55 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          if (pattern109 (x1, 
E_DImode) == 0
              && 
#line 4382 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 151; /* negdi2 */
          break;

        case USE:
          switch (pattern100 (x1))
            {
            case 0:
              if (
#line 9427 "../../gcc/config/sh/sh.md"
(TARGET_FPU_SH4_300))
                return 340; /* negsf2_fpscr */
              break;

            case 1:
              if (
#line 9734 "../../gcc/config/sh/sh.md"
(TARGET_FPU_SH4_300))
                return 355; /* negdf2_fpscr */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case ABS:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern33 (x6, 
147, 
CLOBBER) == 0)
        {
          switch (pattern136 (x4))
            {
            case 0:
              if (
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 156; /* *negabssi2 */
              break;

            case 1:
              if (
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 157; /* *negabsdi2 */
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (pattern89 (x6, 
147) != 0
      || GET_MODE (x4) != E_SImode)
    return -1;
  operands[1] = x5;
  if (!treg_set_expr (operands[1], E_VOIDmode)
      || !
#line 8406 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 296; /* mov_neg_si_t */
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 2:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 2)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          if (!const_int_operand (operands[1], E_VOIDmode)
              || !
#line 6379 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 219; /* indirect_jump_scratch */

        case 25:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!memory_operand (operands[0], E_SImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          return 400; /* stack_protect_set_si */

        case 33:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x9))
            {
            case PLUS:
              switch (pattern112 (x1))
                {
                case 0:
                  if (GET_MODE (x3) != E_QImode
                      || GET_MODE (x9) != E_QImode
                      || !atomic_arith_operand_1 (operands[1], E_QImode))
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_QImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 456; /* atomic_addqi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_QImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 466; /* atomic_addqi_hard_1 */

                case 1:
                  if (GET_MODE (x3) != E_HImode
                      || GET_MODE (x9) != E_HImode
                      || !atomic_arith_operand_1 (operands[1], E_HImode))
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_HImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 461; /* atomic_addhi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_HImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 471; /* atomic_addhi_hard_1 */

                case 2:
                  switch (pattern204 (x3))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 513; /* atomic_addqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 518; /* atomic_addhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 523; /* atomic_addsi_soft_tcb */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern112 (x1))
                {
                case 0:
                  if (GET_MODE (x3) != E_QImode
                      || GET_MODE (x9) != E_QImode
                      || !arith_reg_operand (operands[1], E_QImode))
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_QImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 457; /* atomic_subqi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_QImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 467; /* atomic_subqi_hard_1 */

                case 1:
                  if (GET_MODE (x3) != E_HImode
                      || GET_MODE (x9) != E_HImode
                      || !arith_reg_operand (operands[1], E_HImode))
                    return -1;
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_HImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 462; /* atomic_subhi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_HImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 472; /* atomic_subhi_hard_1 */

                case 2:
                  switch (pattern206 (x3))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 514; /* atomic_subqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 519; /* atomic_subhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 524; /* atomic_subsi_soft_tcb */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case IOR:
              switch (pattern115 (x1))
                {
                case 0:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_QImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 458; /* atomic_orqi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_QImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 468; /* atomic_orqi_hard_1 */

                case 1:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_HImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 463; /* atomic_orhi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_HImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 473; /* atomic_orhi_hard_1 */

                case 2:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 515; /* atomic_orqi_soft_tcb */

                case 3:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 520; /* atomic_orhi_soft_tcb */

                case 4:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 525; /* atomic_orsi_soft_tcb */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern115 (x1))
                {
                case 0:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_QImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 459; /* atomic_xorqi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_QImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 469; /* atomic_xorqi_hard_1 */

                case 1:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_HImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 464; /* atomic_xorhi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_HImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 474; /* atomic_xorhi_hard_1 */

                case 2:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 516; /* atomic_xorqi_soft_tcb */

                case 3:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 521; /* atomic_xorhi_soft_tcb */

                case 4:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 526; /* atomic_xorsi_soft_tcb */

                default:
                  return -1;
                }

            case AND:
              switch (pattern115 (x1))
                {
                case 0:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_QImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 460; /* atomic_andqi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_QImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 470; /* atomic_andqi_hard_1 */

                case 1:
                  x8 = XEXP (x2, 0);
                  operands[0] = x8;
                  if (atomic_mem_operand_1 (operands[0], E_HImode))
                    {
                      x10 = XEXP (x9, 0);
                      if (rtx_equal_p (x10, operands[0])
                          && 
#line 897 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 465; /* atomic_andhi_hard */
                        }
                    }
                  x11 = XEXP (x8, 0);
                  operands[0] = x11;
                  if (!arith_reg_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_HImode)
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0])
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 475; /* atomic_andhi_hard_1 */

                case 2:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 517; /* atomic_andqi_soft_tcb */

                case 3:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 522; /* atomic_andhi_soft_tcb */

                case 4:
                  if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 527; /* atomic_andsi_soft_tcb */

                default:
                  return -1;
                }

            case NOT:
              x10 = XEXP (x9, 0);
              switch (GET_CODE (x10))
                {
                case MEM:
                  x8 = XEXP (x2, 0);
                  if (GET_CODE (x8) == MEM)
                    {
                      res = recog_63 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                    }
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != USE)
                    return -1;
                  operands[0] = x8;
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (!gbr_displacement (operands[1], E_SImode)
                      || !rtx_equal_p (x10, operands[0]))
                    return -1;
                  switch (pattern194 (x3))
                    {
                    case 0:
                      if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 531; /* atomic_notqi_soft_tcb */

                    case 1:
                      if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 532; /* atomic_nothi_soft_tcb */

                    case 2:
                      if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 533; /* atomic_notsi_soft_tcb */

                    default:
                      return -1;
                    }

                case AND:
                  x12 = XEXP (x10, 0);
                  if (GET_CODE (x12) != MEM)
                    return -1;
                  x8 = XEXP (x2, 0);
                  if (GET_CODE (x8) != MEM)
                    return -1;
                  x13 = XEXP (x10, 1);
                  operands[1] = x13;
                  switch (pattern111 (x1))
                    {
                    case 0:
                      if (pattern216 (x3, 
E_QImode) != 0)
                        return -1;
                      operands[0] = x8;
                      if (atomic_mem_operand_1 (operands[0], E_QImode)
                          && rtx_equal_p (x12, operands[0])
                          && 
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 557; /* atomic_nandqi_hard */
                        }
                      x11 = XEXP (x8, 0);
                      operands[0] = x11;
                      if (!arith_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x12) != E_QImode)
                        return -1;
                      x14 = XEXP (x12, 0);
                      if (!rtx_equal_p (x14, operands[0])
                          || !
#line 1418 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      *pnum_clobbers = 3;
                      return 559; /* atomic_nandqi_hard_1 */

                    case 1:
                      if (pattern216 (x3, 
E_HImode) != 0)
                        return -1;
                      operands[0] = x8;
                      if (atomic_mem_operand_1 (operands[0], E_HImode)
                          && rtx_equal_p (x12, operands[0])
                          && 
#line 1394 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 558; /* atomic_nandhi_hard */
                        }
                      x11 = XEXP (x8, 0);
                      operands[0] = x11;
                      if (!arith_reg_operand (operands[0], E_SImode)
                          || GET_MODE (x12) != E_HImode)
                        return -1;
                      x14 = XEXP (x12, 0);
                      if (!rtx_equal_p (x14, operands[0])
                          || !
#line 1418 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      *pnum_clobbers = 3;
                      return 560; /* atomic_nandhi_hard_1 */

                    case 2:
                      switch (pattern217 (x3))
                        {
                        case 0:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          *pnum_clobbers = 2;
                          return 567; /* atomic_nandqi_soft_tcb */

                        case 1:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          *pnum_clobbers = 2;
                          return 568; /* atomic_nandhi_soft_tcb */

                        case 2:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          *pnum_clobbers = 2;
                          return 569; /* atomic_nandsi_soft_tcb */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pattern63 (x3) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      operands[1] = x15;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      x17 = XEXP (x16, 0);
      operands[2] = x17;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_SImode)
          || !
#line 7971 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 279; /* casesi_worker_1 */

    case 4:
      if (pattern63 (x3) != 0)
        return -1;
      x18 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x18) != LABEL_REF)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      operands[1] = x15;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x16 = XVECEXP (x3, 0, 2);
      x17 = XEXP (x16, 0);
      operands[2] = x17;
      x19 = XEXP (x18, 0);
      operands[3] = x19;
      x7 = XEXP (x4, 0);
      operands[4] = x7;
      if (!
#line 8007 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && reload_completed && flag_pic))
        return -1;
      return 280; /* casesi_worker_2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (general_movdst_operand (operands[0], E_DImode)
          && general_movsrc_operand (operands[1], E_DImode)
          && 
#line 5476 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed))
        return gen_split_117 (insn, operands);
      if (arith_reg_dest (operands[0], E_DImode)
          && gbr_address_mem (operands[1], E_DImode)
          && (
#line 7755 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 7757 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_139 (insn, operands);
      if (gbr_address_mem (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && (
#line 7773 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 7775 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_140 (insn, operands);
      if (register_operand (operands[0], E_DImode)
          && memory_operand (operands[1], E_DImode)
          && 
#line 7800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_144 (insn, operands);
      if (memory_operand (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7848 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_152 (insn, operands);
      break;

    case E_DFmode:
      if (general_movdst_operand (operands[0], E_DFmode)
          && general_movsrc_operand (operands[1], E_DFmode)
          && 
#line 5962 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed))
        return gen_split_126 (insn, operands);
      break;

    case E_QImode:
      if (register_operand (operands[0], E_QImode)
          && memory_operand (operands[1], E_QImode)
          && 
#line 7800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_141 (insn, operands);
      if (memory_operand (operands[0], E_QImode)
          && register_operand (operands[1], E_QImode)
          && 
#line 7848 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_149 (insn, operands);
      break;

    case E_HImode:
      if (register_operand (operands[0], E_HImode)
          && memory_operand (operands[1], E_HImode)
          && 
#line 7800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_142 (insn, operands);
      if (memory_operand (operands[0], E_HImode)
          && register_operand (operands[1], E_HImode)
          && 
#line 7848 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_150 (insn, operands);
      break;

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && memory_operand (operands[1], E_SImode)
          && 
#line 7800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_143 (insn, operands);
      if (memory_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 7848 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return gen_split_151 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode
      || GET_MODE (x2) != E_SImode)
    return NULL;
  switch (GET_CODE (x2))
    {
    case REG:
      if (REGNO (x2) != 147
          || !(
#line 8427 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 8429 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_163 (insn, operands);

    case SUBREG:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!arith_reg_operand (operands[0], E_SImode))
        return NULL;
      x7 = XEXP (x4, 2);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return NULL;
      switch (SUBREG_BYTE (x2))
        {
        case 0:
          if (!(
#line 10201 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32) && 
#line 10204 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 4:
          if (!(
#line 10214 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32) && 
#line 10217 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_191 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER
      || pattern26 (x1, 
E_SImode, 
147) != 0)
    return NULL;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_int_operand (operands[2], E_SImode))
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          x8 = XEXP (x3, 1);
          switch (pattern224 (x8))
            {
            case 0:
              if ((
#line 3051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3053 "../../gcc/config/sh/sh.md"
( 1)))
                return gen_split_64 (insn, operands);
              break;

            case 1:
              if ((
#line 3431 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3433 "../../gcc/config/sh/sh.md"
( 1)))
                return gen_split_76 (insn, operands);
              break;

            default:
              break;
            }
        }
      x7 = XEXP (x5, 0);
      if (!arith_reg_operand (x7, E_SImode))
        return NULL;
      switch (XWINT (x6, 0))
        {
        case 31L:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_SImode)
            return NULL;
          operands[3] = x7;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!arith_reg_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode)
              || !(
#line 3315 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3317 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_70 (insn, operands);

        case 1L:
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != -2147483648L)
            return NULL;
          operands[1] = x7;
          if (!(
#line 3397 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3399 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_74 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_SImode))
        {
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == AND
              && GET_MODE (x8) == E_SImode)
            {
              x10 = XEXP (x8, 1);
              if (x10 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x9 = XEXP (x8, 0);
                  operands[3] = x9;
                  if (arith_reg_or_t_reg_operand (operands[3], E_SImode)
                      && (
#line 3177 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3179 "../../gcc/config/sh/sh.md"
( 1)))
                    return gen_split_66 (insn, operands);
                }
            }
          operands[3] = x8;
          if (treg_set_expr (operands[3], E_VOIDmode)
              && (
#line 3262 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3264 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_67 (insn, operands);
        }
      x8 = XEXP (x3, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      switch (pattern229 (x8))
        {
        case 0:
          if (!(
#line 3296 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3298 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_69 (insn, operands);

        case 1:
          if (!(
#line 3335 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3337 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_71 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      switch (pattern192 (x3))
        {
        case 0:
          if (!(
#line 3281 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3283 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_68 (insn, operands);

        case 1:
          if (!(
#line 3380 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3382 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_73 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      operands[1] = x5;
      if (!negt_reg_shl31_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != LSHIFTRT
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!arith_reg_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode)
          || !(
#line 3414 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3416 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_75 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (register_operand (operands[1], E_VOIDmode)
      && register_operand (operands[0], E_VOIDmode))
    {
      x3 = PATTERN (peep2_next_insn (1));
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (register_operand (operands[2], E_VOIDmode))
        {
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (register_operand (operands[3], E_VOIDmode)
              && 
#line 10664 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && REGNO (operands[0]) == REGNO (operands[3])
   && REGNO (operands[1]) == REGNO (operands[2])
   && peep2_reg_dead_p (2, operands[3])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_18 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3
      || !arith_reg_dest (operands[1], E_SImode)
      || !arith_reg_dest (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return NULL;
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return NULL;
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return NULL;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!general_movdst_operand (operands[3], E_SImode))
    return NULL;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[0])
      || !
#line 10706 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (2, operands[1]) && peep2_reg_dead_p (3, operands[0])))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_26 (insn, operands);
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = peephole2_7 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count < 3)
    return NULL;
  operands[2] = x2;
  if (!arith_reg_dest (operands[2], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_VOIDmode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_VOIDmode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (pattern162 (x7) != 0
      || !
#line 10845 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5]))))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_33 (insn, operands);
}
