/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (!const_int_operand (x5, E_VOIDmode))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case SIGN_EXTRACT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 2);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      return pattern10 (); /* [-1, 2] */

    case ASHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 147
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 146
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x5, 0);
  operands[1] = x14;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x7, 0);
  operands[2] = x15;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  x16 = XEXP (x8, 0);
  operands[3] = x16;
  return 0;
}

int
pattern50 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 149
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern66 (rtx x1, unsigned int i1, rtx_code i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 5
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 4
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 2);
  if (GET_CODE (x4) != NEG
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != GE
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != MEM)
    return -1;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 147
          || GET_MODE (x10) != E_SImode)
        return -1;
      switch (GET_MODE (x6))
        {
        case E_QImode:
          if (GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode
              || !atomic_logical_operand_1 (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !atomic_logical_operand_1 (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case USE:
      operands[0] = x6;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!gbr_displacement (operands[2], E_SImode))
        return -1;
      res = pattern114 (x3);
      if (res >= 0)
        return res + 2; /* [2, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern135 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern135 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET
      || pattern142 (x4) != 0)
    return -1;
  return 0;
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      switch (GET_CODE (operands[1]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[1], E_VOIDmode)
              || GET_MODE (x1) != E_SImode)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_QImode:
              if (!arith_reg_operand (operands[0], E_QImode))
                return -1;
              return 0;

            case E_HImode:
              if (!arith_reg_operand (operands[0], E_HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          if (!arith_reg_operand (operands[1], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !arith_reg_operand (operands[0], E_SImode))
            return -1;
          switch (GET_MODE (x1))
            {
            case E_QImode:
              return 2;

            case E_HImode:
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (pattern149 (x1, 
E_QImode) != 0)
        return -1;
      return 4;

    case 2:
      if (pattern149 (x1, 
E_HImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern171 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !atomic_mem_operand_1 (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 147
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 0
          || GET_MODE (x11) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern178 (x3, 
E_SImode); /* [-1, 0] */

        case E_QImode:
          if (pattern178 (x3, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_HImode:
          if (pattern178 (x3, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 0
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern179 (x3, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (pattern179 (x3, 
E_HImode) != 0)
            return -1;
          return 4;

        case E_SImode:
          if (pattern179 (x3, 
E_SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arith_reg_dest (operands[0], E_DImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!arith_reg_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !arith_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern113 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern113 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 5
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i5)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i4
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != i3
      || GET_MODE (x11) != i2)
    return -1;
  x12 = XVECEXP (x1, 0, 4);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != i1)
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  return pattern189 (x1); /* [-1, 2] */
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_arith_operand_1 (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern251 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern251 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !atomic_arith_operand_1 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !atomic_arith_operand_1 (operands[1], i1))
    return -1;
  return 0;
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      return pattern282 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (pattern282 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (pattern282 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 3:
          if (pattern18 (x1, 
146) != 0
              || !register_operand (operands[0], E_SImode)
              || !
#line 2177 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && check_use_sfunc_addr (insn, operands[0])))
            return -1;
          return 61; /* use_sfunc_addr */

        case 22:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!general_movdst_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 5278 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 191; /* load_ra */

        case 2:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!const_int_operand (operands[0], E_VOIDmode)
              || !
#line 6365 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 218; /* block_branch_redirect */

        case 0:
          if (pattern19 (x1, 
0) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) == LABEL_REF)
            {
              x5 = XEXP (x4, 0);
              operands[0] = x5;
              if (
#line 7254 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 252; /* mova */
            }
          operands[0] = x4;
          if (!immediate_operand (operands[0], E_VOIDmode)
              || !
#line 7263 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 253; /* mova_const */

        default:
          return -1;
        }

    case 3:
      switch (XINT (x2, 1))
        {
        case 2:
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_SImode)
              || !
#line 6390 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 220; /* stuff_delay_slot */

        case 1:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 0
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!
#line 7971 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* casesi_worker_1 */

        default:
          return -1;
        }

    case 2:
      if (XINT (x2, 1) != 24
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 12
          || GET_MODE (x6) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 7339 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 254; /* chk_guard_add */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == E_SFmode)
    {
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) == POST_INC
          && pattern50 (x3, 
15) == 0)
        {
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 150
              && GET_MODE (x4) == E_SFmode
              && 
#line 4931 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return 180; /* pop_fpul */
        }
    }
  operands[1] = x2;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers != NULL
          && arith_reg_dest (operands[0], E_SImode)
          && mem_index_disp_operand (operands[1], E_SImode)
          && 
#line 5008 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 183; /* *movsi_index_disp_load */
        }
      break;

    case E_QImode:
      if (arith_reg_dest (operands[0], E_QImode)
          && pre_dec_mem (operands[1], E_QImode)
          && 
#line 5354 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 194; /* *movqi_load_predec */
      break;

    case E_HImode:
      if (arith_reg_dest (operands[0], E_HImode)
          && pre_dec_mem (operands[1], E_HImode)
          && 
#line 5354 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 195; /* *movhi_load_predec */
      break;

    default:
      break;
    }
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!arith_reg_dest (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      if (
#line 5396 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A
   && sh_legitimate_index_p (QImode, operands[2], false, true)))
        return 204; /* *movqi_load_mem_disp04 */
      if (!
#line 5409 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (QImode, operands[2], true, true)))
        return -1;
      return 206; /* *movqi_load_mem_disp12 */

    case E_HImode:
      if (!arith_reg_dest (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      if (
#line 5396 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A
   && sh_legitimate_index_p (HImode, operands[2], false, true)))
        return 205; /* *movhi_load_mem_disp04 */
      if (!
#line 5409 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (HImode, operands[2], true, true)))
        return -1;
      return 207; /* *movhi_load_mem_disp12 */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (arith_reg_or_0_operand (operands[2], E_SImode)
      && arith_reg_operand (operands[1], E_SImode))
    {
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (treg_set_expr (operands[3], E_VOIDmode)
          && 
#line 1581 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 38; /* *addc */
        }
    }
  if (!arith_reg_operand (operands[2], E_SImode)
      || !treg_set_expr (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!arith_reg_operand (operands[3], E_SImode)
      || !
#line 1621 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 39; /* *addc */
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!treg_set_expr (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!arith_reg_operand (operands[3], E_SImode)
          || !
#line 1766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* *addc_negreg_t */

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!arith_reg_dest (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !arith_reg_operand (operands[1], E_DImode)
              || !arith_reg_operand (operands[2], E_DImode)
              || !
#line 1937 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 52; /* subdi3 */

        case E_SImode:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arith_reg_operand (operands[1], E_SImode)
              || !treg_set_expr_not_const01 (operands[2], E_VOIDmode)
              || !
#line 2060 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 57; /* *subc */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (treg_set_expr (operands[3], E_VOIDmode)
          && arith_reg_or_0_operand (operands[2], E_SImode)
          && 
#line 1976 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 54; /* *subc */
        }
      if (!arith_reg_operand (operands[3], E_SImode)
          || !treg_set_expr (operands[2], E_VOIDmode)
          || !
#line 2017 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 55; /* *subc */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XEXP (x5, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x8) != SIGN_EXTEND)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 148
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[0] = x10;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      switch (pattern234 (x1))
        {
        case 0:
          if (!
#line 2579 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return -1;
          return 80; /* mulsidi3_i */

        case 1:
          if (!
#line 2673 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return -1;
          return 84; /* smulsi3_highpart_i */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_CODE (x8) != ZERO_EXTEND)
        return -1;
      x10 = XEXP (x7, 0);
      if (!arith_reg_operand (x10, E_SImode))
        return -1;
      operands[0] = x10;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) == REG
          && REGNO (x9) == 148
          && GET_MODE (x9) == E_SImode)
        {
          switch (pattern234 (x1))
            {
            case 0:
              if (
#line 2627 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return 82; /* umulsidi3_i */
              break;

            case 1:
              if (
#line 2705 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return 86; /* umulsi3_highpart_i */
              break;

            default:
              break;
            }
        }
      operands[1] = x10;
      x11 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x11) != CLOBBER
          || pattern26 (x1, 
E_SImode, 
149) != 0)
        return -1;
      x12 = XEXP (x8, 0);
      operands[2] = x12;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 2718 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
        return -1;
      return 87; /* umulsi3_highpart */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
      if (pattern90 (x3) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern89 (x5, 
147) != 0
          || pattern202 (x2) != 0
          || !
#line 4554 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 159; /* negdi_cond */

    case NE:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != PC)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern156 (x5, 
-1, 
PLUS) != 0)
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!arith_reg_dest (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      x12 = XEXP (x5, 0);
      operands[0] = x12;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[2])
          || !
#line 6425 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        return -1;
      *pnum_clobbers = 1;
      return 221; /* doloop_end_split */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT
      || pattern88 (x1, 
SET, 
147) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!arith_reg_dest (operands[1], E_SImode)
          || XWINT (x4, 0) != 1L)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[1])
          || !
#line 7238 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        return -1;
      return 250; /* dect */

    case MEM:
      if (GET_MODE (x5) != E_QImode
          || XWINT (x4, 0) != 0L)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern42 (x6) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      x7 = XEXP (x6, 1);
      x13 = XVECEXP (x7, 0, 0);
      switch (GET_CODE (x13))
        {
        case CONST_INT:
          if (XWINT (x13, 0) != 128L
              || !
#line 2171 "../../gcc/config/sh/sync.md"
(TARGET_ENABLE_TAS))
            return -1;
          return 669; /* tasb */

        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x13;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          if (
#line 2184 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA && !TARGET_ENABLE_TAS))
            {
              *pnum_clobbers = 3;
              return 670; /* atomic_test_and_set_soft_gusa */
            }
          if (
#line 2229 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK && !TARGET_ENABLE_TAS))
            {
              *pnum_clobbers = 2;
              return 672; /* atomic_test_and_set_soft_imask */
            }
          if (!
#line 2252 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && !TARGET_ENABLE_TAS))
            return -1;
          *pnum_clobbers = 4;
          return 673; /* atomic_test_and_set_hard */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (pattern64 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 14)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != MEM)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (pattern140 (x8, 
147, 
15) != 0)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  x12 = XVECEXP (x3, 0, 0);
  switch (GET_MODE (x12))
    {
    case E_SImode:
      operands[1] = x12;
      if (!atomic_mem_operand_0 (operands[1], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !rtx_equal_p (x7, operands[1]))
        return -1;
      if (arith_operand (operands[2], E_SImode)
          && arith_operand (operands[3], E_SImode)
          && 
#line 279 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
        {
          *pnum_clobbers = 1;
          return 402; /* atomic_compare_and_swapsi_hard */
        }
      if (!arith_reg_operand (operands[2], E_SImode)
          || !arith_reg_operand (operands[3], E_SImode))
        return -1;
      if (
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 3;
          return 409; /* atomic_compare_and_swapsi_soft_gusa */
        }
      if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 2;
      return 415; /* atomic_compare_and_swapsi_soft_imask */

    case E_QImode:
      if (!arith_reg_operand (operands[2], E_QImode)
          || !arith_reg_operand (operands[3], E_QImode)
          || GET_MODE (x5) != E_QImode)
        return -1;
      operands[1] = x12;
      if (atomic_mem_operand_0 (operands[1], E_QImode)
          && rtx_equal_p (x7, operands[1])
          && 
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 403; /* atomic_compare_and_swapqi_hard */
        }
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      if (arith_reg_operand (operands[1], E_SImode)
          && GET_MODE (x7) == E_QImode)
        {
          x14 = XEXP (x7, 0);
          if (rtx_equal_p (x14, operands[1])
              && 
#line 356 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            {
              *pnum_clobbers = 4;
              return 405; /* atomic_compare_and_swapqi_hard_1 */
            }
        }
      operands[1] = x12;
      if (!atomic_mem_operand_0 (operands[1], E_QImode)
          || !rtx_equal_p (x7, operands[1]))
        return -1;
      if (
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 3;
          return 407; /* atomic_compare_and_swapqi_soft_gusa */
        }
      if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 2;
      return 413; /* atomic_compare_and_swapqi_soft_imask */

    case E_HImode:
      if (!arith_reg_operand (operands[2], E_HImode)
          || !arith_reg_operand (operands[3], E_HImode)
          || GET_MODE (x5) != E_HImode)
        return -1;
      operands[1] = x12;
      if (atomic_mem_operand_0 (operands[1], E_HImode)
          && rtx_equal_p (x7, operands[1])
          && 
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 404; /* atomic_compare_and_swaphi_hard */
        }
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      if (arith_reg_operand (operands[1], E_SImode)
          && GET_MODE (x7) == E_HImode)
        {
          x14 = XEXP (x7, 0);
          if (rtx_equal_p (x14, operands[1])
              && 
#line 356 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            {
              *pnum_clobbers = 4;
              return 406; /* atomic_compare_and_swaphi_hard_1 */
            }
        }
      operands[1] = x12;
      if (!atomic_mem_operand_0 (operands[1], E_HImode)
          || !rtx_equal_p (x7, operands[1]))
        return -1;
      if (
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 3;
          return 408; /* atomic_compare_and_swaphi_soft_gusa */
        }
      if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 2;
      return 414; /* atomic_compare_and_swaphi_soft_imask */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MULT:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern126 (x1, 
SIGN_EXTEND) != 0
              || !
#line 2599 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
            return -1;
          return 81; /* mulsidi3_compact */

        case ZERO_EXTEND:
          if (pattern126 (x1, 
ZERO_EXTEND) != 0
              || !
#line 2647 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
            return -1;
          return 83; /* umulsidi3_compact */

        case REG:
        case SUBREG:
          operands[1] = x7;
          if (REGNO (x5) != 155)
            return -1;
          switch (pattern160 (x1))
            {
            case 0:
              if (!
#line 9241 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
                return -1;
              return 330; /* mulsf3_i */

            case 1:
              if (!
#line 9604 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
                return -1;
              return 348; /* muldf3_i */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      if (pattern27 (x1) != 0
          || !
#line 2687 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
        return -1;
      return 85; /* smulsi3_highpart */

    case ASHIFT:
      if (pattern28 (x1, pnum_clobbers) != 0
          || !
#line 3565 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_DYNSHIFT))
        return -1;
      *pnum_clobbers = 2;
      return 119; /* ashlsi3_d_call */

    case LSHIFTRT:
      if (pattern28 (x1, pnum_clobbers) != 0
          || !
#line 4014 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_DYNSHIFT))
        return -1;
      *pnum_clobbers = 2;
      return 137; /* lshrsi3_d_call */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      return recog_70 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      if (pattern29 (x1) != 0
          || !
#line 6425 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        return -1;
      return 221; /* doloop_end_split */

    case CALL:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          switch (REGNO (x5))
            {
            case 154:
              x10 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x10))
                {
                case CLOBBER:
                  x11 = XEXP (x10, 0);
                  if (pattern207 (x11, 
146) != 0
                      || !
#line 6591 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
                    return -1;
                  return 229; /* call_valuei */

                case RETURN:
                  if (!register_operand (operands[1], E_SImode)
                      || !
#line 6973 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
                    return -1;
                  return 241; /* sibcall_valuei */

                default:
                  return -1;
                }

            case 151:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != USE)
                return -1;
              x11 = XEXP (x10, 0);
              if (pattern207 (x11, 
12) != 0
                  || !
#line 6612 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
                return -1;
              *pnum_clobbers = 1;
              return 230; /* call_valuei_fdpic */

            default:
              return -1;
            }

        case SYMBOL_REF:
          if (pnum_clobbers == NULL
              || !symbol_ref_operand (operands[1], E_SImode)
              || REGNO (x5) != 154)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != USE)
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (scratch_operand (operands[3], E_VOIDmode)
              && 
#line 6636 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh2a_is_function_vector_call (operands[1])))
            {
              *pnum_clobbers = 1;
              return 231; /* call_valuei_tbr_rel */
            }
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 12
              || GET_MODE (x11) != E_SImode
              || !
#line 6679 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return -1;
          *pnum_clobbers = 2;
          return 233; /* call_value_pcrel */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_75 (x1, insn, pnum_clobbers);

    case XOR:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case NE:
        case EQ:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[1] = x7;
          if (!t_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (pattern145 (x1))
            {
            case 0:
              if (!
#line 8245 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 290; /* movrt_negc */

            case 1:
              if (!
#line 8266 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A))
                return -1;
              return 291; /* *movrt_negc */

            default:
              return -1;
            }

        case MEM:
          x4 = XVECEXP (x1, 0, 1);
          if (pattern16 (x4, 
XOR) != 0)
            return -1;
          switch (pattern71 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 1620 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 576; /* atomic_xor_fetchsi_hard */

            case 1:
              operands[1] = x7;
              if (atomic_mem_operand_1 (operands[1], E_QImode))
                {
                  x12 = XEXP (x4, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  x14 = XEXP (x13, 0);
                  if (rtx_equal_p (x14, operands[1]))
                    {
                      x5 = XEXP (x4, 0);
                      if (rtx_equal_p (x5, operands[1])
                          && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 582; /* atomic_xor_fetchqi_hard */
                        }
                    }
                }
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (pattern275 (x4, 
E_QImode) != 0
                  || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 592; /* atomic_xor_fetchqi_hard_1 */

            case 2:
              operands[1] = x7;
              if (atomic_mem_operand_1 (operands[1], E_HImode))
                {
                  x12 = XEXP (x4, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  x14 = XEXP (x13, 0);
                  if (rtx_equal_p (x14, operands[1]))
                    {
                      x5 = XEXP (x4, 0);
                      if (rtx_equal_p (x5, operands[1])
                          && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 587; /* atomic_xor_fetchhi_hard */
                        }
                    }
                }
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (pattern275 (x4, 
E_HImode) != 0
                  || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 597; /* atomic_xor_fetchhi_hard_1 */

            case 3:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 640; /* atomic_xor_fetchqi_soft_imask */

            case 4:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 645; /* atomic_xor_fetchhi_soft_imask */

            case 5:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 650; /* atomic_xor_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_73 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_74 (x1, insn, pnum_clobbers);

    case FMA:
      if (GET_MODE (x3) != E_SFmode
          || pattern65 (x1, 
E_SFmode) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fp_arith_reg_operand (operands[1], E_SFmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!fp_arith_reg_operand (operands[2], E_SFmode))
        return -1;
      x15 = XEXP (x3, 2);
      operands[3] = x15;
      if (!fp_arith_reg_operand (operands[3], E_SFmode)
          || !
#line 9265 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
        return -1;
      return 331; /* fmasf4_i */

    case DIV:
      if (pattern30 (x1) != 0)
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern159 (x3, 
E_SFmode) != 0
              || !
#line 9312 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return -1;
          return 333; /* divsf3_i */

        case E_DFmode:
          if (pattern159 (x3, 
E_DFmode) != 0
              || !
#line 9625 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 349; /* divdf3_i */

        default:
          return -1;
        }

    case FLOAT:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER
          || pattern66 (x1, 
154, 
USE, 
155) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fpul_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fp_arith_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 9331 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return -1;
          return 334; /* floatsisf2_i4 */

        case E_DFmode:
          if (!fp_arith_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 9644 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 350; /* floatsidf2_i */

        default:
          return -1;
        }

    case FIX:
      if (pattern31 (x1, 
E_SImode) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fp_arith_reg_operand (operands[1], E_SFmode)
              || !
#line 9350 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return -1;
          return 335; /* fix_truncsfsi2_i4 */

        case E_DFmode:
          if (!fp_arith_reg_operand (operands[1], E_DFmode)
              || !
#line 9663 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 351; /* fix_truncdfsi2_i */

        default:
          return -1;
        }

    case GT:
      if (GET_MODE (x3) != E_SImode
          || pattern68 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x3, 1);
      switch (pattern228 (x9))
        {
        case 0:
          if (!
#line 9361 "../../gcc/config/sh/sh.md"
(TARGET_SH2E || TARGET_SH4 || TARGET_SH2A_SINGLE))
            return -1;
          return 336; /* cmpgtsf_t */

        case 1:
          if (!
#line 9675 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 352; /* cmpgtdf_t */

        default:
          return -1;
        }

    case EQ:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 147
          || GET_MODE (x6) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x10) != USE)
        return -1;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[0] = x7;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern33 (x4, 
155, 
CLOBBER) != 0)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 154
              || GET_MODE (x11) != E_SImode)
            return -1;
          x9 = XEXP (x3, 1);
          switch (pattern228 (x9))
            {
            case 0:
              if (!
#line 9372 "../../gcc/config/sh/sh.md"
(TARGET_SH2E || TARGET_SH4 || TARGET_SH2A_SINGLE))
                return -1;
              return 337; /* cmpeqsf_t */

            case 1:
              if (!
#line 9686 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
                return -1;
              return 353; /* cmpeqdf_t */

            default:
              return -1;
            }

        case MEM:
          if (pnum_clobbers == NULL
              || GET_MODE (x7) != E_QImode)
            return -1;
          x9 = XEXP (x3, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET
              || pattern197 (x1) != 0)
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!gbr_displacement (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          x16 = XEXP (x5, 0);
          if (!rtx_equal_p (x16, operands[0])
              || !
#line 2207 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB && !TARGET_ENABLE_TAS))
            return -1;
          *pnum_clobbers = 3;
          return 671; /* atomic_test_and_set_soft_tcb */

        default:
          return -1;
        }

    case IOR:
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 147
              || GET_MODE (x7) != E_SImode)
            return -1;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != EQ
              || GET_MODE (x9) != E_SImode
              || pattern68 (x1) != 0
              || GET_MODE (x3) != E_SImode)
            return -1;
          x17 = XEXP (x9, 0);
          operands[0] = x17;
          x18 = XEXP (x9, 1);
          operands[1] = x18;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!fp_arith_reg_operand (operands[0], E_SFmode)
                  || !fp_arith_reg_operand (operands[1], E_SFmode)
                  || !
#line 9384 "../../gcc/config/sh/sh.md"
(TARGET_IEEE && TARGET_SH2E))
                return -1;
              return 338; /* ieee_ccmpeqsf_t */

            case E_DFmode:
              if (!fp_arith_reg_operand (operands[0], E_DFmode)
                  || !fp_arith_reg_operand (operands[1], E_DFmode)
                  || !
#line 9698 "../../gcc/config/sh/sh.md"
(TARGET_IEEE && TARGET_FPU_DOUBLE))
                return -1;
              return 354; /* *ieee_ccmpeqdf_t */

            default:
              return -1;
            }

        case MEM:
          switch (pattern72 (x1, pnum_clobbers, 
IOR))
            {
            case 0:
              if (!
#line 1620 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 575; /* atomic_or_fetchsi_hard */

            case 1:
              operands[1] = x7;
              if (atomic_mem_operand_1 (operands[1], E_QImode))
                {
                  x4 = XVECEXP (x1, 0, 1);
                  x12 = XEXP (x4, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  x14 = XEXP (x13, 0);
                  if (rtx_equal_p (x14, operands[1]))
                    {
                      x5 = XEXP (x4, 0);
                      if (rtx_equal_p (x5, operands[1])
                          && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 581; /* atomic_or_fetchqi_hard */
                        }
                    }
                }
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern275 (x4, 
E_QImode) != 0
                  || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 591; /* atomic_or_fetchqi_hard_1 */

            case 2:
              operands[1] = x7;
              if (atomic_mem_operand_1 (operands[1], E_HImode))
                {
                  x4 = XVECEXP (x1, 0, 1);
                  x12 = XEXP (x4, 1);
                  x13 = XVECEXP (x12, 0, 0);
                  x14 = XEXP (x13, 0);
                  if (rtx_equal_p (x14, operands[1]))
                    {
                      x5 = XEXP (x4, 0);
                      if (rtx_equal_p (x5, operands[1])
                          && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        {
                          *pnum_clobbers = 1;
                          return 586; /* atomic_or_fetchhi_hard */
                        }
                    }
                }
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern275 (x4, 
E_HImode) != 0
                  || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 596; /* atomic_or_fetchhi_hard_1 */

            case 3:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 639; /* atomic_or_fetchqi_soft_imask */

            case 4:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 644; /* atomic_or_fetchhi_soft_imask */

            case 5:
              if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 649; /* atomic_or_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      if (pattern30 (x1) != 0)
        return -1;
      switch (pattern99 (x3))
        {
        case 0:
          if (!
#line 9446 "../../gcc/config/sh/sh.md"
(TARGET_SH3E))
            return -1;
          return 341; /* sqrtsf2_i */

        case 1:
          if (!
#line 9760 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 357; /* sqrtdf2_i */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pattern32 (x1) != 0
          || !
#line 9497 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && TARGET_FSCA))
        return -1;
      return 343; /* fsca */

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_DFmode
          || pattern65 (x1, 
E_DFmode) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fpul_operand (operands[1], E_SFmode)
          || !
#line 9807 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
        return -1;
      return 360; /* extendsfdf2_i4 */

    case FLOAT_TRUNCATE:
      if (pattern31 (x1, 
E_SFmode) != 0)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fp_arith_reg_operand (operands[1], E_DFmode)
          || !
#line 9826 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
        return -1;
      return 361; /* truncdfsf2_i4 */

    case UNSPEC_VOLATILE:
      return recog_72 (x1, insn, pnum_clobbers);

    case AND:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM)
        return -1;
      switch (pattern72 (x1, pnum_clobbers, 
AND))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
            return -1;
          return 577; /* atomic_and_fetchsi_hard */

        case 1:
          operands[1] = x7;
          if (atomic_mem_operand_1 (operands[1], E_QImode))
            {
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x14 = XEXP (x13, 0);
              if (rtx_equal_p (x14, operands[1]))
                {
                  x5 = XEXP (x4, 0);
                  if (rtx_equal_p (x5, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 583; /* atomic_and_fetchqi_hard */
                    }
                }
            }
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern275 (x4, 
E_QImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 593; /* atomic_and_fetchqi_hard_1 */

        case 2:
          operands[1] = x7;
          if (atomic_mem_operand_1 (operands[1], E_HImode))
            {
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x14 = XEXP (x13, 0);
              if (rtx_equal_p (x14, operands[1]))
                {
                  x5 = XEXP (x4, 0);
                  if (rtx_equal_p (x5, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 588; /* atomic_and_fetchhi_hard */
                    }
                }
            }
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern275 (x4, 
E_HImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 598; /* atomic_and_fetchhi_hard_1 */

        case 3:
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          return 641; /* atomic_and_fetchqi_soft_imask */

        case 4:
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          return 646; /* atomic_and_fetchhi_soft_imask */

        case 5:
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          return 651; /* atomic_and_fetchsi_soft_imask */

        default:
          return -1;
        }

    case NOT:
      return recog_71 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GE:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      switch (pattern6 (x1))
        {
        case 0:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!arith_reg_operand (operands[0], E_SImode)
              || !
#line 935 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p () && optimize
   && !sh_in_recog_treg_set_expr ()))
            return NULL;
          return gen_split_13 (insn, operands);

        case 1:
          x4 = XEXP (x2, 0);
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          if (!arith_reg_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (!arith_reg_operand (operands[1], E_SImode)
              || !(
#line 1053 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1055 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_17 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode
          || pattern9 (x1) != 0)
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case XOR:
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
            case SIGN_EXTEND:
              operands[0] = x5;
              x6 = XEXP (x4, 1);
              operands[1] = x6;
              x7 = XEXP (x2, 2);
              operands[2] = x7;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                case SIGN_EXTEND:
                  if (!arith_reg_operand (operands[1], E_SImode)
                      || GET_MODE (x4) != E_SImode
                      || !arith_reg_operand (operands[0], E_SImode)
                      || !(
#line 1096 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) == 7 || INTVAL (operands[2]) == 15
       || INTVAL (operands[2]) == 23 || INTVAL (operands[2]) == 29
       || INTVAL (operands[2]) == 30 || INTVAL (operands[2]) == 31)) && 
#line 1101 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_20 (insn, operands);

                case CONST_INT:
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return NULL;
                  switch (pattern169 (x4))
                    {
                    case 0:
                      if (!(
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))) && 
#line 10032 "../../gcc/config/sh/sh.md"
( 1)))
                        return NULL;
                      return gen_split_175 (insn, operands);

                    case 1:
                      if (!(
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))) && 
#line 10032 "../../gcc/config/sh/sh.md"
( 1)))
                        return NULL;
                      return gen_split_176 (insn, operands);

                    case 2:
                      if (!(
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))) && 
#line 10032 "../../gcc/config/sh/sh.md"
( 1)))
                        return NULL;
                      return gen_split_177 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case XOR:
              if (GET_MODE (x5) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return NULL;
              x8 = XEXP (x5, 0);
              operands[0] = x8;
              if (!arith_reg_operand (operands[0], E_SImode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[1] = x9;
              if (!arith_reg_operand (operands[1], E_SImode))
                return NULL;
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (!const_int_operand (operands[2], E_VOIDmode))
                return NULL;
              x7 = XEXP (x2, 2);
              operands[3] = x7;
              if (!(
#line 1165 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) & 0xFFFFFFFF) == (1U << INTVAL (operands[3]))
   && (INTVAL (operands[3]) == 15
       || INTVAL (operands[3]) == 23 || INTVAL (operands[3]) == 29
       || INTVAL (operands[3]) == 30 || INTVAL (operands[3]) == 31)) && 
#line 1171 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_22 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          switch (pattern123 (x2))
            {
            case 0:
              if (!(
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))) && 
#line 10176 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_187 (insn, operands);

            case 1:
              if (!(
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))) && 
#line 10176 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_188 (insn, operands);

            case 2:
              if (!(
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))) && 
#line 10176 "../../gcc/config/sh/sh.md"
( 1)))
                return NULL;
              return gen_split_189 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case GEU:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x10 = XEXP (x1, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 147
          || GET_MODE (x10) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!arith_reg_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      if (!arith_reg_or_0_operand (operands[1], E_SImode)
          || !(
#line 1280 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 1282 "../../gcc/config/sh/sh.md"
( satisfies_constraint_Z (operands[1]))))
        return NULL;
      return gen_split_28 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      if (GET_MODE (x2) == E_SImode)
        {
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      operands[3] = x2;
      if (pattern7 (x1) != 0
          || !(
#line 2827 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2829 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_61 (insn, operands);

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (!arith_reg_operand (x4, E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) == 31L)
            {
              x10 = XEXP (x1, 0);
              if (GET_CODE (x10) == REG
                  && REGNO (x10) == 147
                  && GET_MODE (x10) == E_SImode)
                {
                  operands[0] = x4;
                  if ((
#line 2863 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2865 "../../gcc/config/sh/sh.md"
( 1)))
                    return gen_split_63 (insn, operands);
                }
            }
          operands[2] = x3;
          if (!not_p27_rshift_count_operand (operands[2], E_SImode))
            return NULL;
          x10 = XEXP (x1, 0);
          operands[0] = x10;
          if (!arith_reg_dest (operands[0], E_SImode))
            return NULL;
          operands[1] = x4;
          if (!(
#line 4025 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! sh_lshrsi_clobbers_t_reg_p (operands[2])) && 
#line 4027 "../../gcc/config/sh/sh.md"
( (reload_completed
       || (sh_dynamicalize_shift_p (operands[2]) && can_create_pseudo_p ())))))
            return NULL;
          return gen_split_89 (insn, operands);

        case NEG:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x10 = XEXP (x1, 0);
          operands[0] = x10;
          if (!arith_reg_dest (operands[0], E_SImode))
            return NULL;
          operands[1] = x4;
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!shift_count_operand (operands[2], E_SImode)
              || !(
#line 3967 "../../gcc/config/sh/sh.md"
(TARGET_DYNSHIFT) && 
#line 3969 "../../gcc/config/sh/sh.md"
( CONST_INT_P (operands[2]) && ! sh_dynamicalize_shift_p (operands[2])
   && ! sh_lshrsi_clobbers_t_reg_p (operands[2]))))
            return NULL;
          return gen_split_88 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (treg_set_expr (operands[1], E_VOIDmode))
        {
          x3 = XEXP (x2, 1);
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 31]
              && (
#line 3365 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 3367 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_72 (insn, operands);
        }
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (shift_count_operand (operands[2], E_SImode)
          && (
#line 3524 "../../gcc/config/sh/sh.md"
(TARGET_DYNSHIFT) && 
#line 3526 "../../gcc/config/sh/sh.md"
( CONST_INT_P (operands[2]) && ! sh_dynamicalize_shift_p (operands[2])
   && ! sh_ashlsi_clobbers_t_reg_p (operands[2]))))
        return gen_split_79 (insn, operands);
      if (!not_p27_shift_count_operand (operands[2], E_SImode)
          || !(
#line 3576 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! sh_ashlsi_clobbers_t_reg_p (operands[2])) && 
#line 3578 "../../gcc/config/sh/sh.md"
( (reload_completed
       || (sh_dynamicalize_shift_p (operands[2]) && can_create_pseudo_p ())))))
        return NULL;
      return gen_split_80 (insn, operands);

    case ASHIFTRT:
      if (pattern5 (x1, 
16) != 0
          || !(
#line 3808 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3810 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_84 (insn, operands);

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode)
          || !(
#line 4405 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4407 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
        return NULL;
      return gen_split_98 (insn, operands);

    case UNSPEC:
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (XINT (x2, 1) != 22
              || !general_movdst_operand (operands[0], E_SImode))
            return NULL;
          x12 = XVECEXP (x2, 0, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_SImode)
              || !(
#line 5278 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 5280 "../../gcc/config/sh/sh.md"
( ! currently_expanding_to_rtl)))
            return NULL;
          return gen_split_116 (insn, operands);

        case 2:
          if (XINT (x2, 1) != 24)
            return NULL;
          x13 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 12
              || GET_MODE (x13) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x12 = XVECEXP (x2, 0, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 7341 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed))
            return NULL;
          return gen_split_138 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IF_THEN_ELSE:
          res = split_3 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      if (negt_reg_shl31_operand (operands[1], E_SImode))
        {
          x10 = XEXP (x1, 0);
          operands[0] = x10;
          if (arith_reg_dest (operands[0], E_SImode)
              && (
#line 8485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 8487 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_166 (insn, operands);
        }
      if (GET_CODE (x2) != PLUS
          || GET_MODE (x2) != E_SImode)
        return NULL;
      switch (pattern11 (x1))
        {
        case 0:
          if (!(
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 10068 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 1:
          if (!(
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 10068 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 2:
          if (!(
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 10068 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 3:
          if (!(
#line 10078 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 10080 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_182 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != SMIN
          || GET_MODE (x4) != E_SImode)
        return NULL;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!clips_max_const_int (operands[2], E_VOIDmode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!clips_min_const_int (operands[3], E_VOIDmode)
          || !(
#line 8816 "../../gcc/config/sh/sh.md"
(TARGET_SH2A) && 
#line 8818 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_169 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case NE:
    case EQ:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      switch (GET_CODE (x2))
        {
        case EQ:
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case ZERO_EXTEND:
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case SIGN_EXTEND:
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          res = split_7 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x2;
      if (!t_reg_operand (operands[1], E_SImode))
        return NULL;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      if (!arith_reg_dest (operands[0], E_SImode)
          || !
#line 10886 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed))
        return NULL;
      return gen_split_193 (insn, operands);

    default:
      return NULL;
    }
}
