/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!bitwise_memory_operand (operands[1], E_QImode))
    return -1;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != SIGN_EXTEND
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x4, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 149
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 148
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x2, 0);
  operands[0] = x13;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[1] = x14;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x7, 0);
  operands[2] = x15;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern45 (rtx x1, rtx_code i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern44 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern61 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 33)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 155
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 154
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!fp_arith_reg_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!arith_reg_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!arith_reg_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      if (!arith_reg_dest (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !arith_reg_operand (operands[1], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != 1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 147
      || GET_MODE (x8) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  x11 = XEXP (x5, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!atomic_mem_operand_1 (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_logical_operand_1 (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 33)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MEM)
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XEXP (x10, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 147
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != 0
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XEXP (x4, 0);
  operands[1] = x16;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x17 = XEXP (x3, 1);
  operands[2] = x17;
  x18 = XVECEXP (x1, 0, 4);
  x19 = XEXP (x18, 0);
  operands[3] = x19;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x20 = XVECEXP (x1, 0, 5);
  x21 = XEXP (x20, 0);
  operands[4] = x21;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x22 = XEXP (x8, 0);
  if (!rtx_equal_p (x22, operands[1]))
    return -1;
  x23 = XEXP (x7, 1);
  if (!rtx_equal_p (x23, operands[2]))
    return -1;
  x24 = XEXP (x9, 0);
  if (!rtx_equal_p (x24, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern144 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!mem_index_disp_operand (operands[0], E_HImode)
          || !arith_reg_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!mem_index_disp_operand (operands[0], E_SImode)
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LSHIFTRT
      || GET_MODE (x2) != E_DImode
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!arith_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      return 0;

    case 4:
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MEM:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != MEM)
        return -1;
      return 0;

    case AND:
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != MEM)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != AND)
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != MEM)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern171 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern171 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern171 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MEM:
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x6))
        {
        case SET:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 147
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 0
              || GET_MODE (x10) != E_SImode
              || pattern183 (x3, 
E_SImode) != 0)
            return -1;
          return 0;

        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 0
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern184 (x3, 
E_QImode) != 0)
                return -1;
              return 1;

            case E_HImode:
              if (pattern184 (x3, 
E_HImode) != 0)
                return -1;
              return 2;

            case E_SImode:
              if (pattern184 (x3, 
E_SImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      x12 = XEXP (x5, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x6))
        {
        case SET:
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 147
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 0
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern185 (x3, 
E_SImode) != 0)
                return -1;
              return 4;

            case E_QImode:
              if (pattern185 (x3, 
E_QImode) != 0)
                return -1;
              return 5;

            case E_HImode:
              if (pattern185 (x3, 
E_HImode) != 0)
                return -1;
              return 6;

            default:
              return -1;
            }

        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 0
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern185 (x3, 
E_QImode) != 0)
                return -1;
              return 7;

            case E_HImode:
              if (pattern185 (x3, 
E_HImode) != 0)
                return -1;
              return 8;

            case E_SImode:
              if (pattern185 (x3, 
E_SImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || !atomic_mem_operand_0 (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (pattern215 (x1, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern215 (x1, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case CLOBBER:
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern246 (x3, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern246 (x3, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern246 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case USE:
      res = pattern219 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i3
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i2
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (pattern6 (x1))
    {
    case 0:
      switch (pattern80 (x2))
        {
        case 0:
          if (!
#line 922 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 14; /* cmpgesi_t */

        case 1:
          if (!
#line 1412 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return -1;
          return 31; /* cmpgedi_t */

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arith_reg_operand (operands[1], E_SImode)
          || !
#line 1053 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 20; /* *cmp_div0s_4 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (const_int_operand (operands[2], E_SImode)
      && arith_reg_dest (operands[0], E_SImode)
      && GET_MODE (x2) == E_SImode
      && GET_MODE (x3) == E_SImode)
    {
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) == AND
          && GET_MODE (x5) == E_SImode)
        {
          x6 = XEXP (x5, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x7 = XEXP (x5, 0);
              operands[3] = x7;
              if (arith_reg_or_t_reg_operand (operands[3], E_SImode)
                  && 
#line 3177 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 106; /* *rotcl */
                }
            }
        }
      operands[3] = x5;
      if (treg_set_expr (operands[3], E_VOIDmode)
          && 
#line 3262 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 107; /* *rotcl */
        }
    }
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!arith_reg_operand (operands[3], E_SImode)
          || !
#line 3296 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 109; /* *rotcl */

    case ZERO_EXTRACT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!arith_reg_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_VOIDmode)
          || !
#line 3335 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 111; /* *rotcl */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pnum_clobbers != NULL
          && mem_index_disp_operand (operands[0], E_HImode)
          && arith_reg_operand (operands[1], E_HImode)
          && 
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 186; /* *movhi_index_disp_store */
        }
      if (post_inc_mem (operands[0], E_HImode)
          && arith_reg_operand (operands[1], E_HImode)
          && 
#line 5361 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 198; /* *movhi_store_postinc */
      break;

    case E_SImode:
      if (pnum_clobbers != NULL
          && mem_index_disp_operand (operands[0], E_SImode)
          && arith_reg_operand (operands[1], E_SImode)
          && 
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 187; /* *movsi_index_disp_store */
        }
      break;

    case E_QImode:
      if (post_inc_mem (operands[0], E_QImode)
          && arith_reg_operand (operands[1], E_QImode)
          && 
#line 5361 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 197; /* *movqi_store_postinc */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x3;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!arith_reg_operand (operands[2], E_QImode))
        return -1;
      if (
#line 5375 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_legitimate_index_p (QImode, operands[1], false, true)))
        return 200; /* *movqi_store_mem_disp04 */
      if (!
#line 5386 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (QImode, operands[1], true, true)))
        return -1;
      return 202; /* *movqi_store_mem_disp12 */

    case E_HImode:
      if (!arith_reg_operand (operands[2], E_HImode))
        return -1;
      if (
#line 5375 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_legitimate_index_p (HImode, operands[1], false, true)))
        return 201; /* *movhi_store_mem_disp04 */
      if (!
#line 5386 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh_legitimate_index_p (HImode, operands[1], true, true)))
        return -1;
      return 203; /* *movhi_store_mem_disp12 */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = recog_28 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case LABEL_REF:
      x6 = XEXP (x3, 2);
      if (GET_CODE (x6) != PC
          || GET_CODE (x2) != PC
          || !cbranch_treg_value (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!
#line 6325 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 217; /* *cbranch_t */

    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      operands[0] = x2;
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !treg_set_expr (operands[1], E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 8357 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && ((INTVAL (operands[2]) == -2147483648LL
	&& INTVAL (operands[3]) == 2147483647LL)
       || (INTVAL (operands[2]) == 2147483647LL
	   && INTVAL (operands[3]) == -2147483648LL))))
        return -1;
      *pnum_clobbers = 1;
      return 295; /* *mov_t_msb_neg */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      if (pnum_clobbers != NULL)
        {
          operands[1] = x4;
          if (arith_reg_operand (operands[1], E_DImode)
              && arith_reg_dest (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (arith_reg_operand (operands[2], E_DImode)
                  && 
#line 1545 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 36; /* adddi3 */
                }
            }
        }
      break;

    case PLUS:
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      if (GET_MODE (x4) == E_SImode)
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1]
              && arith_reg_dest (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (arith_reg_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x4, 1);
                  operands[2] = x7;
                  if (arith_reg_operand (operands[2], E_SImode)
                      && 
#line 1649 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return 41; /* *minus_plus_one */
                }
            }
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers != NULL)
    {
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x4;
  res = recog_32 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (pnum_clobbers == NULL)
    return -1;
  if (GET_MODE (x4) == E_SImode)
    {
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          x7 = XEXP (x4, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (arith_reg_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (treg_set_expr (operands[2], E_VOIDmode)
                      && 
#line 1752 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 46; /* *addc_2r_t */
                    }
                }
            }
          break;

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (arith_reg_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (arith_reg_operand (operands[2], E_SImode)
                  && 
#line 2033 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 56; /* *subc */
                }
            }
          break;

        case MINUS:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (arith_reg_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x4, 1);
              operands[2] = x7;
              if (treg_set_expr (operands[2], E_VOIDmode))
                {
                  x5 = XEXP (x3, 1);
                  operands[3] = x5;
                  if (arith_reg_operand (operands[3], E_SImode)
                      && 
#line 2106 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 59; /* *subc_negreg_t */
                    }
                }
            }
          break;

        case AND:
          x7 = XEXP (x4, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x5 = XEXP (x3, 1);
              if (GET_CODE (x5) == CONST_INT
                  && XWINT (x5, 0) == 2147483647L)
                {
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (arith_reg_operand (operands[1], E_SImode)
                      && 
#line 8314 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 293; /* *mov_t_msb_neg */
                    }
                }
            }
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 2147483647L)
    return -1;
  operands[1] = x4;
  if (!treg_set_expr (operands[1], E_VOIDmode)
      || !
#line 8328 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 294; /* *mov_t_msb_neg */
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 147
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (pattern134 (x6, 
IOR, 
NE) != 0)
    return -1;
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 147
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x7, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern124 (x1, 
E_SImode) != 0)
    return -1;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  if (!rtx_equal_p (x12, operands[1])
      || !
#line 4353 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 149; /* negc */
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case CLOBBER:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 147
          || GET_MODE (x6) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode)
          || !mem_index_disp_operand (operands[1], E_SImode)
          || !
#line 5008 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 183; /* *movsi_index_disp_load */

    case SET:
      if (pnum_clobbers == NULL)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 33)
        return -1;
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern215 (x7, 
E_QImode) != 0)
                return -1;
              if (
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 421; /* atomic_exchangeqi_soft_gusa */
                }
              if (!
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 1;
              return 427; /* atomic_exchangeqi_soft_imask */

            case E_HImode:
              if (pattern215 (x7, 
E_HImode) != 0)
                return -1;
              if (
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 422; /* atomic_exchangehi_soft_gusa */
                }
              if (!
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 1;
              return 428; /* atomic_exchangehi_soft_imask */

            case E_SImode:
              if (pattern215 (x7, 
E_SImode) != 0)
                return -1;
              if (
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 2;
                  return 423; /* atomic_exchangesi_soft_gusa */
                }
              if (!
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 1;
              return 429; /* atomic_exchangesi_soft_imask */

            default:
              return -1;
            }

        case PLUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern175 (x7, 
E_QImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 480; /* atomic_fetch_addqi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 534; /* atomic_fetch_addqi_soft_imask */

            case E_HImode:
              if (pattern175 (x7, 
E_HImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 485; /* atomic_fetch_addhi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 539; /* atomic_fetch_addhi_soft_imask */

            case E_SImode:
              if (pattern175 (x7, 
E_SImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 490; /* atomic_fetch_addsi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 544; /* atomic_fetch_addsi_soft_imask */

            default:
              return -1;
            }

        case MINUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern178 (x7, 
E_QImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 481; /* atomic_fetch_subqi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 535; /* atomic_fetch_subqi_soft_imask */

            case E_HImode:
              if (pattern178 (x7, 
E_HImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 486; /* atomic_fetch_subhi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 540; /* atomic_fetch_subhi_soft_imask */

            case E_SImode:
              if (pattern178 (x7, 
E_SImode) != 0)
                return -1;
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 491; /* atomic_fetch_subsi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 545; /* atomic_fetch_subsi_soft_imask */

            default:
              return -1;
            }

        case IOR:
          switch (pattern193 (x7))
            {
            case 0:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 482; /* atomic_fetch_orqi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 536; /* atomic_fetch_orqi_soft_imask */

            case 1:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 487; /* atomic_fetch_orhi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 541; /* atomic_fetch_orhi_soft_imask */

            case 2:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 492; /* atomic_fetch_orsi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 546; /* atomic_fetch_orsi_soft_imask */

            default:
              return -1;
            }

        case XOR:
          switch (pattern193 (x7))
            {
            case 0:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 483; /* atomic_fetch_xorqi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 537; /* atomic_fetch_xorqi_soft_imask */

            case 1:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 488; /* atomic_fetch_xorhi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 542; /* atomic_fetch_xorhi_soft_imask */

            case 2:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 493; /* atomic_fetch_xorsi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 547; /* atomic_fetch_xorsi_soft_imask */

            default:
              return -1;
            }

        case AND:
          switch (pattern193 (x7))
            {
            case 0:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 484; /* atomic_fetch_andqi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 538; /* atomic_fetch_andqi_soft_imask */

            case 1:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 489; /* atomic_fetch_andhi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 543; /* atomic_fetch_andhi_soft_imask */

            case 2:
              if (
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                {
                  *pnum_clobbers = 3;
                  return 494; /* atomic_fetch_andsi_soft_gusa */
                }
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              *pnum_clobbers = 2;
              return 548; /* atomic_fetch_andsi_soft_imask */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x8, 0);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern183 (x7, 
E_QImode) != 0)
                    return -1;
                  if (
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 495; /* atomic_fetch_notqi_soft_gusa */
                    }
                  if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 549; /* atomic_fetch_notqi_soft_imask */

                case E_HImode:
                  if (pattern183 (x7, 
E_HImode) != 0)
                    return -1;
                  if (
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 496; /* atomic_fetch_nothi_soft_gusa */
                    }
                  if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 550; /* atomic_fetch_nothi_soft_imask */

                case E_SImode:
                  if (pattern183 (x7, 
E_SImode) != 0)
                    return -1;
                  if (
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 497; /* atomic_fetch_notsi_soft_gusa */
                    }
                  if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 551; /* atomic_fetch_notsi_soft_imask */

                default:
                  return -1;
                }

            case AND:
              x11 = XEXP (x10, 1);
              operands[2] = x11;
              x12 = XEXP (x10, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern230 (x7, 
E_QImode) != 0)
                    return -1;
                  if (arith_reg_operand (operands[2], E_QImode)
                      && 
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 561; /* atomic_fetch_nandqi_soft_gusa */
                    }
                  if (!logical_operand (operands[2], E_QImode)
                      || !
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 570; /* atomic_fetch_nandqi_soft_imask */

                case E_HImode:
                  if (pattern230 (x7, 
E_HImode) != 0)
                    return -1;
                  if (arith_reg_operand (operands[2], E_HImode)
                      && 
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 562; /* atomic_fetch_nandhi_soft_gusa */
                    }
                  if (!logical_operand (operands[2], E_HImode)
                      || !
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 571; /* atomic_fetch_nandhi_soft_imask */

                case E_SImode:
                  if (pattern230 (x7, 
E_SImode) != 0)
                    return -1;
                  if (arith_reg_operand (operands[2], E_SImode)
                      && 
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    {
                      *pnum_clobbers = 3;
                      return 563; /* atomic_fetch_nandsi_soft_gusa */
                    }
                  if (!logical_operand (operands[2], E_SImode)
                      || !
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  *pnum_clobbers = 2;
                  return 572; /* atomic_fetch_nandsi_soft_imask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case UDIV:
      if (pattern35 (x4, 
4, 
E_SImode) != 0
          || pattern125 (x1, 
CLOBBER, 
5) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 147
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || GET_MODE (x10) != E_SImode
          || pattern231 (x1) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x8))
        {
        case 146:
          if (REGNO (x10) != 1)
            return -1;
          x11 = XEXP (x3, 0);
          if (REGNO (x11) != 4)
            return -1;
          x12 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x12) != USE)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!
#line 2206 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_DIVIDE_CALL_DIV1))
            return -1;
          return 63; /* udivsi3_i1 */

        case 1:
          if (REGNO (x10) != 146)
            return -1;
          x11 = XEXP (x3, 0);
          if (REGNO (x11) != 148)
            return -1;
          x12 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 149
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          if (!arith_reg_operand (operands[1], E_SImode)
              || !
#line 2267 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 66; /* udivsi3_i4_int */

        default:
          return -1;
        }

    case DIV:
      if (pattern35 (x4, 
4, 
E_SImode) != 0)
        return -1;
      x16 = XEXP (x4, 1);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 5
          || GET_MODE (x16) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || pattern91 (x1) != 0
          || pattern231 (x1) != 0
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (REGNO (x6))
        {
        case 147:
          if (pattern271 (x1, 
E_SImode, 
1, 
146) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          switch (REGNO (x11))
            {
            case 2:
              if (REGNO (x13) != 3
                  || !
#line 2348 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_DIVIDE_CALL_DIV1))
                return -1;
              return 68; /* divsi3_i1 */

            case 148:
              if (REGNO (x13) != 149
                  || !
#line 2396 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 71; /* divsi3_i4_int */

            default:
              return -1;
            }

        case 146:
          if (pattern271 (x1, 
E_DFmode, 
66, 
64) != 0)
            return -1;
          x11 = XEXP (x3, 0);
          if (REGNO (x11) != 2)
            return -1;
          x12 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x12) != USE)
            return -1;
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!
#line 2380 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && TARGET_FPU_SINGLE))
            return -1;
          return 70; /* divsi3_i4_single */

        default:
          return -1;
        }

    case MEM:
      if (pattern35 (x4, 
5, 
E_BLKmode) != 0)
        return -1;
      x17 = XEXP (x2, 0);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != E_BLKmode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 4
          || GET_MODE (x18) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      if (pattern146 (x9, 
E_SImode, 
146, 
CLOBBER) != 0)
        return -1;
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 0
          || GET_MODE (x11) != E_SImode
          || pattern257 (x1, 
2, 
E_SImode, 
1) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!
#line 8981 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
        return -1;
      return 321; /* block_move_real_i4 */

    case UNSPEC_VOLATILE:
      if (pattern64 (x4) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET
          || pattern141 (x1) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x12) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x14) != CLOBBER)
        return -1;
      x17 = XEXP (x2, 0);
      operands[0] = x17;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x19 = XVECEXP (x4, 0, 1);
      operands[2] = x19;
      x20 = XVECEXP (x4, 0, 2);
      operands[3] = x20;
      x11 = XEXP (x3, 0);
      if (!scratch_operand (x11, E_SImode))
        return -1;
      operands[4] = x11;
      res = recog_68 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[5] = x11;
      x9 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x9) != USE)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 0
          || GET_MODE (x13) != E_SImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 1
          || GET_MODE (x15) != E_SImode)
        return -1;
      x21 = XVECEXP (x4, 0, 0);
      operands[1] = x21;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!gbr_displacement (operands[4], E_SImode))
        return -1;
      switch (pattern284 (x5))
        {
        case 0:
          if (!
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 410; /* atomic_compare_and_swapqi_soft_tcb */

        case 1:
          if (!
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 411; /* atomic_compare_and_swaphi_soft_tcb */

        case 2:
          if (!
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 412; /* atomic_compare_and_swapsi_soft_tcb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ
      && pattern50 (x3, 
147) == 0)
    {
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) == NEG
          && GET_MODE (x4) == E_SImode)
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (arith_reg_dest (operands[0], E_SImode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (const_int_operand (operands[3], E_SImode))
                {
                  x7 = XEXP (x2, 1);
                  operands[1] = x7;
                  if (arith_reg_operand (operands[1], E_SImode))
                    {
                      x8 = XEXP (x4, 0);
                      operands[2] = x8;
                      if (arith_reg_operand (operands[2], E_SImode)
                          && 
#line 4529 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_ZDCBRANCH))
                        return gen_split_103 (insn, operands);
                    }
                }
            }
        }
    }
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return NULL;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return NULL;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return NULL;
  operands[1] = x3;
  if (!cbranch_treg_value (operands[1], E_VOIDmode))
    return NULL;
  x9 = XEXP (x7, 0);
  operands[0] = x9;
  if (!(
#line 6325 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 6329 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_130 (insn, operands);
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[0] = x5;
          if (!arith_reg_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          if (!arith_or_int_operand (operands[1], E_SImode)
              || !
#line 557 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p () && CONST_INT_P (operands[1])
   && !sh_in_recog_treg_set_expr ()))
            return NULL;
          return gen_split_1 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!arith_reg_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x5, 1);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !(
#line 804 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 806 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_11 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x4 = XEXP (x2, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) == SUBREG)
            {
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) == AND)
                {
                  switch (pattern150 (x3))
                    {
                    case 0:
                      if ((
#line 728 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 730 "../../gcc/config/sh/sh.md"
( 1)))
                        return gen_split_2 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 728 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 730 "../../gcc/config/sh/sh.md"
( 1)))
                        return gen_split_3 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 750 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()) && 
#line 752 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
                        return gen_split_4 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 750 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()) && 
#line 752 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
                        return gen_split_5 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()) && 
#line 768 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
                        return gen_split_6 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()) && 
#line 768 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
                        return gen_split_7 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[0] = x3;
          if (arith_reg_operand (operands[0], E_SImode)
              && 
#line 831 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p () && optimize
   && !sh_in_recog_treg_set_expr ()))
            return gen_split_12 (insn, operands);
        }
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!arith_reg_operand (operands[0], E_DImode))
        return NULL;
      operands[1] = x4;
      if (!arith_reg_or_0_operand (operands[1], E_DImode)
          || !
#line 1366 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed && optimize))
        return NULL;
      return gen_split_29 (insn, operands);

    case 2:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[1] = x6;
      switch (pattern151 (x2))
        {
        case 0:
          if ((
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 786 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_8 (insn, operands);
          break;

        case 1:
          if ((
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 786 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_9 (insn, operands);
          break;

        case 2:
          if ((
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 786 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_10 (insn, operands);
          break;

        default:
          break;
        }
      if (XWINT (x6, 0) != 1L
          || pattern152 (x2) != 0
          || !(
#line 1147 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) == 15
       || INTVAL (operands[2]) == 23 || INTVAL (operands[2]) == 29
       || INTVAL (operands[2]) == 30 || INTVAL (operands[2]) == 31)) && 
#line 1152 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_21 (insn, operands);

    case 3:
      x2 = XEXP (x1, 1);
      switch (pattern104 (x2))
        {
        case 0:
          if (!(
#line 1029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1031 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_15 (insn, operands);

        case 1:
          if (!(
#line 1079 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1081 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_19 (insn, operands);

        default:
          return NULL;
        }

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern105 (x2, 
0) != 0
          || !(
#line 1041 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1043 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_16 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  if (REGNO (x5) == 149)
    {
      switch (pattern107 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) == SIGN_EXTEND
              && pattern106 (x3, 
SIGN_EXTEND) == 0
              && (
#line 2453 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2455 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_53 (insn, operands);
          operands[1] = x6;
          if (arith_reg_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              if (arith_reg_operand (operands[2], E_SImode)
                  && (
#line 2531 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()) && 
#line 2533 "../../gcc/config/sh/sh.md"
( 1)))
                return gen_split_55 (insn, operands);
            }
          break;

        case 1:
          if ((
#line 2465 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2467 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_54 (insn, operands);
          break;

        default:
          break;
        }
    }
  if (REGNO (x5) != 147
      || pattern108 (x1) != 0
      || !(
#line 8467 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 8469 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_165 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_20 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 1);
              switch (GET_CODE (x3))
                {
                case IF_THEN_ELSE:
                  res = split_8 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case PLUS:
                  res = split_11 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case MINUS:
                  res = split_12 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case MULT:
                  res = split_13 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case TRUNCATE:
                  res = split_14 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case IOR:
                  res = split_15 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case ASHIFT:
                  x4 = XEXP (x3, 1);
                  if (GET_CODE (x4) == CONST_INT)
                    {
                      operands[2] = x4;
                      switch (pattern87 (x1))
                        {
                        case 0:
                          if ((
#line 3600 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_ashlsi_clobbers_t_reg_p (operands[2])) && 
#line 3602 "../../gcc/config/sh/sh.md"
( (reload_completed || INTVAL (operands[2]) == 31
       || (sh_dynamicalize_shift_p (operands[2]) && can_create_pseudo_p ())))))
                            return gen_split_81 (insn, operands);
                          break;

                        case 1:
                          if ((
#line 3691 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3693 "../../gcc/config/sh/sh.md"
( reload_completed)))
                            return gen_split_82 (insn, operands);
                          break;

                        default:
                          break;
                        }
                      if (XWINT (x4, 0) == 1L
                          && pattern96 (x1) == 0
                          && (
#line 3752 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3754 "../../gcc/config/sh/sh.md"
( reload_completed)))
                        return gen_split_83 (insn, operands);
                    }
                  break;

                case ASHIFTRT:
                  x4 = XEXP (x3, 1);
                  if (GET_CODE (x4) == CONST_INT
                      && pattern52 (x1) == 0)
                    {
                      switch (XWINT (x4, 0))
                        {
                        case 31L:
                          if (arith_reg_dest (operands[0], E_SImode)
                              && GET_MODE (x3) == E_SImode
                              && arith_reg_operand (operands[1], E_SImode)
                              && (
#line 3822 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3824 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_85 (insn, operands);
                          break;

                        case 1L:
                          if (arith_reg_dest (operands[0], E_DImode)
                              && GET_MODE (x3) == E_DImode
                              && arith_reg_operand (operands[1], E_DImode)
                              && (
#line 3889 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3891 "../../gcc/config/sh/sh.md"
( reload_completed)))
                            return gen_split_87 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case LSHIFTRT:
                  res = split_16 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case AND:
                  if (GET_MODE (x3) == E_SImode)
                    {
                      x5 = XEXP (x3, 0);
                      if (GET_CODE (x5) == ASHIFT
                          && GET_MODE (x5) == E_SImode
                          && pattern23 (x1) == 0
                          && 
#line 4138 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed && (unsigned)INTVAL (operands[2]) < 32))
                        return gen_split_93 (insn, operands);
                    }
                  break;

                case SIGN_EXTRACT:
                  if (pattern24 (x1) == 0
                      && 
#line 4259 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return gen_split_95 (insn, operands);
                  break;

                case NEG:
                  if (pattern51 (x1, 
147, 
CLOBBER) == 0)
                    {
                      x5 = XEXP (x3, 0);
                      switch (GET_CODE (x5))
                        {
                        case REG:
                        case SUBREG:
                        case SIGN_EXTEND:
                          operands[1] = x5;
                          if (arith_reg_operand (operands[1], E_DImode)
                              && arith_reg_dest (operands[0], E_DImode)
                              && GET_MODE (x3) == E_DImode
                              && (
#line 4382 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4384 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_97 (insn, operands);
                          break;

                        case ABS:
                          switch (pattern136 (x3))
                            {
                            case 0:
                              if ((
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4487 "../../gcc/config/sh/sh.md"
( 1)))
                                return gen_split_101 (insn, operands);
                              break;

                            case 1:
                              if ((
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4487 "../../gcc/config/sh/sh.md"
( 1)))
                                return gen_split_102 (insn, operands);
                              break;

                            default:
                              break;
                            }
                          break;

                        default:
                          break;
                        }
                      if (arith_reg_dest (operands[0], E_SImode)
                          && GET_MODE (x3) == E_SImode)
                        {
                          operands[1] = x5;
                          if (treg_set_expr (operands[1], E_VOIDmode)
                              && (
#line 8406 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 8411 "../../gcc/config/sh/sh.md"
( !t_reg_operand (operands[1], VOIDmode))))
                            return gen_split_162 (insn, operands);
                        }
                    }
                  break;

                case ABS:
                  if (pattern52 (x1) == 0)
                    {
                      switch (pattern137 (x3))
                        {
                        case 0:
                          if ((
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4465 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_99 (insn, operands);
                          break;

                        case 1:
                          if ((
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4465 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_100 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case MEM:
                  operands[1] = x3;
                  if (mem_index_disp_operand (operands[1], E_SImode))
                    {
                      x6 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x6) == CLOBBER
                          && pattern26 (x1, 
E_SImode, 
147) == 0
                          && (
#line 5008 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 5010 "../../gcc/config/sh/sh.md"
( 1)))
                        return gen_split_111 (insn, operands);
                    }
                  break;

                case REG:
                case SUBREG:
                case SIGN_EXTEND:
                  if (pattern51 (x1, 
147, 
CLOBBER) == 0)
                    {
                      if (arith_reg_dest (operands[0], E_SImode)
                          && GET_CODE (x3) == SIGN_EXTEND
                          && GET_MODE (x3) == E_SImode)
                        {
                          x5 = XEXP (x3, 0);
                          operands[1] = x5;
                          if (mem_index_disp_operand (operands[1], E_HImode)
                              && (
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 5038 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_112 (insn, operands);
                        }
                      operands[1] = x3;
                      switch (pattern144 ())
                        {
                        case 0:
                          if ((
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 5085 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_114 (insn, operands);
                          break;

                        case 1:
                          if ((
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 5085 "../../gcc/config/sh/sh.md"
( 1)))
                            return gen_split_115 (insn, operands);
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case ZERO_EXTEND:
                  if (pattern25 (x1) == 0
                      && (
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 5038 "../../gcc/config/sh/sh.md"
( 1)))
                    return gen_split_113 (insn, operands);
                  break;

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x3;
                  if (immediate_operand (operands[1], E_SImode))
                    {
                      x6 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x6) == CLOBBER)
                        {
                          x7 = XEXP (x2, 0);
                          operands[0] = x7;
                          if (register_operand (operands[0], E_SImode))
                            {
                              x8 = XEXP (x6, 0);
                              operands[2] = x8;
                              if (register_operand (operands[2], E_SImode)
                                  && 
#line 6300 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                                return gen_split_129 (insn, operands);
                            }
                        }
                    }
                  break;

                case XOR:
                  if (GET_MODE (x3) == E_SImode)
                    {
                      x4 = XEXP (x3, 1);
                      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                        {
                          x6 = XVECEXP (x1, 0, 1);
                          if (pattern84 (x6, 
USE) == 0)
                            {
                              x7 = XEXP (x2, 0);
                              operands[0] = x7;
                              if (arith_reg_dest (operands[0], E_SImode))
                                {
                                  x5 = XEXP (x3, 0);
                                  operands[1] = x5;
                                  if (t_reg_operand (operands[1], E_SImode)
                                      && (
#line 8292 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 8294 "../../gcc/config/sh/sh.md"
( reload_completed)))
                                    return gen_split_158 (insn, operands);
                                }
                            }
                        }
                    }
                  break;

                default:
                  break;
                }
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER
                  || pattern26 (x1, 
E_SImode, 
147) != 0)
                return NULL;
              operands[1] = x3;
              if (treg_set_expr (operands[1], E_VOIDmode)
                  && (
#line 8607 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 8609 "../../gcc/config/sh/sh.md"
( !sh_in_recog_treg_set_expr ())))
                return gen_split_168 (insn, operands);
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              switch (pattern139 (x3))
                {
                case 0:
                  if (!(
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()) && 
#line 8848 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                case 1:
                  if (!(
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()) && 
#line 8848 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 2:
                  if (!(
#line 8906 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()) && 
#line 8908 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                case 3:
                  if (!(
#line 10227 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && exact_log2 (INTVAL (operands[3])) >= 0) && 
#line 10230 "../../gcc/config/sh/sh.md"
( 1)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 7)
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return NULL;
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!register_operand (operands[0], E_VOIDmode))
                return NULL;
              x8 = XEXP (x6, 0);
              operands[1] = x8;
              if (!scratch_operand (operands[1], E_VOIDmode)
                  || !
#line 8107 "../../gcc/config/sh/sh.md"
(reload_completed))
                return NULL;
              return gen_split_155 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          return split_19 (x1, insn);

        case 4:
          return split_17 (x1, insn);

        case 5:
          return split_18 (x1, insn);

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern16 (x6, 
NOT) != 0
              || pattern148 (x1) != 0)
            return NULL;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != CLOBBER)
            return NULL;
          x11 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x11) != CLOBBER)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          x12 = XEXP (x10, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x11, 0);
          operands[3] = x13;
          if (!scratch_operand (operands[3], E_SImode))
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case MEM:
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (!arith_reg_operand (operands[1], E_SImode))
                return NULL;
              x14 = XEXP (x6, 1);
              x15 = XVECEXP (x14, 0, 0);
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return NULL;
              x8 = XEXP (x6, 0);
              x18 = XEXP (x8, 0);
              if (!rtx_equal_p (x18, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern267 (x1, 
E_QImode) != 0
                      || !(
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS) && 
#line 966 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_225 (insn, operands);

                case E_HImode:
                  if (pattern267 (x1, 
E_HImode) != 0
                      || !(
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS) && 
#line 966 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_226 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM)
                return NULL;
              x19 = XEXP (x5, 0);
              operands[1] = x19;
              if (!arith_reg_operand (operands[1], E_SImode))
                return NULL;
              switch (pattern281 (x1))
                {
                case 0:
                  if (!(
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS) && 
#line 1742 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_305 (insn, operands);

                case 1:
                  if (!(
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS) && 
#line 1742 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_306 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
