/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UDIV
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 5
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case REG:
      return pattern13 (x1); /* [-1, 0] */

    case ZERO_EXTRACT:
      if (pattern14 (x1) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x6, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 13
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 14)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC_VOLATILE
      || XVECLEN (x8, 0) != 1
      || XINT (x8, 1) != 15
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern45 (x1, 
USE, 
146, 
147) != 0)
    return -1;
  return 0;
}

int
pattern53 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != XOR
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != NOT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ASHIFT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x9 = XEXP (x1, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 147
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x5, 0);
  operands[0] = x10;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x11 = XEXP (x5, 1);
  operands[1] = x11;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x12 = XEXP (x4, 1);
  operands[2] = x12;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[3] = x13;
  if (!arith_reg_operand (operands[3], E_SImode))
    return -1;
  x14 = XEXP (x7, 1);
  operands[4] = x14;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arith_reg_dest (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!arith_reg_dest (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 33)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  return pattern39 (x1); /* [-1, 2] */
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern99 (x5); /* [-1, 1] */
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      return 0;

    case ZERO_EXTEND:
      if (pattern106 (x6, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 33)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != MEM)
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XEXP (x10, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 147
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != 0
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XEXP (x4, 0);
  operands[1] = x16;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x17 = XEXP (x3, 1);
  operands[2] = x17;
  x18 = XVECEXP (x1, 0, 4);
  x19 = XEXP (x18, 0);
  operands[3] = x19;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x20 = XVECEXP (x1, 0, 5);
  x21 = XEXP (x20, 0);
  operands[4] = x21;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x22 = XEXP (x8, 0);
  if (!rtx_equal_p (x22, operands[1]))
    return -1;
  x23 = XEXP (x7, 1);
  if (!rtx_equal_p (x23, operands[2]))
    return -1;
  x24 = XEXP (x9, 0);
  if (!rtx_equal_p (x24, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern118 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern118 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  return pattern146 (x4, 
i1, 
i2, 
CLOBBER); /* [-1, 0] */
}

int
pattern156 (rtx x1, int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fp_arith_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fp_arith_reg_operand (operands[1], i1)
      || !fp_arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_logical_operand_1 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!arith_reg_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!arith_reg_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  switch (XWINT (x5, 0))
    {
    case 1L:
      if (GET_CODE (x4) != ASHIFT
          || !arith_reg_or_t_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case -2147483648L:
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 12)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  return pattern198 (x6, 
146); /* [-1, 0] */
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      return pattern178 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern178 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern178 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case LSHIFTRT:
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!arith_reg_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ZERO_EXTRACT:
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!arith_reg_operand (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x1, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern241 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern241 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern241 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MEM:
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              return pattern248 (x3, 
E_QImode); /* [-1, 0] */

            case E_HImode:
              if (pattern248 (x3, 
E_HImode) != 0)
                return -1;
              return 1;

            case E_SImode:
              if (pattern248 (x3, 
E_SImode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case USE:
          res = pattern220 (x1);
          if (res >= 0)
            return res + 3; /* [3, 5] */
          return -1;

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern249 (x3, 
E_QImode) != 0)
                return -1;
              return 6;

            case E_HImode:
              if (pattern249 (x3, 
E_HImode) != 0)
                return -1;
              return 7;

            case E_SImode:
              if (pattern249 (x3, 
E_SImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        case USE:
          res = pattern227 (x1);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern283 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!atomic_mem_operand_0 (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode)
          || !arith_operand (operands[3], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_QImode:
      if (pattern282 (x1, 
E_QImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern282 (x1, 
E_HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == SIGN_EXTEND)
    {
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == SIGN_EXTEND)
        {
          if (pnum_clobbers != NULL)
            {
              switch (pattern55 (x1))
                {
                case 0:
                  if (
#line 2453 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 72; /* mulhisi3 */
                    }
                  break;

                case 1:
                  if (
#line 2599 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 2;
                      return 81; /* mulsidi3_compact */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_MODE (x4) == E_SImode
              && pattern56 (x1) == 0
              && 
#line 2488 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 75; /* mulhisi3_i */
        }
    }
  operands[1] = x3;
  if (pattern20 (x1) == 0
      && 
#line 2514 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
    return 77; /* mul_r */
  operands[0] = x3;
  if (arith_reg_operand (operands[0], E_SImode)
      && pattern53 (x1, 
149) == 0)
    {
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (arith_reg_operand (operands[1], E_SImode)
          && 
#line 2522 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        return 78; /* mul_l */
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x3;
  if (pattern20 (x1) != 0
      || !
#line 2531 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 79; /* mulsi3_i */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  switch (XWINT (x3, 0))
    {
    case 1L:
      if (pattern58 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 2923 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      *pnum_clobbers = 1;
      return 99; /* *rotlsi3_1 */

    case 31L:
      if (pattern58 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 2932 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      *pnum_clobbers = 1;
      return 100; /* rotlsi3_31 */

    case 16L:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode)
          || !
#line 2940 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 101; /* rotlsi3_16 */

    case 8L:
      if (!arith_reg_dest (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !arith_reg_operand (operands[1], E_HImode)
          || !
#line 2999 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 102; /* rotlhi3_8 */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      switch (pattern81 (x3))
        {
        case 0:
          if (!
#line 4695 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 163; /* *zero_extendqisi2_compact */

        case 1:
          if (!
#line 4695 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 164; /* *zero_extendhisi2_compact */

        case 2:
          if (!
#line 4716 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 165; /* zero_extendqihi2 */

        default:
          return -1;
        }

    case MEM:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!zero_extend_movu_operand (operands[1], E_QImode)
              || !
#line 4736 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return -1;
          return 166; /* *zero_extendqisi2_disp_mem */

        case E_HImode:
          if (zero_extend_movu_operand (operands[1], E_HImode)
              && 
#line 4736 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return 167; /* *zero_extendhisi2_disp_mem */
          if (pnum_clobbers == NULL
              || !mem_index_disp_operand (operands[1], E_HImode)
              || !
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 185; /* *movhi_index_disp_load */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      if (!general_movsrc_operand (operands[1], E_SImode)
          || !arith_reg_dest (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 2);
      operands[2] = x4;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 1472 "../../gcc/config/sh/sh.md"
(TARGET_PRETEND_CMOVE
   && (arith_reg_operand (operands[1], SImode)
       || (immediate_operand (operands[1], SImode)
	   && satisfies_constraint_I08 (operands[1])))))
        return -1;
      return 34; /* *movsicc_t_false */

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != NOT
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !bitwise_memory_operand (operands[0], E_QImode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[1] = x10;
      if (!const_int_operand (operands[1], E_QImode))
        return -1;
      x11 = XEXP (x3, 1);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      x12 = XEXP (x8, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x4, 1);
      if (!rtx_equal_p (x13, operands[0])
          || !
#line 10308 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
        return -1;
      return 385; /* bst_m2a */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !treg_set_expr (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arith_reg_operand (operands[3], E_SImode)
          || !
#line 1634 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* *addc */

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[2] = x4;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !treg_set_expr_not_const01 (operands[1], E_VOIDmode)
          || !
#line 1713 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* *addc_t_r */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SMIN:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!clips_max_const_int (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!clips_min_const_int (operands[3], E_VOIDmode)
              || !
#line 8816 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return -1;
          return 313; /* *clips */

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!arith_reg_or_0_or_1_operand (operands[2], E_SImode)
              || !
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 316; /* *smaxsi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SMAX:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!clips_min_const_int (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!clips_max_const_int (operands[3], E_VOIDmode)
              || !
#line 8827 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return -1;
          return 314; /* *clips */

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!arith_reg_or_0_or_1_operand (operands[2], E_SImode)
              || !
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 315; /* *sminsi3 */

        default:
          return -1;
        }

    case UMIN:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[2] = x7;
      if (clipu_max_const_int (operands[2], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (arith_reg_dest (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (arith_reg_operand (operands[1], E_SImode)
                  && 
#line 8891 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
                return 317; /* *clipu */
            }
        }
      if (pnum_clobbers == NULL
          || XWINT (x7, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode)
          || !
#line 8906 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 318; /* clipu_one */

    case EQ:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != AND
          || pattern17 (x4, 
AND) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x8 = XEXP (x5, 0);
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != ZERO_EXTRACT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != XOR
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x9, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x12 = XEXP (x9, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != ZERO_EXTRACT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != XOR
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x13, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x16 = XEXP (x13, 2);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x17 = XEXP (x5, 1);
      if (GET_CODE (x17) != ZERO_EXTRACT
          || GET_MODE (x17) != E_SImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != XOR
          || GET_MODE (x18) != E_SImode)
        return -1;
      x19 = XEXP (x17, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x20 = XEXP (x17, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x21 = XEXP (x6, 0);
      if (GET_CODE (x21) != XOR
          || GET_MODE (x21) != E_SImode)
        return -1;
      x22 = XEXP (x6, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XEXP (x6, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
          || pattern12 (x1, 
0) != 0)
        return -1;
      x24 = XEXP (x10, 0);
      operands[0] = x24;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x25 = XEXP (x10, 1);
      operands[1] = x25;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x26 = XEXP (x14, 0);
      if (!rtx_equal_p (x26, operands[0]))
        return -1;
      x27 = XEXP (x14, 1);
      if (!rtx_equal_p (x27, operands[1]))
        return -1;
      x28 = XEXP (x18, 0);
      if (!rtx_equal_p (x28, operands[0]))
        return -1;
      x29 = XEXP (x18, 1);
      if (!rtx_equal_p (x29, operands[1]))
        return -1;
      x30 = XEXP (x21, 0);
      if (!rtx_equal_p (x30, operands[0]))
        return -1;
      x31 = XEXP (x21, 1);
      if (!rtx_equal_p (x31, operands[1])
          || !
#line 9029 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 323; /* cmpstr_t */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 27)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x32 = XVECEXP (x2, 0, 0);
      operands[1] = x32;
      if (!unaligned_load_operand (operands[1], E_BLKmode)
          || !
#line 9932 "../../gcc/config/sh/sh.md"
(TARGET_SH4A))
        return -1;
      return 362; /* movua */

    case ZERO_EXTRACT:
      if (pattern9 (x1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case XOR:
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x33 = XEXP (x2, 2);
          operands[2] = x33;
          switch (pattern169 (x4))
            {
            case 0:
              if (!
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))))
                return -1;
              return 363; /* *neg_zero_extract_0 */

            case 1:
              if (!
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))))
                return -1;
              return 364; /* *neg_zero_extract_0 */

            case 2:
              if (!
#line 10029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))))
                return -1;
              return 365; /* *neg_zero_extract_0 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          switch (pattern123 (x2))
            {
            case 0:
              if (
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))))
                return 375; /* *zero_extract_0 */
              if (!
#line 10346 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_K03 (operands[1])))
                return -1;
              return 388; /* bldqi_reg */

            case 1:
              if (
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))))
                return 376; /* *zero_extract_0 */
              if (!
#line 10346 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_K03 (operands[1])))
                return -1;
              return 389; /* bldhi_reg */

            case 2:
              if (
#line 10173 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && !(TARGET_SH2A && satisfies_constraint_K03 (operands[1]))))
                return 377; /* *zero_extract_0 */
              if (!
#line 10346 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_K03 (operands[1])))
                return -1;
              return 390; /* bldsi_reg */

            default:
              return -1;
            }

        case MEM:
          operands[0] = x4;
          if (!bitwise_memory_operand (operands[0], E_QImode))
            return -1;
          x33 = XEXP (x2, 2);
          operands[1] = x33;
          if (!
#line 10321 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
            return -1;
          return 386; /* bld_m2a */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case NOT:
          switch (pattern59 (x1))
            {
            case 0:
              x5 = XEXP (x4, 0);
              operands[0] = x5;
              if (arith_reg_operand (operands[0], E_SImode)
                  && 
#line 10052 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 366; /* *neg_zero_extract_1 */
              if (GET_CODE (x5) != SUBREG)
                return -1;
              switch (pattern153 (x5))
                {
                case 0:
                  if (!
#line 10130 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32))
                    return -1;
                  return 373; /* *neg_zero_extract_5 */

                case 1:
                  if (!
#line 10147 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32))
                    return -1;
                  return 374; /* *neg_zero_extract_6 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 10114 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[3]) > 0
   && INTVAL (operands[1]) + INTVAL (operands[3]) == 32))
                return -1;
              return 372; /* *neg_zero_extract_4b */

            default:
              return -1;
            }

        case AND:
          if (pattern60 (x1) != 0
              || !
#line 10096 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && INTVAL (operands[4]) > 0
   && INTVAL (operands[1]) & (1LL << INTVAL (operands[2]))))
            return -1;
          return 371; /* *neg_zero_extract_4 */

        case LSHIFTRT:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!arith_reg_dest (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 10227 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && exact_log2 (INTVAL (operands[3])) >= 0))
            return -1;
          *pnum_clobbers = 1;
          return 380; /* *zero_extract_3 */

        case REG:
          if (pattern13 (x1) != 0
              || !
#line 10358 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
            return -1;
          return 391; /* band_m2a */

        case ZERO_EXTRACT:
          if (pattern14 (x1) != 0
              || !
#line 10371 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[2])))
            return -1;
          return 392; /* bandreg_m2a */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 367; /* *neg_zero_extract_2 */

        case 1:
          if (!
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 368; /* *neg_zero_extract_2 */

        case 2:
          if (!
#line 10066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 369; /* *neg_zero_extract_2 */

        case 3:
          if (!
#line 10078 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 370; /* *neg_zero_extract_3 */

        default:
          return -1;
        }

    case SUBREG:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 147
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x34 = XEXP (x4, 2);
      operands[1] = x34;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      switch (SUBREG_BYTE (x2))
        {
        case 0:
          if (!
#line 10201 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32))
            return -1;
          return 378; /* *zero_extract_1 */

        case 4:
          if (!
#line 10214 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()
   && INTVAL (operands[1]) < 32))
            return -1;
          return 379; /* *zero_extract_2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pattern12 (x1, 
1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!bitwise_memory_operand (operands[0], E_QImode))
        return -1;
      x33 = XEXP (x2, 2);
      operands[1] = x33;
      if (!const_int_operand (operands[1], E_VOIDmode)
          || !
#line 10334 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
        return -1;
      return 387; /* bldsign_m2a */

    case IOR:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 10394 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
            return -1;
          return 393; /* bor_m2a */

        case 1:
          if (!
#line 10407 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[2])))
            return -1;
          return 394; /* borreg_m2a */

        default:
          return -1;
        }

    case XOR:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 10430 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
            return -1;
          return 395; /* bxor_m2a */

        case 1:
          if (!
#line 10443 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[2])))
            return -1;
          return 396; /* bxorreg_m2a */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 9)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 15
          || GET_MODE (x3) != E_SImode)
        return -1;
      x32 = XVECEXP (x2, 0, 0);
      operands[0] = x32;
      if (!
#line 10968 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 397; /* sp_switch_1 */

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case UNSPEC_VOLATILE:
      if (XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != 13
          || GET_MODE (x7) != E_SImode
          || pattern141 (x1) != 0
          || pattern270 (x1) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x7, 0, 1);
      operands[2] = x10;
      x11 = XVECEXP (x7, 0, 2);
      operands[3] = x11;
      x12 = XEXP (x4, 0);
      operands[4] = x12;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 407; /* atomic_compare_and_swapqi_soft_gusa */

        case 1:
          if (!
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 408; /* atomic_compare_and_swaphi_soft_gusa */

        case 2:
          if (!
#line 391 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 409; /* atomic_compare_and_swapsi_soft_gusa */

        default:
          return -1;
        }

    case MEM:
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 33)
        return -1;
      x14 = XEXP (x3, 0);
      if (GET_CODE (x14) != MEM
          || pattern168 (x1) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x15 = XEXP (x7, 0);
      operands[1] = x15;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x16 = XEXP (x5, 0);
      if (!scratch_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x6, 0);
      if (!scratch_operand (x17, E_SImode))
        return -1;
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x19 = XVECEXP (x13, 0, 0);
      switch (GET_CODE (x19))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[2] = x19;
          operands[3] = x16;
          operands[4] = x17;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern258 (x1, 
E_QImode) != 0
                  || !
#line 581 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 419; /* atomic_exchangeqi_hard_1 */

            case E_HImode:
              if (pattern258 (x1, 
E_HImode) != 0
                  || !
#line 581 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 420; /* atomic_exchangehi_hard_1 */

            default:
              return -1;
            }

        case PLUS:
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != MEM)
            return -1;
          x21 = XEXP (x19, 1);
          operands[2] = x21;
          operands[3] = x16;
          operands[4] = x17;
          switch (pattern260 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 446; /* atomic_fetch_addqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 451; /* atomic_fetch_addhi_hard_1 */

            default:
              return -1;
            }

        case MINUS:
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != MEM)
            return -1;
          x21 = XEXP (x19, 1);
          operands[2] = x21;
          operands[3] = x16;
          operands[4] = x17;
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 447; /* atomic_fetch_subqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 452; /* atomic_fetch_subhi_hard_1 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern274 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 448; /* atomic_fetch_orqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 453; /* atomic_fetch_orhi_hard_1 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern274 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 449; /* atomic_fetch_xorqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 454; /* atomic_fetch_xorhi_hard_1 */

            default:
              return -1;
            }

        case AND:
          switch (pattern274 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 450; /* atomic_fetch_andqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 455; /* atomic_fetch_andhi_hard_1 */

            default:
              return -1;
            }

        case NOT:
          x20 = XEXP (x19, 0);
          switch (GET_CODE (x20))
            {
            case MEM:
              operands[2] = x16;
              operands[3] = x17;
              x22 = XEXP (x20, 0);
              if (!rtx_equal_p (x22, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern267 (x1, 
E_QImode) != 0
                      || !
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 476; /* atomic_fetch_notqi_hard */

                case E_HImode:
                  if (pattern267 (x1, 
E_HImode) != 0
                      || !
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 477; /* atomic_fetch_nothi_hard */

                default:
                  return -1;
                }

            case AND:
              x22 = XEXP (x20, 0);
              if (GET_CODE (x22) != MEM)
                return -1;
              x23 = XEXP (x20, 1);
              operands[2] = x23;
              operands[3] = x16;
              operands[4] = x17;
              switch (pattern269 (x1))
                {
                case 0:
                  if (!
#line 1361 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 555; /* atomic_fetch_nandqi_hard_1 */

                case 1:
                  if (!
#line 1361 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 556; /* atomic_fetch_nandhi_hard_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern116 (x1, 
PLUS))
        {
        case 0:
          if (pattern286 (x1, 
E_QImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 589; /* atomic_add_fetchqi_hard_1 */

        case 1:
          if (pattern286 (x1, 
E_HImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 594; /* atomic_add_fetchhi_hard_1 */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern116 (x1, 
MINUS))
        {
        case 0:
          if (pattern287 (x1, 
E_QImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 590; /* atomic_sub_fetchqi_hard_1 */

        case 1:
          if (pattern287 (x1, 
E_HImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 595; /* atomic_sub_fetchhi_hard_1 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern119 (x1, 
IOR))
        {
        case 0:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 591; /* atomic_or_fetchqi_hard_1 */

        case 1:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 596; /* atomic_or_fetchhi_hard_1 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern119 (x1, 
XOR))
        {
        case 0:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 592; /* atomic_xor_fetchqi_hard_1 */

        case 1:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 597; /* atomic_xor_fetchhi_hard_1 */

        default:
          return -1;
        }

    case AND:
      switch (pattern119 (x1, 
AND))
        {
        case 0:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 593; /* atomic_and_fetchqi_hard_1 */

        case 1:
          if (!
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          return 598; /* atomic_and_fetchhi_hard_1 */

        default:
          return -1;
        }

    case NOT:
      x13 = XEXP (x3, 1);
      if (pattern61 (x13, 
NOT) != 0
          || pattern143 (x1) != 0)
        return -1;
      x12 = XEXP (x4, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 0
          || GET_MODE (x12) != E_SImode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x16 = XEXP (x5, 0);
      if (!scratch_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x6, 0);
      if (!scratch_operand (x17, E_SImode))
        return -1;
      switch (pattern161 (x1))
        {
        case 0:
          x15 = XEXP (x7, 0);
          x24 = XEXP (x15, 0);
          operands[1] = x24;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x16;
          operands[3] = x17;
          switch (pattern281 (x1))
            {
            case 0:
              if (!
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 599; /* atomic_not_fetchqi_hard */

            case 1:
              if (!
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 600; /* atomic_not_fetchhi_hard */

            default:
              return -1;
            }

        case 1:
          x15 = XEXP (x7, 0);
          x24 = XEXP (x15, 0);
          x25 = XEXP (x24, 0);
          operands[1] = x25;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x26 = XEXP (x15, 1);
          operands[2] = x26;
          operands[3] = x16;
          operands[4] = x17;
          x19 = XVECEXP (x13, 0, 0);
          x20 = XEXP (x19, 0);
          x22 = XEXP (x20, 0);
          x27 = XEXP (x22, 0);
          if (!rtx_equal_p (x27, operands[1]))
            return -1;
          x23 = XEXP (x20, 1);
          if (!rtx_equal_p (x23, operands[2]))
            return -1;
          x14 = XEXP (x3, 0);
          x18 = XEXP (x14, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern288 (x1, 
E_QImode) != 0
                  || !
#line 2024 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 658; /* atomic_nand_fetchqi_hard_1 */

            case E_HImode:
              if (pattern288 (x1, 
E_HImode) != 0
                  || !
#line 2024 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              return 659; /* atomic_nand_fetchhi_hard_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x15 = XEXP (x7, 0);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_QImode)
        return -1;
      x28 = XEXP (x7, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 147
          || GET_MODE (x8) != E_SImode
          || pattern197 (x1) != 0)
        return -1;
      x14 = XEXP (x3, 0);
      x18 = XEXP (x14, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return -1;
      x29 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x29))
        {
        case USE:
          if (pattern270 (x1) != 0)
            return -1;
          x30 = XEXP (x29, 0);
          operands[2] = x30;
          if (!gbr_displacement (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x4, 0);
          operands[3] = x12;
          if (!scratch_operand (operands[3], E_QImode)
              || !
#line 2207 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB && !TARGET_ENABLE_TAS))
            return -1;
          return 671; /* atomic_test_and_set_soft_tcb */

        case CLOBBER:
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 0
              || GET_MODE (x30) != E_SImode)
            return -1;
          x12 = XEXP (x4, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x5, 0);
          operands[3] = x16;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x17 = XEXP (x6, 0);
          operands[4] = x17;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 2252 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && !TARGET_ENABLE_TAS))
            return -1;
          return 673; /* atomic_test_and_set_hard */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (arith_reg_dest (operands[0], E_SImode))
    {
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (arith_reg_operand (operands[1], E_QImode)
              && (
#line 4809 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4811 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
            return gen_split_109 (insn, operands);
          break;

        case E_HImode:
          if (arith_reg_operand (operands[1], E_HImode)
              && (
#line 4809 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4811 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
            return gen_split_110 (insn, operands);
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode)
          || !
#line 7814 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return NULL;
      return gen_split_145 (insn, operands);

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode)
          || !
#line 7814 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return NULL;
      return gen_split_146 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (arith_reg_or_0_operand (operands[2], E_SImode)
      && arith_reg_operand (operands[1], E_SImode))
    {
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (treg_set_expr (operands[3], E_VOIDmode)
          && (
#line 1581 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1583 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_31 (insn, operands);
    }
  if (!arith_reg_operand (operands[2], E_SImode)
      || !treg_set_expr (operands[1], E_VOIDmode))
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!arith_reg_operand (operands[3], E_SImode)
      || !(
#line 1621 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1623 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_32 (insn, operands);
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG
      && REGNO (x3) == 147
      && GET_MODE (x3) == E_SImode)
    {
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
    }
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode))
    return NULL;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return NULL;
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (arith_reg_operand (operands[1], E_SImode))
    {
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (arith_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x3;
          if (scratch_operand (operands[3], E_SImode)
              && (
#line 1832 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 1837 "../../gcc/config/sh/sh.md"
( reload_completed)))
            return gen_split_43 (insn, operands);
        }
    }
  if (treg_set_expr (operands[1], E_VOIDmode)
      && pattern132 (x1) == 0
      && (
#line 1739 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1741 "../../gcc/config/sh/sh.md"
( 1)))
    return gen_split_39 (insn, operands);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return NULL;
  if (GET_MODE (x7) == E_SImode)
    {
      switch (pattern164 (x6))
        {
        case 0:
          if ((
#line 1752 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1754 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_40 (insn, operands);
          break;

        case 1:
          if ((
#line 2033 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2035 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_49 (insn, operands);
          break;

        case 2:
          if ((
#line 2106 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 2108 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_52 (insn, operands);
          break;

        case 3:
          if ((
#line 8314 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 8316 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_159 (insn, operands);
          break;

        default:
          break;
        }
    }
  x8 = XEXP (x6, 1);
  if (GET_CODE (x8) != CONST_INT
      || XWINT (x8, 0) != 2147483647L)
    return NULL;
  operands[1] = x7;
  if (!treg_set_expr (operands[1], E_VOIDmode)
      || !(
#line 8328 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 8330 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_160 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case ASHIFTRT:
          if (pattern46 (x1) != 0
              || !arith_reg_dest (operands[0], E_SImode))
            return NULL;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!arith_reg_operand (operands[1], E_SImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!symbol_ref_operand (operands[2], E_SImode)
              || !(
#line 3841 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 3843 "../../gcc/config/sh/sh.md"
( 1)))
            return NULL;
          return gen_split_86 (insn, operands);

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x4;
          switch (pattern93 (x1))
            {
            case 0:
              if (!
#line 6175 "../../gcc/config/sh/sh.md"
(reload_completed
   && sh_movsf_ie_ra_split_p (operands[0], operands[1], operands[2])))
                return NULL;
              return gen_split_127 (insn, operands);

            case 1:
              x8 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return NULL;
              x10 = XEXP (x8, 1);
              x11 = XVECEXP (x10, 0, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                case SIGN_EXTEND:
                  operands[2] = x11;
                  if (pattern168 (x1) != 0)
                    return NULL;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (pattern215 (x10, 
E_QImode) != 0
                          || !(
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 558 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_197 (insn, operands);

                    case E_HImode:
                      if (pattern215 (x10, 
E_HImode) != 0
                          || !(
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 558 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_198 (insn, operands);

                    default:
                      return NULL;
                    }

                case PLUS:
                  switch (pattern177 (x1))
                    {
                    case 0:
                      if (!(
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 781 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_199 (insn, operands);

                    case 1:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_205 (insn, operands);

                    case 2:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_210 (insn, operands);

                    case 3:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_263 (insn, operands);

                    case 4:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_268 (insn, operands);

                    case 5:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_273 (insn, operands);

                    default:
                      return NULL;
                    }

                case MINUS:
                  switch (pattern180 (x1))
                    {
                    case 0:
                      if (!(
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 781 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_200 (insn, operands);

                    case 1:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_206 (insn, operands);

                    case 2:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_211 (insn, operands);

                    case 3:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_264 (insn, operands);

                    case 4:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_269 (insn, operands);

                    case 5:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_274 (insn, operands);

                    default:
                      return NULL;
                    }

                case IOR:
                  switch (pattern182 (x1))
                    {
                    case 0:
                      if (!(
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 781 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_201 (insn, operands);

                    case 1:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_207 (insn, operands);

                    case 2:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_212 (insn, operands);

                    case 3:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_265 (insn, operands);

                    case 4:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_270 (insn, operands);

                    case 5:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_275 (insn, operands);

                    default:
                      return NULL;
                    }

                case XOR:
                  switch (pattern182 (x1))
                    {
                    case 0:
                      if (!(
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 781 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_202 (insn, operands);

                    case 1:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_208 (insn, operands);

                    case 2:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_213 (insn, operands);

                    case 3:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_266 (insn, operands);

                    case 4:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_271 (insn, operands);

                    case 5:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_276 (insn, operands);

                    default:
                      return NULL;
                    }

                case AND:
                  switch (pattern182 (x1))
                    {
                    case 0:
                      if (!(
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 781 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_203 (insn, operands);

                    case 1:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_209 (insn, operands);

                    case 2:
                      if (!(
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 832 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_214 (insn, operands);

                    case 3:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_267 (insn, operands);

                    case 4:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_272 (insn, operands);

                    case 5:
                      if (!(
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1203 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_277 (insn, operands);

                    default:
                      return NULL;
                    }

                case NOT:
                  switch (pattern186 (x1))
                    {
                    case 0:
                      if (!(
#line 798 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 807 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_204 (insn, operands);

                    case 1:
                      if (!(
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1232 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_278 (insn, operands);

                    case 2:
                      if (!(
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1232 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_279 (insn, operands);

                    case 3:
                      if (!(
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1232 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_280 (insn, operands);

                    case 4:
                      if (!(
#line 1292 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 1302 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_281 (insn, operands);

                    case 5:
                      if (!(
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1328 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_282 (insn, operands);

                    case 6:
                      if (!(
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1328 "../../gcc/config/sh/sync.md"
( 1)))
                        return NULL;
                      return gen_split_283 (insn, operands);

                    case 7:
                      if (!(
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1555 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_292 (insn, operands);

                    case 8:
                      if (!(
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1555 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_293 (insn, operands);

                    case 9:
                      if (!(
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK) && 
#line 1555 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                        return NULL;
                      return gen_split_294 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CALL:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != USE
              || pattern45 (x1, 
RETURN, 
1, 
154) != 0)
            return NULL;
          x12 = XEXP (x5, 0);
          operands[1] = x12;
          if (!symbol_ref_operand (operands[1], E_SImode))
            return NULL;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (!
#line 7046 "../../gcc/config/sh/sh.md"
(reload_completed))
            return NULL;
          return gen_split_136 (insn, operands);

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || pattern94 (x1) != 0)
            return NULL;
          if (
#line 7933 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2 && reload_completed))
            return gen_split_153 (insn, operands);
          if (!
#line 7952 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && reload_completed))
            return NULL;
          return gen_split_154 (insn, operands);

        case UNSPEC_VOLATILE:
          if (pattern36 (x1) != 0
              || pattern147 (x1, 
E_SImode, 
0, 
147) != 0
              || !arith_reg_dest (operands[0], E_SImode))
            return NULL;
          x14 = XVECEXP (x4, 0, 0);
          operands[1] = x14;
          x15 = XVECEXP (x4, 0, 1);
          operands[2] = x15;
          x16 = XVECEXP (x4, 0, 2);
          operands[3] = x16;
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return NULL;
          x10 = XEXP (x8, 1);
          switch (pattern283 (x10))
            {
            case 0:
              if (!(
#line 279 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)) && 
#line 291 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && !satisfies_constraint_I08 (operands[2]))))
                return NULL;
              return gen_split_194 (insn, operands);

            case 1:
              if (!(
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 328 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_195 (insn, operands);

            case 2:
              if (!(
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 328 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_196 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (pattern77 (x1, 
PLUS) != 0)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern188 (x1, 
E_QImode) != 0
                  || !(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_295 (insn, operands);

            case E_HImode:
              if (pattern188 (x1, 
E_HImode) != 0
                  || !(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_300 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          if (pattern77 (x1, 
MINUS) != 0)
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern190 (x1, 
E_QImode) != 0
                  || !(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_296 (insn, operands);

            case E_HImode:
              if (pattern190 (x1, 
E_HImode) != 0
                  || !(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_301 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern78 (x1, 
IOR))
            {
            case 0:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_297 (insn, operands);

            case 1:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_302 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern78 (x1, 
XOR))
            {
            case 0:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_298 (insn, operands);

            case 1:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_303 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern78 (x1, 
AND))
            {
            case 0:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_299 (insn, operands);

            case 1:
              if (!(
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1662 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_304 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != AND)
            return NULL;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return NULL;
          x10 = XEXP (x8, 1);
          if (pattern61 (x10, 
NOT) != 0)
            return NULL;
          x11 = XVECEXP (x10, 0, 0);
          x17 = XEXP (x11, 0);
          if (GET_CODE (x17) != AND
              || pattern148 (x1) != 0)
            return NULL;
          x12 = XEXP (x5, 0);
          operands[1] = x12;
          x18 = XEXP (x5, 1);
          operands[2] = x18;
          x19 = XEXP (x17, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return NULL;
          x20 = XEXP (x17, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return NULL;
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern241 (x1, 
E_QImode) != 0
                  || !(
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1990 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_325 (insn, operands);

            case E_HImode:
              if (pattern241 (x1, 
E_HImode) != 0
                  || !(
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()) && 
#line 1990 "../../gcc/config/sh/sync.md"
( 1)))
                return NULL;
              return gen_split_326 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != USE
          || pattern97 (x1) != 0)
        return NULL;
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != RETURN)
        return NULL;
      x21 = XEXP (x3, 0);
      operands[0] = x21;
      if (!symbol_ref_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x22 = XVECEXP (x1, 0, 2);
      x23 = XEXP (x22, 0);
      operands[2] = x23;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 6880 "../../gcc/config/sh/sh.md"
(reload_completed))
        return NULL;
      return gen_split_134 (insn, operands);

    default:
      return NULL;
    }
}
