/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 5
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 4
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE)
    return -1;
  return 0;
}

int
pattern19 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 147
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!mem_index_disp_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern35 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern38 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern38 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern38 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1)
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !arith_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  return pattern61 (x6, 
i1); /* [-1, 0] */
}

int
pattern67 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern75 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 144
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[0] = x5;
      return 0;

    case REG:
      if (REGNO (x3) != 144)
        return -1;
      x6 = XEXP (x1, 1);
      operands[0] = x6;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern102 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i3
      || pattern67 (x1, 
i1, 
i2, 
USE) != 0)
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_logical_operand_1 (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern117 (x5, 
i1); /* [-1, 0] */
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[1] = x8;
  if (!arith_reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[2] = x9;
  return 0;
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MEM:
      operands[1] = x5;
      return 0;

    case AND:
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      x8 = XVECEXP (x7, 0, 0);
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != AND)
        return -1;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !treg_set_expr (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x1, 2);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      x4 = XEXP (x1, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !treg_set_expr_not_const01 (operands[1], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 154
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 12)
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_logical_operand_1 (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern188 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern188 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern188 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x6))
    {
    case SET:
      return pattern195 (x6); /* [-1, 2] */

    case CLOBBER:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x4, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!atomic_mem_operand_1 (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern212 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!gbr_displacement (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      return pattern183 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern183 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern183 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x8))
    {
    case SET:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 149
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      x12 = XEXP (x9, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 149
          || GET_MODE (x10) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !atomic_logical_operand_1 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  return pattern117 (x4, 
i1); /* [-1, 0] */
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 4);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 5);
  x10 = XEXP (x9, 0);
  operands[4] = x10;
  return pattern252 (x1); /* [-1, 1] */
}

int
pattern282 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!atomic_mem_operand_0 (operands[1], i1)
      || !arith_reg_operand (operands[2], i1)
      || !arith_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_operand (operands[2], i1)
      || !arith_reg_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case GE:
      if (pattern57 (x1, 
0) != 0
          || !
#line 1017 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 17; /* *cmp_div0s_1 */

    case LSHIFTRT:
      if (pattern57 (x1, 
31) != 0
          || !
#line 1066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 21; /* *cmp_div0s_5 */

    case REG:
    case SUBREG:
    case NE:
    case EQ:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      operands[1] = x3;
      if (arith_reg_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (arith_reg_dest (operands[0], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (logical_operand (operands[2], E_SImode)
                  && 
#line 2814 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 92; /* xorsi3 */
            }
        }
      if (!t_reg_operand (x3, E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (arith_reg_dest (operands[0], E_SImode))
        {
          operands[1] = x3;
          if (
#line 8167 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return 289; /* movrt */
          if (pnum_clobbers != NULL
              && 
#line 8266 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_SH2A))
            {
              *pnum_clobbers = 2;
              return 291; /* *movrt_negc */
            }
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      operands[0] = x3;
      if (!
#line 8447 "../../gcc/config/sh/sh.md"
(TARGET_SH2A || (TARGET_SH1 && can_create_pseudo_p ())))
        return -1;
      return 298; /* nott */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (pnum_clobbers != NULL)
        {
          operands[2] = x5;
          if (const_int_operand (operands[2], E_SImode)
              && arith_reg_dest (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode
              && arith_reg_operand (operands[1], E_SImode)
              && 
#line 3800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && INTVAL (operands[2]) == 1))
            {
              *pnum_clobbers = 1;
              return 128; /* ashrsi3_k */
            }
        }
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arith_reg_operand (operands[1], E_SImode)
              || !
#line 3808 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 129; /* ashrsi2_16 */

        case 31L:
          if (pattern58 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 3822 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          *pnum_clobbers = 1;
          return 130; /* ashrsi2_31 */

        case 1L:
          if (pattern58 (x3, pnum_clobbers, 
E_DImode) != 0
              || !
#line 3889 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          *pnum_clobbers = 1;
          return 134; /* ashrdi3_k */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x5) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 3851 "../../gcc/config/sh/sh.md"
(TARGET_DYNSHIFT))
        return -1;
      return 132; /* ashrsi3_d */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (general_movdst_operand (operands[0], E_SImode)
          && general_movsrc_operand (operands[1], E_SImode))
        {
          if (
#line 5118 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FPU_ANY
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 188; /* movsi_i */
          if (
#line 5174 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_FPU_ANY
   && ((register_operand (operands[0], SImode)
	&& !fpscr_operand (operands[0], SImode))
       || (register_operand (operands[1], SImode)
	   && !fpscr_operand (operands[1], SImode)))))
            return 189; /* movsi_ie */
        }
      if (arith_reg_dest (operands[0], E_SImode)
          && pre_dec_mem (operands[1], E_SImode)
          && 
#line 5354 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 196; /* *movsi_load_predec */
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_SImode)
          && immediate_operand (operands[1], E_SImode)
          && 
#line 6290 "../../gcc/config/sh/sh.md"
(TARGET_SH2E
   && (reload_in_progress || reload_completed)))
        {
          *pnum_clobbers = 1;
          return 216; /* *movsi_y */
        }
      break;

    case E_QImode:
      if (general_movdst_operand (operands[0], E_QImode)
          && general_movsrc_operand (operands[1], E_QImode)
          && 
#line 5433 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (arith_reg_operand (operands[0], QImode)
       || arith_reg_operand (operands[1], QImode))))
        return 208; /* *movqi */
      break;

    case E_HImode:
      if (general_movdst_operand (operands[0], E_HImode)
          && general_movsrc_operand (operands[1], E_HImode)
          && 
#line 5433 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (arith_reg_operand (operands[0], HImode)
       || arith_reg_operand (operands[1], HImode))))
        return 209; /* *movhi */
      break;

    case E_DImode:
      if (general_movdst_operand (operands[0], E_DImode)
          && general_movsrc_operand (operands[1], E_DImode)
          && 
#line 5459 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (arith_reg_operand (operands[0], DImode)
       || arith_reg_operand (operands[1], DImode))))
        return 210; /* *movdi_i */
      if (arith_reg_dest (operands[0], E_DImode)
          && gbr_address_mem (operands[1], E_DImode)
          && 
#line 7755 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 276; /* *movdi_gbr_load */
      if (gbr_address_mem (operands[0], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7773 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 277; /* *movdi_gbr_store */
      break;

    case E_DFmode:
      if (general_movdst_operand (operands[0], E_DFmode)
          && general_movsrc_operand (operands[1], E_DFmode)
          && 
#line 5549 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (!TARGET_FPU_DOUBLE || reload_completed
       /* ??? We provide some insn so that direct_{load,store}[DFmode] get set */
       || (REG_P (operands[0]) && REGNO (operands[0]) == 3)
       || (REG_P (operands[1]) && REGNO (operands[1]) == 3))
   && (arith_reg_operand (operands[0], DFmode)
       || arith_reg_operand (operands[1], DFmode))))
        return 211; /* movdf_k */
      break;

    case E_SFmode:
      if (general_movdst_operand (operands[0], E_SFmode)
          && general_movsrc_operand (operands[1], E_SFmode)
          && 
#line 6028 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (! TARGET_SH2E
       /* ??? We provide some insn so that direct_{load,store}[SFmode] get set */
       || (REG_P (operands[0]) && REGNO (operands[0]) == 3)
       || (REG_P (operands[1]) && REGNO (operands[1]) == 3))
   && (arith_reg_operand (operands[0], SFmode)
       || arith_reg_operand (operands[1], SFmode))))
        return 213; /* movsf_i */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (pattern82 (x1))
    {
    case 0:
      operands[1] = x3;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!gbr_displacement (operands[0], E_QImode)
              || !register_operand (operands[1], E_QImode)
              || !
#line 7736 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 270; /* *movqi_gbr_store */

        case E_HImode:
          if (!gbr_displacement (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode)
              || !
#line 7736 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 271; /* *movhi_gbr_store */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (x2))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || !
#line 7743 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 273; /* *movqi_gbr_store */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !
#line 7743 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 274; /* *movhi_gbr_store */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (arith_reg_operand (operands[1], E_SImode))
    {
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 147
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (arith_reg_or_0_operand (operands[2], E_SImode)
      && arith_reg_operand (operands[1], E_SImode))
    {
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      if (treg_set_expr (operands[3], E_VOIDmode)
          && 
#line 1581 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 38; /* *addc */
    }
  if (!arith_reg_operand (operands[2], E_SImode)
      || !treg_set_expr (operands[1], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!arith_reg_operand (operands[3], E_SImode)
      || !
#line 1621 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  return 39; /* *addc */
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  switch (pattern133 (x7, 
1, 
AND))
    {
    case 0:
      if (!
#line 2893 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 96; /* rotrsi3_1 */

    case 1:
      if (!
#line 2903 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 97; /* *rotrsi3_1 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      if (pattern85 (x4) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x7 = XEXP (x5, 1);
      if (XWINT (x7, 0) != 31L)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != ASHIFT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (pattern33 (x9, 
147, 
CLOBBER) != 0)
        return -1;
      operands[3] = x6;
      if (!arith_reg_operand (operands[3], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 3315 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 110; /* *rotcl */

    case ASHIFT:
      if (pattern85 (x4) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (XWINT (x7, 0) == 1L)
        {
          x9 = XVECEXP (x1, 0, 1);
          if (pattern156 (x9, 
31, 
LSHIFTRT) == 0)
            {
              x12 = XEXP (x9, 0);
              if (GET_CODE (x12) == REG
                  && REGNO (x12) == 147
                  && GET_MODE (x12) == E_SImode)
                {
                  x8 = XEXP (x4, 1);
                  operands[2] = x8;
                  if (t_reg_operand (operands[2], E_SImode))
                    {
                      x13 = XEXP (x9, 1);
                      x14 = XEXP (x13, 0);
                      if (rtx_equal_p (x14, operands[1])
                          && 
#line 3037 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                        return 104; /* rotcl */
                    }
                }
            }
        }
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x12 = XEXP (x9, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 147
          || GET_MODE (x12) != E_SImode)
        return -1;
      operands[2] = x7;
      if (const_int_operand (operands[2], E_SImode))
        {
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) == AND
              && GET_MODE (x8) == E_SImode)
            {
              x11 = XEXP (x8, 1);
              if (x11 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x10 = XEXP (x8, 0);
                  operands[3] = x10;
                  if (arith_reg_or_t_reg_operand (operands[3], E_SImode)
                      && 
#line 3177 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    return 106; /* *rotcl */
                }
            }
          operands[3] = x8;
          if (treg_set_expr (operands[3], E_VOIDmode)
              && 
#line 3262 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 107; /* *rotcl */
        }
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (pattern229 (x8))
        {
        case 0:
          if (!
#line 3296 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 109; /* *rotcl */

        case 1:
          if (!
#line 3335 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 111; /* *rotcl */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern124 (x1, 
E_SImode) != 0)
        return -1;
      switch (pattern192 (x4))
        {
        case 0:
          if (!
#line 3281 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 108; /* *rotcl */

        case 1:
          if (!
#line 3380 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 113; /* *rotcr */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      operands[1] = x5;
      if (!negt_reg_shl31_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != LSHIFTRT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != CLOBBER
          || pattern124 (x1, 
E_SImode) != 0)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[3] = x11;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 3414 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 115; /* *rotcr_neg_t */

    case MEM:
      switch (pattern86 (x1, pnum_clobbers, 
IOR))
        {
        case 0:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 603; /* atomic_or_fetchqi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 639; /* atomic_or_fetchqi_soft_imask */

        case 1:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 608; /* atomic_or_fetchhi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 644; /* atomic_or_fetchhi_soft_imask */

        case 2:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 613; /* atomic_or_fetchsi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 649; /* atomic_or_fetchsi_soft_imask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern89 (x6, 
155) != 0)
        return -1;
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 9199 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return -1;
          return 328; /* addsf3_i */

        case 1:
          if (!
#line 9562 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 346; /* adddf3_i */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x5) != E_SFmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || pattern67 (x1, 
154, 
155, 
USE) != 0
          || !fp_arith_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x4) != E_SFmode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!fp_arith_reg_operand (operands[1], E_SFmode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!fp_arith_reg_operand (operands[2], E_SFmode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!arith_reg_operand (operands[3], E_SFmode)
          || !
#line 9280 "../../gcc/config/sh/sh.md"
(TARGET_SH2E && flag_fp_contract_mode == FP_CONTRACT_FAST))
        return -1;
      return 332; /* *fmasf4 */

    case MEM:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern16 (x6, 
PLUS) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (pattern196 (x1))
        {
        case 0:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          operands[1] = x5;
          if (!atomic_mem_operand_1 (operands[1], E_SImode)
              || !atomic_arith_operand_1 (operands[2], E_SImode)
              || pattern69 (x6) != 0
              || !
#line 1620 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
            return -1;
          return 573; /* atomic_add_fetchsi_hard */

        case 1:
          if (pattern254 (x1, pnum_clobbers, 
E_QImode) != 0)
            return -1;
          operands[1] = x5;
          if (atomic_mem_operand_1 (operands[1], E_QImode))
            {
              x10 = XEXP (x6, 1);
              x11 = XVECEXP (x10, 0, 0);
              x12 = XEXP (x11, 0);
              if (rtx_equal_p (x12, operands[1]))
                {
                  x13 = XEXP (x6, 0);
                  if (rtx_equal_p (x13, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 579; /* atomic_add_fetchqi_hard */
                    }
                }
            }
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (pattern275 (x6, 
E_QImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 589; /* atomic_add_fetchqi_hard_1 */

        case 2:
          if (pattern254 (x1, pnum_clobbers, 
E_HImode) != 0)
            return -1;
          operands[1] = x5;
          if (atomic_mem_operand_1 (operands[1], E_HImode))
            {
              x10 = XEXP (x6, 1);
              x11 = XVECEXP (x10, 0, 0);
              x12 = XEXP (x11, 0);
              if (rtx_equal_p (x12, operands[1]))
                {
                  x13 = XEXP (x6, 0);
                  if (rtx_equal_p (x13, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 584; /* atomic_add_fetchhi_hard */
                    }
                }
            }
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (pattern275 (x6, 
E_HImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 594; /* atomic_add_fetchhi_hard_1 */

        case 3:
          x13 = XEXP (x6, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern188 (x1, 
E_QImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 637; /* atomic_add_fetchqi_soft_imask */

            case E_HImode:
              if (pattern188 (x1, 
E_HImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 642; /* atomic_add_fetchhi_soft_imask */

            case E_SImode:
              if (pattern188 (x1, 
E_SImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 647; /* atomic_add_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 6150 "../../gcc/config/sh/sh.md"
(TARGET_SH2E
   && (arith_reg_operand (operands[0], SFmode)
       || fpul_operand (operands[0], SFmode)
       || arith_reg_operand (operands[1], SFmode)
       || fpul_operand (operands[1], SFmode))))
        return -1;
      return 215; /* movsf_ie_ra */

    case 1:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XEXP (x4, 1);
      x7 = XVECEXP (x6, 0, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
        case TRUNCATE:
          operands[2] = x7;
          x8 = XVECEXP (x1, 0, 3);
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x10))
            {
            case SET:
              x11 = XEXP (x10, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern47 (x1, 
0, 
147) != 0)
                return -1;
              switch (pattern236 (x6))
                {
                case 0:
                  if (!
#line 532 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                    return -1;
                  return 416; /* atomic_exchangesi_hard */

                case 1:
                  if (!
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  return 417; /* atomic_exchangeqi_hard */

                case 2:
                  if (!
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  return 418; /* atomic_exchangehi_hard */

                default:
                  return -1;
                }

            case CLOBBER:
              x12 = XEXP (x10, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 0
                  || GET_MODE (x12) != E_SImode
                  || REGNO (x9) != 1)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern215 (x6, 
E_QImode) != 0
                      || !
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 421; /* atomic_exchangeqi_soft_gusa */

                case E_HImode:
                  if (pattern215 (x6, 
E_HImode) != 0
                      || !
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 422; /* atomic_exchangehi_soft_gusa */

                case E_SImode:
                  if (pattern215 (x6, 
E_SImode) != 0
                      || !
#line 606 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 423; /* atomic_exchangesi_soft_gusa */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          switch (pattern177 (x1))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 430; /* atomic_fetch_addsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 436; /* atomic_fetch_addqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 441; /* atomic_fetch_addhi_hard */

            case 3:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 534; /* atomic_fetch_addqi_soft_imask */

            case 4:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 539; /* atomic_fetch_addhi_soft_imask */

            case 5:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 544; /* atomic_fetch_addsi_soft_imask */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern180 (x1))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 431; /* atomic_fetch_subsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 437; /* atomic_fetch_subqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 442; /* atomic_fetch_subhi_hard */

            case 3:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 535; /* atomic_fetch_subqi_soft_imask */

            case 4:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 540; /* atomic_fetch_subhi_soft_imask */

            case 5:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 545; /* atomic_fetch_subsi_soft_imask */

            default:
              return -1;
            }

        case IOR:
          switch (pattern182 (x1))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 432; /* atomic_fetch_orsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 438; /* atomic_fetch_orqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 443; /* atomic_fetch_orhi_hard */

            case 3:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 536; /* atomic_fetch_orqi_soft_imask */

            case 4:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 541; /* atomic_fetch_orhi_soft_imask */

            case 5:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 546; /* atomic_fetch_orsi_soft_imask */

            default:
              return -1;
            }

        case XOR:
          switch (pattern182 (x1))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 433; /* atomic_fetch_xorsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 439; /* atomic_fetch_xorqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 444; /* atomic_fetch_xorhi_hard */

            case 3:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 537; /* atomic_fetch_xorqi_soft_imask */

            case 4:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 542; /* atomic_fetch_xorhi_soft_imask */

            case 5:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 547; /* atomic_fetch_xorsi_soft_imask */

            default:
              return -1;
            }

        case AND:
          switch (pattern182 (x1))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 434; /* atomic_fetch_andsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 440; /* atomic_fetch_andqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 445; /* atomic_fetch_andhi_hard */

            case 3:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 538; /* atomic_fetch_andqi_soft_imask */

            case 4:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 543; /* atomic_fetch_andhi_soft_imask */

            case 5:
              if (!
#line 1191 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 548; /* atomic_fetch_andsi_soft_imask */

            default:
              return -1;
            }

        case NOT:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 798 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 435; /* atomic_fetch_notsi_hard */

            case 1:
              if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 549; /* atomic_fetch_notqi_soft_imask */

            case 2:
              if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 550; /* atomic_fetch_nothi_soft_imask */

            case 3:
              if (!
#line 1220 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 551; /* atomic_fetch_notsi_soft_imask */

            case 4:
              if (!
#line 1292 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 552; /* atomic_fetch_nandsi_hard */

            case 5:
              if (!
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 553; /* atomic_fetch_nandqi_hard */

            case 6:
              if (!
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 554; /* atomic_fetch_nandhi_hard */

            case 7:
              if (!
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 570; /* atomic_fetch_nandqi_soft_imask */

            case 8:
              if (!
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 571; /* atomic_fetch_nandhi_soft_imask */

            case 9:
              if (!
#line 1542 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 572; /* atomic_fetch_nandsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arith_reg_dest (operands[0], E_SImode))
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case MINUS:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !(
#line 1649 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 1651 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_34 (insn, operands);

    case AND:
      if (pattern103 (x4, 
1, 
PLUS) != 0)
        return NULL;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return NULL;
      x6 = XEXP (x4, 0);
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 1688 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return NULL;
      return gen_split_36 (insn, operands);

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_or_int_operand (operands[2], E_SImode))
        {
          if ((
#line 1810 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_lra_p ()
   && (! reg_overlap_mentioned_p (operands[0], operands[1])
       || arith_operand (operands[2], SImode))) && 
#line 1816 "../../gcc/config/sh/sh.md"
( reload_completed
   && ! reg_overlap_mentioned_p (operands[0], operands[1]))))
            return gen_split_42 (insn, operands);
          if ((
#line 1882 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !sh_lra_p ()
   && (reload_completed || reload_in_progress)
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && (!reload_in_progress
       || ((!REG_P (operands[1]) || REGNO (operands[1]) != SP_REG)
	   && (!REG_P (operands[2]) || REGNO (operands[2]) != SP_REG)))) && 
#line 1889 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_44 (insn, operands);
        }
      if (!arith_operand (operands[2], E_SImode)
          || !(
#line 1918 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !sh_lra_p ()) && 
#line 1922 "../../gcc/config/sh/sh.md"
( operands[2] == const0_rtx)))
        return NULL;
      return gen_split_45 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (arith_reg_dest (operands[0], E_SImode))
    {
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (arith_reg_operand (operands[1], E_QImode)
              && (
#line 4695 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4697 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
            return gen_split_107 (insn, operands);
          break;

        case E_HImode:
          if (arith_reg_operand (operands[1], E_HImode)
              && (
#line 4695 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4697 "../../gcc/config/sh/sh.md"
( can_create_pseudo_p ())))
            return gen_split_108 (insn, operands);
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode)
          || !
#line 7830 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return NULL;
      return gen_split_147 (insn, operands);

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode)
          || !
#line 7830 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && !reload_in_progress && !reload_completed
   && df_regs_ever_live_p (GBR_REG)))
        return NULL;
      return gen_split_148 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern33 (x2, 
147, 
CLOBBER) != 0)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NE:
      if (pattern130 (x3) == 0
          && 
#line 1206 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return gen_split_23 (insn, operands);
      break;

    case LE:
      if (pattern130 (x3) == 0
          && 
#line 1221 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return gen_split_24 (insn, operands);
      break;

    case LT:
      if (pattern130 (x3) == 0
          && 
#line 1234 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return gen_split_25 (insn, operands);
      break;

    case LEU:
      if (pattern131 (x3) == 0
          && 
#line 1247 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return gen_split_26 (insn, operands);
      break;

    case LTU:
      if (pattern131 (x3) == 0
          && 
#line 1260 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return gen_split_27 (insn, operands);
      break;

    case EQ:
      if (GET_MODE (x5) == E_SImode
          && pattern90 (x4) == 0
          && pattern202 (x3) == 0
          && (
#line 4554 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 4556 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_104 (insn, operands);
      break;

    default:
      break;
    }
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x4) != E_SImode)
    return NULL;
  switch (pattern157 (x4))
    {
    case 0:
      if (!(
#line 8357 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && ((INTVAL (operands[2]) == -2147483648LL
	&& INTVAL (operands[3]) == 2147483647LL)
       || (INTVAL (operands[2]) == 2147483647LL
	   && INTVAL (operands[3]) == -2147483648LL))) && 
#line 8363 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_161 (insn, operands);

    case 1:
      if (!(
#line 8556 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH && can_create_pseudo_p ()) && 
#line 8558 "../../gcc/config/sh/sh.md"
( 1)))
        return NULL;
      return gen_split_167 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x5;
      if (arith_reg_operand (operands[1], E_DImode)
          && arith_reg_dest (operands[0], E_DImode)
          && GET_MODE (x4) == E_DImode)
        {
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (arith_reg_operand (operands[2], E_DImode)
              && (
#line 1545 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1547 "../../gcc/config/sh/sh.md"
( 1)))
            return gen_split_30 (insn, operands);
        }
      break;

    case PLUS:
      res = split_9 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x4) != E_SImode)
    return NULL;
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (pattern170 (x6) == 0
          && (
#line 1634 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1636 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_33 (insn, operands);
      break;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[2] = x6;
      if (arith_reg_operand (operands[2], E_SImode)
          && treg_set_expr_not_const01 (operands[1], E_VOIDmode)
          && (
#line 1713 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1715 "../../gcc/config/sh/sh.md"
( 1)))
        return gen_split_37 (insn, operands);
      break;

    default:
      break;
    }
  if (!arith_reg_operand (operands[1], E_SImode))
    return NULL;
  operands[2] = x6;
  if (!treg_set_expr_not_const01 (operands[2], E_VOIDmode)
      || !(
#line 1725 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()) && 
#line 1727 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_38 (insn, operands);
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || pattern21 (x4, 
E_DImode, 
ZERO_EXTEND, 
MULT) != 0)
    return NULL;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != ZERO_EXTEND
      || GET_MODE (x6) != E_DImode)
    return NULL;
  x7 = XEXP (x4, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  if (pattern33 (x8, 
149, 
CLOBBER) != 0)
    return NULL;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!arith_reg_dest (operands[0], E_SImode))
    return NULL;
  x10 = XEXP (x5, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!arith_reg_operand (operands[1], E_SImode))
    return NULL;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  if (!arith_reg_operand (operands[2], E_SImode)
      || !(
#line 2718 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()) && 
#line 2720 "../../gcc/config/sh/sh.md"
( 1)))
    return NULL;
  return gen_split_59 (insn, operands);
}

 rtx_insn *
split_18 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case CALL:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE
          || pattern67 (x1, 
12, 
154, 
USE) != 0)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!symbol_ref_operand (operands[0], E_SImode))
        return NULL;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) == REG
          && pattern233 (x1) == 0
          && 
#line 6569 "../../gcc/config/sh/sh.md"
(reload_completed))
        return gen_split_132 (insn, operands);
      x9 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x9) != RETURN)
        return NULL;
      operands[2] = x8;
      if (!scratch_operand (operands[2], E_SImode)
          || !(
#line 6905 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC) && 
#line 6907 "../../gcc/config/sh/sh.md"
( reload_completed)))
        return NULL;
      return gen_split_135 (insn, operands);

    case SET:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CALL:
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_SImode)
            return NULL;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE
              || pattern67 (x1, 
12, 
154, 
USE) != 0)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!symbol_ref_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x7, 1);
          operands[2] = x12;
          switch (pattern256 (x1))
            {
            case 0:
              if (!
#line 6681 "../../gcc/config/sh/sh.md"
(reload_completed))
                return NULL;
              return gen_split_133 (insn, operands);

            case 1:
              if (!(
#line 7076 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC) && 
#line 7078 "../../gcc/config/sh/sh.md"
( reload_completed)))
                return NULL;
              return gen_split_137 (insn, operands);

            default:
              return NULL;
            }

        case MEM:
          operands[1] = x7;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern74 (x5) != 0
              || REGNO (x8) != 0)
            return NULL;
          x9 = XVECEXP (x1, 0, 4);
          if (pattern198 (x9, 
1) != 0)
            return NULL;
          x13 = XEXP (x5, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return NULL;
          x14 = XEXP (x5, 1);
          x15 = XVECEXP (x14, 0, 0);
          switch (GET_CODE (x15))
            {
            case PLUS:
              switch (pattern245 (x1))
                {
                case 0:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_227 (insn, operands);

                case 1:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_232 (insn, operands);

                case 2:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_237 (insn, operands);

                case 3:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 4:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_250 (insn, operands);

                case 5:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_255 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern247 (x1))
                {
                case 0:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_228 (insn, operands);

                case 1:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_233 (insn, operands);

                case 2:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_238 (insn, operands);

                case 3:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 4:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_251 (insn, operands);

                case 5:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern209 (x1))
                {
                case 0:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_229 (insn, operands);

                case 1:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_234 (insn, operands);

                case 2:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_239 (insn, operands);

                case 3:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_247 (insn, operands);

                case 4:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_252 (insn, operands);

                case 5:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_257 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern209 (x1))
                {
                case 0:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_230 (insn, operands);

                case 1:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_235 (insn, operands);

                case 2:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_240 (insn, operands);

                case 3:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_248 (insn, operands);

                case 4:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_253 (insn, operands);

                case 5:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_258 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern209 (x1))
                {
                case 0:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_231 (insn, operands);

                case 1:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_236 (insn, operands);

                case 2:
                  if (!(
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1031 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 3:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_249 (insn, operands);

                case 4:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_254 (insn, operands);

                case 5:
                  if (!(
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1095 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_259 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              switch (pattern250 (x1))
                {
                case 0:
                  if (!(
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1060 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_242 (insn, operands);

                case 1:
                  if (!(
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1060 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 2:
                  if (!(
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1060 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 3:
                  if (!(
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1151 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_260 (insn, operands);

                case 4:
                  if (!(
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1151 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_261 (insn, operands);

                case 5:
                  if (!(
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1151 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_262 (insn, operands);

                case 6:
                  if (!(
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1462 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_286 (insn, operands);

                case 7:
                  if (!(
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1462 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_287 (insn, operands);

                case 8:
                  if (!(
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA) && 
#line 1462 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_288 (insn, operands);

                case 9:
                  if (!(
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1497 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_289 (insn, operands);

                case 10:
                  if (!(
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1497 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_290 (insn, operands);

                case 11:
                  if (!(
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1497 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                    return NULL;
                  return gen_split_291 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case PLUS:
          if (pattern121 (x1, 
PLUS) != 0)
            return NULL;
          switch (pattern238 (x1))
            {
            case 0:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_307 (insn, operands);

            case 1:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_312 (insn, operands);

            case 2:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_317 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          if (pattern121 (x1, 
MINUS) != 0)
            return NULL;
          switch (pattern239 (x1))
            {
            case 0:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_308 (insn, operands);

            case 1:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_313 (insn, operands);

            case 2:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern122 (x1, 
IOR))
            {
            case 0:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_309 (insn, operands);

            case 1:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_314 (insn, operands);

            case 2:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_319 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern122 (x1, 
XOR))
            {
            case 0:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_310 (insn, operands);

            case 1:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_315 (insn, operands);

            case 2:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_320 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern122 (x1, 
AND))
            {
            case 0:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_311 (insn, operands);

            case 1:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_316 (insn, operands);

            case 2:
              if (!(
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1829 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_321 (insn, operands);

            default:
              return NULL;
            }

        case NOT:
          if (pattern121 (x1, 
NOT) != 0)
            return NULL;
          switch (pattern243 (x1))
            {
            case 0:
              if (!(
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1860 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_322 (insn, operands);

            case 1:
              if (!(
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1860 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_323 (insn, operands);

            case 2:
              if (!(
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 1860 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_324 (insn, operands);

            case 3:
              if (!(
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 2094 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_327 (insn, operands);

            case 4:
              if (!(
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 2094 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_328 (insn, operands);

            case 5:
              if (!(
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB) && 
#line 2094 "../../gcc/config/sh/sync.md"
( can_create_pseudo_p () && optimize
   && sh_reg_dead_or_unused_after_insn (insn, REGNO (operands[0])))))
                return NULL;
              return gen_split_329 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
