/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode
      || pattern3 (x1) != 0)
    return -1;
  return 0;
}

int
pattern10 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!arith_reg_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!arith_reg_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 155
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 154
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !atomic_mem_operand_1 (operands[1], i1)
      || !atomic_logical_operand_1 (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 33
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  return 0;
}

int
pattern49 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x15))
    {
    case SET:
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x15, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 147
          || GET_MODE (x17) != E_SImode
          || REGNO (x6) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern38 (x1, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern38 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      x17 = XEXP (x15, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 0
          || GET_MODE (x17) != E_SImode
          || REGNO (x6) != 1)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern38 (x1, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern38 (x1, 
E_HImode) != 0)
            return -1;
          return 3;

        case E_SImode:
          if (pattern38 (x1, 
E_SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  return 0;
}

int
pattern89 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case USE:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 154
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !general_movdst_operand (operands[0], E_SFmode)
          || !general_movsrc_operand (operands[1], E_SFmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!scratch_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case SET:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 33)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != MEM)
    return -1;
  x7 = XEXP (x4, 1);
  operands[1] = x7;
  return pattern111 (x1); /* [-1, 2] */
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern122 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 1)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != USE)
    return -1;
  return pattern40 (x1); /* [-1, 2] */
}

int
pattern134 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SMIN:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!arith_reg_or_0_or_1_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case SMAX:
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      if (!arith_reg_or_0_or_1_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case UMIN:
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case AND:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LSHIFTRT
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 65280L)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case ZERO_EXTRACT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x8 = XEXP (x6, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_arith_operand_1 (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern190 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !atomic_mem_operand_1 (operands[1], i1)
      || !arith_reg_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!atomic_mem_operand_1 (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!atomic_mem_operand_1 (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!atomic_mem_operand_1 (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern203 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern203 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern203 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_0 (operands[1], i1)
      || GET_MODE (x1) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XEXP (x2, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern203 (x1, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern203 (x1, 
E_HImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XEXP (x2, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern205 (x1, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_HImode:
          if (pattern205 (x1, 
E_HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case IOR:
      res = pattern221 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case XOR:
      res = pattern221 (x1);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case AND:
      res = pattern221 (x1);
      if (res >= 0)
        return res + 8; /* [8, 9] */
      return -1;

    case NOT:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != AND)
        return -1;
      x5 = XEXP (x4, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!atomic_mem_operand_1 (operands[0], E_QImode)
              || pattern216 (x1, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_HImode:
          if (!atomic_mem_operand_1 (operands[0], E_HImode)
              || pattern216 (x1, 
E_HImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !arith_reg_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern256 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  switch (REGNO (x3))
    {
    case 146:
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case 1:
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != RETURN)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 4);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  x11 = XEXP (x5, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_QImode:
      return pattern264 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern264 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern279 (rtx x1, rtx_code i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x12) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (XWINT (x4, 0))
        {
        case 1L:
          x7 = XEXP (x2, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -2]
              || !arith_reg_operand (operands[1], E_SImode)
              || !
#line 1668 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_SH2A && can_create_pseudo_p ()
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
            return -1;
          return 42; /* *round_int_even */

        case -1L:
          if (!t_reg_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (!arith_reg_operand (operands[2], E_SImode)
              || !
#line 8520 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH))
            return -1;
          return 301; /* *cset_zero */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x3;
      if (arith_reg_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (arith_reg_dest (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode)
            {
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              if (logical_and_operand (operands[2], E_SImode)
                  && 
#line 2762 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 88; /* *andsi_compact */
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 2784 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_Psz (operands[2])))
                return 89; /* *andsi3_bclr */
            }
        }
      operands[0] = x3;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern53 (x1, 
147) != 0
          || !
#line 2850 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 94; /* *reg_lsb_t */

    case ASHIFT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4152 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && shl_and_kind (operands[2], operands[3], 0) == 1))
        {
          *pnum_clobbers = 1;
          return 142; /* *sh.md:4146 */
        }
      if (!
#line 4178 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && shl_and_kind (operands[2], operands[3], 0) == 2))
        return -1;
      *pnum_clobbers = 1;
      return 143; /* *sh.md:4172 */

    case NOT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!bitwise_memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 10258 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
        return -1;
      return 381; /* bclr_m2a */

    case MEM:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!bitwise_memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_QImode)
          || !rtx_equal_p (x3, operands[0])
          || !
#line 10268 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_Psz (operands[1]) && TARGET_BITOPS))
        return -1;
      return 382; /* bclrmem_m2a */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      res = recog_22 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_23 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 147
          && GET_MODE (x3) == E_SImode)
        {
          switch (XWINT (x2, 0))
            {
            case 0L:
              if (
#line 4976 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 181; /* clrt */
              break;

            case 1L:
              if (
#line 4982 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 182; /* sett */
              break;

            default:
              break;
            }
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (
#line 6444 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !CROSSING_JUMP_P (insn)))
            return 222; /* jump_compact */
          if (
#line 6458 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && flag_reorder_blocks_and_partition
   && CROSSING_JUMP_P (insn)))
            return 223; /* *jump_compact_crossing */
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case STRICT_LOW_PART:
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (general_movdst_operand (operands[0], E_SImode))
        {
          operands[1] = x2;
          if (general_movsrc_operand (operands[1], E_SImode)
              && 
#line 5245 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 190; /* movsi_i_lowpart */
        }
      break;

    default:
      break;
    }
  operands[0] = x3;
  res = recog_25 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x3) != MEM)
    return -1;
  operands[0] = x3;
  if (post_inc_mem (operands[0], E_SImode))
    {
      operands[1] = x2;
      if (arith_reg_operand (operands[1], E_SImode)
          && 
#line 5361 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
        return 199; /* *movsi_store_postinc */
    }
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) != E_SImode
      || !register_operand (x2, E_SImode))
    return -1;
  switch (pattern82 (x1))
    {
    case 0:
      if (!gbr_displacement (operands[0], E_SImode))
        return -1;
      operands[1] = x2;
      if (!
#line 7736 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 272; /* *movsi_gbr_store */

    case 1:
      if (!
#line 7743 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 275; /* *movsi_gbr_store */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL)
    {
      res = recog_34 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (arith_reg_operand (operands[2], E_SImode))
    {
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (pnum_clobbers != NULL
          && treg_set_expr_not_const01 (operands[1], E_VOIDmode)
          && 
#line 2075 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        {
          *pnum_clobbers = 1;
          return 58; /* *subc_negt_reg */
        }
      if (arith_reg_operand (operands[1], E_SImode)
          && 
#line 2133 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return 60; /* *subsi3_internal */
    }
  if (pnum_clobbers == NULL
      || !treg_set_expr (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != NEG
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_SImode)
      || !
#line 4366 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 150; /* *negc */
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pattern62 (x1, pnum_clobbers, 
PLUS) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  switch (pattern189 (x1))
    {
    case 0:
      if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 2;
          return 601; /* atomic_add_fetchqi_soft_gusa */
        }
      if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 1;
      return 637; /* atomic_add_fetchqi_soft_imask */

    case 1:
      if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 2;
          return 606; /* atomic_add_fetchhi_soft_gusa */
        }
      if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 1;
      return 642; /* atomic_add_fetchhi_soft_imask */

    case 2:
      if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
        {
          *pnum_clobbers = 2;
          return 611; /* atomic_add_fetchsi_soft_gusa */
        }
      if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
        return -1;
      *pnum_clobbers = 1;
      return 647; /* atomic_add_fetchsi_soft_imask */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 1L:
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern133 (x7, 
31, 
LSHIFTRT))
        {
        case 0:
          if (!
#line 2913 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 98; /* rotlsi3_1 */

        case 1:
          if (!
#line 2923 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 99; /* *rotlsi3_1 */

        default:
          return -1;
        }

    case 31L:
      x7 = XVECEXP (x1, 0, 1);
      if (pattern33 (x7, 
147, 
CLOBBER) != 0
          || !
#line 2932 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 100; /* rotlsi3_31 */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (XWINT (x4, 0) == 1L)
    {
      switch (pattern110 (x1, 
1, 
AND))
        {
        case 0:
          if (
#line 3791 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 127; /* shar */
          break;

        case 1:
          if (
#line 3889 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 134; /* ashrdi3_k */
          break;

        default:
          break;
        }
    }
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern124 (x1, 
E_SImode) != 0)
    return -1;
  operands[2] = x4;
  if (const_int_operand (operands[2], E_SImode)
      && 
#line 3800 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && INTVAL (operands[2]) == 1))
    return 128; /* ashrsi3_k */
  if (XWINT (x4, 0) != 31L
      || !
#line 3822 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 130; /* ashrsi2_31 */
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_SImode)
    {
      res = recog_58 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern26 (x1, 
E_SImode, 
147) != 0)
    return -1;
  switch (pattern157 (x3))
    {
    case 0:
      if (!
#line 8357 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && ((INTVAL (operands[2]) == -2147483648LL
	&& INTVAL (operands[3]) == 2147483647LL)
       || (INTVAL (operands[2]) == 2147483647LL
	   && INTVAL (operands[3]) == -2147483648LL))))
        return -1;
      return 295; /* *mov_t_msb_neg */

    case 1:
      if (!
#line 8556 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH && can_create_pseudo_p ()))
        return -1;
      return 303; /* *cset_zero */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      res = recog_60 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      res = recog_61 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      if (immediate_operand (operands[1], E_SImode))
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER)
            {
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (register_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x4, 0);
                  operands[2] = x6;
                  if (scratch_operand (operands[2], E_SImode)
                      && 
#line 6290 "../../gcc/config/sh/sh.md"
(TARGET_SH2E
   && (reload_in_progress || reload_completed)))
                    return 216; /* *movsi_y */
                }
            }
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x3;
  if (pattern51 (x1, 
154, 
USE) != 0)
    return -1;
  switch (pattern158 ())
    {
    case 0:
      if (!
#line 5584 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE
   && (arith_reg_operand (operands[0], DFmode)
       || arith_reg_operand (operands[1], DFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 212; /* movdf_i4 */

    case 1:
      if (!
#line 6066 "../../gcc/config/sh/sh.md"
(TARGET_SH2E
   && (arith_reg_operand (operands[0], SFmode)
       || fpul_operand (operands[0], SFmode)
       || arith_reg_operand (operands[1], SFmode)
       || fpul_operand (operands[1], SFmode))))
        return -1;
      *pnum_clobbers = 1;
      return 214; /* movsf_ie */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (pattern61 (x3, 
NOT) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (pattern161 (x1))
    {
    case 0:
      x7 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x7))
        {
        case SET:
          switch (pattern195 (x7))
            {
            case 0:
              if (!arith_reg_dest (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x5, 1);
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[1] = x9;
              if (!atomic_mem_operand_1 (operands[1], E_SImode)
                  || pattern69 (x2) != 0
                  || !
#line 1637 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 578; /* atomic_not_fetchsi_hard */

            case 1:
              if (pattern237 (x1, pnum_clobbers, 
E_QImode) != 0
                  || !
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 599; /* atomic_not_fetchqi_hard */

            case 2:
              if (pattern237 (x1, pnum_clobbers, 
E_HImode) != 0
                  || !
#line 1725 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 600; /* atomic_not_fetchhi_hard */

            default:
              return -1;
            }

        case CLOBBER:
          x8 = XEXP (x5, 1);
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 652; /* atomic_not_fetchqi_soft_imask */

            case 1:
              if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 653; /* atomic_not_fetchhi_soft_imask */

            case 2:
              if (!
#line 1899 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 654; /* atomic_not_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      x11 = XEXP (x9, 1);
      operands[2] = x11;
      x12 = XVECEXP (x3, 0, 0);
      x13 = XEXP (x12, 0);
      x14 = XEXP (x13, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      switch (GET_CODE (x7))
        {
        case SET:
          switch (pattern195 (x7))
            {
            case 0:
              if (!arith_reg_dest (operands[0], E_SImode)
                  || GET_MODE (x8) != E_SImode
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x15 = XEXP (x9, 0);
              operands[1] = x15;
              if (!atomic_mem_operand_1 (operands[1], E_SImode)
                  || pattern240 (x3, 
E_SImode) != 0)
                return -1;
              x16 = XEXP (x13, 0);
              if (!rtx_equal_p (x16, operands[1])
                  || !rtx_equal_p (x4, operands[1])
                  || !
#line 1963 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 655; /* atomic_nand_fetchsi_hard */

            case 1:
              if (pattern263 (x1, pnum_clobbers, 
E_QImode) != 0)
                return -1;
              x15 = XEXP (x9, 0);
              operands[1] = x15;
              if (atomic_mem_operand_1 (operands[1], E_QImode))
                {
                  x16 = XEXP (x13, 0);
                  if (rtx_equal_p (x16, operands[1])
                      && rtx_equal_p (x4, operands[1])
                      && 
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 656; /* atomic_nand_fetchqi_hard */
                    }
                }
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              if (pattern285 (x2, 
E_QImode) != 0
                  || !
#line 2024 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 658; /* atomic_nand_fetchqi_hard_1 */

            case 2:
              if (pattern263 (x1, pnum_clobbers, 
E_HImode) != 0)
                return -1;
              x15 = XEXP (x9, 0);
              operands[1] = x15;
              if (atomic_mem_operand_1 (operands[1], E_HImode))
                {
                  x16 = XEXP (x13, 0);
                  if (rtx_equal_p (x16, operands[1])
                      && rtx_equal_p (x4, operands[1])
                      && 
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 657; /* atomic_nand_fetchhi_hard */
                    }
                }
              x17 = XEXP (x15, 0);
              operands[1] = x17;
              if (pattern285 (x2, 
E_HImode) != 0
                  || !
#line 2024 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 659; /* atomic_nand_fetchhi_hard_1 */

            default:
              return -1;
            }

        case CLOBBER:
          x15 = XEXP (x9, 0);
          operands[1] = x15;
          x10 = XEXP (x7, 0);
          operands[3] = x10;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x13, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 666; /* atomic_nand_fetchqi_soft_imask */

            case 1:
              if (!
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 667; /* atomic_nand_fetchhi_soft_imask */

            case 2:
              if (!
#line 2113 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 668; /* atomic_nand_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || GET_MODE (x3) != E_SImode)
    return -1;
  switch (REGNO (x3))
    {
    case 151:
      x4 = XVECEXP (x1, 0, 3);
      if (pattern146 (x4, 
E_SImode, 
146, 
CLOBBER) != 0
          || !arith_reg_operand (operands[1], E_SImode)
          || !
#line 6612 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
        return -1;
      return 230; /* call_valuei_fdpic */

    case 154:
      x4 = XVECEXP (x1, 0, 3);
      switch (GET_CODE (x4))
        {
        case USE:
          if (pnum_clobbers == NULL
              || !arith_reg_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!
#line 6659 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return -1;
          *pnum_clobbers = 1;
          return 232; /* call_valuei_pcrel */

        case RETURN:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6988 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
            return -1;
          return 242; /* sibcall_valuei_fdpic */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case ASHIFT:
          if (pattern34 (x1) != 0
              || !
#line 3565 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_DYNSHIFT))
            return -1;
          return 119; /* ashlsi3_d_call */

        case ASHIFTRT:
          if (pattern35 (x3, 
4, 
E_SImode) != 0
              || pattern88 (x1, 
CLOBBER, 
4) != 0
              || pattern128 (x1, 
USE, 
146) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          operands[0] = x4;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 4);
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!
#line 3863 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 133; /* ashrsi3_n */

        case LSHIFTRT:
          if (pattern34 (x1) != 0
              || !
#line 4014 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_DYNSHIFT))
            return -1;
          return 137; /* lshrsi3_d_call */

        case CALL:
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != MEM
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != USE)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != USE)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != REG
              || GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          x14 = XEXP (x9, 0);
          switch (GET_CODE (x14))
            {
            case REG:
            case SUBREG:
            case SIGN_EXTEND:
              operands[1] = x14;
              if (!arith_reg_operand (operands[1], E_SImode))
                return -1;
              x5 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x5) != USE)
                return -1;
              x4 = XEXP (x3, 1);
              operands[2] = x4;
              x15 = XEXP (x10, 0);
              if (GET_CODE (x15) == REG
                  && pattern211 (x1) == 0)
                {
                  x6 = XEXP (x5, 0);
                  operands[3] = x6;
                  if (
#line 6659 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                    return 232; /* call_valuei_pcrel */
                }
              if (REGNO (x12) != 154
                  || pattern212 (x1, 
RETURN, 
12) != 0)
                return -1;
              operands[3] = x15;
              if (!
#line 7022 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC))
                return -1;
              return 244; /* sibcall_valuei_pcrel_fdpic */

            case SYMBOL_REF:
              operands[1] = x14;
              if (!symbol_ref_operand (operands[1], E_SImode)
                  || pattern174 (x1) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG)
                return -1;
              x4 = XEXP (x3, 1);
              operands[2] = x4;
              if (GET_MODE (x6) != E_SImode)
                return -1;
              switch (pattern256 (x1))
                {
                case 0:
                  if (!
#line 6679 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                    return -1;
                  return 233; /* call_value_pcrel */

                case 1:
                  if (!
#line 7076 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC))
                    return -1;
                  return 246; /* sibcall_value_pcrel_fdpic */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x14, 0) != 1)
                return -1;
              x4 = XEXP (x3, 1);
              if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern174 (x1) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 3);
              if (pattern146 (x5, 
E_SImode, 
146, 
CLOBBER) != 0)
                return -1;
              x7 = XVECEXP (x1, 0, 4);
              if (GET_CODE (x7) != CLOBBER)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != SCRATCH
                  || GET_MODE (x8) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x16 = XVECEXP (x14, 0, 0);
              operands[1] = x16;
              switch (XINT (x14, 1))
                {
                case 16:
                  if (!
#line 7551 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 255; /* tls_global_dynamic */

                case 17:
                  if (!
#line 7578 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return -1;
                  return 256; /* tls_local_dynamic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MEM:
          return recog_77 (x1, insn, pnum_clobbers);

        case UNSPEC_VOLATILE:
          if (pattern36 (x1) != 0
              || pattern127 (x1, 
CLOBBER, 
147) != 0)
            return -1;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!arith_reg_dest (operands[0], E_SImode))
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          operands[1] = x17;
          x18 = XVECEXP (x3, 0, 1);
          operands[2] = x18;
          x19 = XVECEXP (x3, 0, 2);
          operands[3] = x19;
          x5 = XVECEXP (x1, 0, 3);
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 4);
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!scratch_operand (operands[5], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          switch (pattern284 (x10))
            {
            case 0:
              if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 413; /* atomic_compare_and_swapqi_soft_imask */

            case 1:
              if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 414; /* atomic_compare_and_swaphi_soft_imask */

            case 2:
              if (!
#line 450 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 415; /* atomic_compare_and_swapsi_soft_imask */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 33)
            return -1;
          x13 = XEXP (x2, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x20 = XEXP (x10, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern128 (x1, 
CLOBBER, 
0) != 0)
            return -1;
          x21 = XEXP (x13, 0);
          operands[0] = x21;
          if (!arith_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x6 = XEXP (x5, 0);
          if (!scratch_operand (x6, E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 4);
          x8 = XEXP (x7, 0);
          if (!scratch_operand (x8, E_SImode))
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x17))
            {
            case PLUS:
              x22 = XEXP (x17, 0);
              if (GET_CODE (x22) != MEM)
                return -1;
              x23 = XEXP (x17, 1);
              operands[1] = x23;
              operands[2] = x6;
              operands[3] = x8;
              x24 = XEXP (x22, 0);
              if (!rtx_equal_p (x24, operands[0]))
                return -1;
              switch (GET_MODE (x13))
                {
                case E_QImode:
                  if (pattern276 (x3, 
E_QImode) != 0
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 466; /* atomic_addqi_hard_1 */

                case E_HImode:
                  if (pattern276 (x3, 
E_HImode) != 0
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 471; /* atomic_addhi_hard_1 */

                default:
                  return -1;
                }

            case MINUS:
              x22 = XEXP (x17, 0);
              if (GET_CODE (x22) != MEM)
                return -1;
              x23 = XEXP (x17, 1);
              operands[1] = x23;
              operands[2] = x6;
              operands[3] = x8;
              x24 = XEXP (x22, 0);
              if (!rtx_equal_p (x24, operands[0]))
                return -1;
              switch (GET_MODE (x13))
                {
                case E_QImode:
                  if (pattern277 (x3, 
E_QImode) != 0
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 467; /* atomic_subqi_hard_1 */

                case E_HImode:
                  if (pattern277 (x3, 
E_HImode) != 0
                      || !
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 472; /* atomic_subhi_hard_1 */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 468; /* atomic_orqi_hard_1 */

                case 1:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 473; /* atomic_orhi_hard_1 */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 469; /* atomic_xorqi_hard_1 */

                case 1:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 474; /* atomic_xorhi_hard_1 */

                default:
                  return -1;
                }

            case AND:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 470; /* atomic_andqi_hard_1 */

                case 1:
                  if (!
#line 922 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  return 475; /* atomic_andhi_hard_1 */

                default:
                  return -1;
                }

            case NOT:
              x22 = XEXP (x17, 0);
              switch (GET_CODE (x22))
                {
                case MEM:
                  operands[1] = x6;
                  operands[2] = x8;
                  switch (pattern225 (x2))
                    {
                    case 0:
                      if (!
#line 988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      return 478; /* atomic_notqi_hard */

                    case 1:
                      if (!
#line 988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      return 479; /* atomic_nothi_hard */

                    default:
                      return -1;
                    }

                case AND:
                  x24 = XEXP (x22, 0);
                  if (GET_CODE (x24) != MEM)
                    return -1;
                  x25 = XEXP (x22, 1);
                  operands[1] = x25;
                  operands[2] = x6;
                  operands[3] = x8;
                  x26 = XEXP (x24, 0);
                  if (!rtx_equal_p (x26, operands[0]))
                    return -1;
                  switch (GET_MODE (x13))
                    {
                    case E_QImode:
                      if (pattern278 (x3, 
E_QImode) != 0
                          || !
#line 1418 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      return 559; /* atomic_nandqi_hard_1 */

                    case E_HImode:
                      if (pattern278 (x3, 
E_HImode) != 0
                          || !
#line 1418 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                        return -1;
                      return 560; /* atomic_nandhi_hard_1 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pattern37 (x1, 
PLUS) != 0)
            return -1;
          switch (pattern238 (x1))
            {
            case 0:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 619; /* atomic_add_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 624; /* atomic_add_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 629; /* atomic_add_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case MINUS:
          if (pattern37 (x1, 
MINUS) != 0)
            return -1;
          switch (pattern239 (x1))
            {
            case 0:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 620; /* atomic_sub_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 625; /* atomic_sub_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 630; /* atomic_sub_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case IOR:
          switch (pattern41 (x1, 
IOR))
            {
            case 0:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 621; /* atomic_or_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 626; /* atomic_or_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 631; /* atomic_or_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case XOR:
          switch (pattern41 (x1, 
XOR))
            {
            case 0:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 622; /* atomic_xor_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 627; /* atomic_xor_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 632; /* atomic_xor_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case AND:
          switch (pattern41 (x1, 
AND))
            {
            case 0:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 623; /* atomic_and_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 628; /* atomic_and_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1816 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 633; /* atomic_and_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case NOT:
          if (pattern37 (x1, 
NOT) != 0)
            return -1;
          switch (pattern243 (x1))
            {
            case 0:
              if (!
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 634; /* atomic_not_fetchqi_soft_tcb */

            case 1:
              if (!
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 635; /* atomic_not_fetchhi_soft_tcb */

            case 2:
              if (!
#line 1847 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 636; /* atomic_not_fetchsi_soft_tcb */

            case 3:
              if (!
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 663; /* atomic_nand_fetchqi_soft_tcb */

            case 4:
              if (!
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 664; /* atomic_nand_fetchhi_soft_tcb */

            case 5:
              if (!
#line 2080 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              return 665; /* atomic_nand_fetchsi_soft_tcb */

            default:
              return -1;
            }

        case EQ:
          if (pattern43 (x1) != 0
              || pattern199 (x1, 
1, 
0, 
CLOBBER) != 0
              || pattern266 (x1, 
E_QImode) != 0
              || !
#line 2184 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA && !TARGET_ENABLE_TAS))
            return -1;
          return 670; /* atomic_test_and_set_soft_gusa */

        default:
          return -1;
        }

    case CALL:
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != USE)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x11) != USE)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || GET_MODE (x12) != E_SImode)
        return -1;
      x21 = XEXP (x13, 0);
      operands[0] = x21;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      switch (GET_CODE (operands[0]))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          if (!arith_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) == REG
              && pattern211 (x1) == 0)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (
#line 6548 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return 227; /* calli_pcrel */
            }
          if (REGNO (x12) != 154
              || pattern212 (x1, 
RETURN, 
12) != 0)
            return -1;
          operands[2] = x15;
          if (!
#line 6845 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC))
            return -1;
          return 237; /* sibcalli_pcrel_fdpic */

        case SYMBOL_REF:
          if (!symbol_ref_operand (operands[0], E_SImode)
              || pattern174 (x1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG
              && pattern233 (x1) == 0
              && 
#line 6567 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
            return 228; /* call_pcrel */
          x7 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x7) != RETURN)
            return -1;
          operands[2] = x6;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 6905 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && TARGET_FDPIC))
            return -1;
          return 240; /* sibcall_pcrel_fdpic */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 0);
  switch (pattern22 (x4))
    {
    case 0:
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 1);
      operands[2] = x6;
      if (not_p27_rshift_count_operand (operands[2], E_SImode)
          && arith_reg_dest (operands[0], E_SImode)
          && GET_MODE (x5) == E_SImode
          && arith_reg_operand (operands[1], E_SImode)
          && (
#line 4051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_lshrsi_clobbers_t_reg_p (operands[2])) && 
#line 4053 "../../gcc/config/sh/sh.md"
( (reload_completed || INTVAL (operands[2]) == 31
       || (sh_dynamicalize_shift_p (operands[2]) && can_create_pseudo_p ())))))
        return gen_split_90 (insn, operands);
      if (XWINT (x6, 0) != 1L
          || !arith_reg_dest (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !arith_reg_operand (operands[1], E_DImode)
          || !(
#line 4104 "../../gcc/config/sh/sh.md"
(TARGET_SH1) && 
#line 4106 "../../gcc/config/sh/sh.md"
( reload_completed)))
        return NULL;
      return gen_split_91 (insn, operands);

    case 1:
      x5 = XEXP (x4, 1);
      if (pattern201 (x5) != 0
          || !register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x5, 0);
      x8 = XEXP (x7, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return NULL;
      x6 = XEXP (x5, 1);
      operands[5] = x6;
      if (!const_int_operand (operands[5], E_SImode)
          || !
#line 4230 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return NULL;
      return gen_split_94 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  if (GET_CODE (x3) == GT)
    {
      x4 = XEXP (x1, 1);
      if (XWINT (x4, 0) == 0L)
        {
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) == REG
              && REGNO (x5) == 147
              && GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x3, 1);
              operands[1] = x6;
              if (arith_reg_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x3, 0);
                  if (rtx_equal_p (x7, operands[0])
                      && 
#line 3649 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[1])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_1 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  if (GET_CODE (x3) != SIGN_EXTEND)
    return NULL;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x3, 0);
  if (GET_CODE (x7) != MEM)
    return NULL;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return NULL;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!arith_reg_dest (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x8, 1);
  operands[3] = x9;
  if (!arith_reg_operand (operands[3], E_SImode))
    return NULL;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (peep2_current_count >= 3)
        {
          x11 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x11) == SET)
            {
              x12 = XEXP (x11, 0);
              operands[4] = x12;
              if (arith_reg_dest (operands[4], E_QImode))
                {
                  x13 = XEXP (x11, 1);
                  operands[5] = x13;
                  if (arith_reg_operand (operands[5], E_QImode)
                      && 
#line 10535 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && sh_legitimate_index_p (QImode, operands[1], true, true)
   && REGNO (operands[2]) == REGNO (operands[5])
   && peep2_reg_dead_p (3, operands[5])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_8 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      if (!
#line 10571 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && sh_legitimate_index_p (QImode, operands[1], true, true)
   && (peep2_reg_dead_p (2, operands[0])
       || REGNO (operands[0]) == REGNO (operands[2]))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    case E_HImode:
      if (peep2_current_count >= 3)
        {
          x11 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x11) == SET)
            {
              x12 = XEXP (x11, 0);
              operands[4] = x12;
              if (arith_reg_dest (operands[4], E_HImode))
                {
                  x13 = XEXP (x11, 1);
                  operands[5] = x13;
                  if (arith_reg_operand (operands[5], E_HImode)
                      && 
#line 10551 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && sh_legitimate_index_p (HImode, operands[1], true, true)
   && REGNO (operands[2]) == REGNO (operands[5])
   && peep2_reg_dead_p (3, operands[5])))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_9 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      if (!
#line 10586 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && sh_legitimate_index_p (HImode, operands[1], true, true)
   && (peep2_reg_dead_p (2, operands[0])
       || REGNO (operands[0]) == REGNO (operands[2]))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SIGN_EXTEND:
      res = peephole2_4 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    case REG:
    case SUBREG:
      res = peephole2_5 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!arith_reg_operand (operands[1], E_VOIDmode)
      || !arith_reg_dest (operands[0], E_VOIDmode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!arith_reg_dest (operands[2], E_SImode))
    return NULL;
  x6 = XEXP (x4, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_QImode:
      if (!arith_reg_operand (operands[3], E_QImode)
          || !
#line 10648 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && REGNO (operands[0]) == REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_16 (insn, operands);

    case E_HImode:
      if (!arith_reg_operand (operands[3], E_HImode)
          || !
#line 10648 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && REGNO (operands[0]) == REGNO (operands[3])
   && (REGNO (operands[0]) == REGNO (operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_17 (insn, operands);

    default:
      return NULL;
    }
}
