/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 147
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      return 0;

    case XOR:
      return 1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 147
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern28 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[1] = x10;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x7, 0);
  operands[2] = x11;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x8, 0);
  operands[3] = x12;
  return 0;
}

int
pattern41 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XVECEXP (x1, 0, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return pattern40 (x1); /* [-1, 2] */
}

int
pattern57 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != GE
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 147
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[0] = x8;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x9))
    {
    case SET:
      x10 = XEXP (x9, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 147
          || GET_MODE (x11) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x12 = XEXP (x3, 0);
          operands[1] = x12;
          if (!atomic_mem_operand_1 (operands[1], E_SImode)
              || !atomic_logical_operand_1 (operands[2], E_SImode)
              || pattern69 (x5) != 0)
            return -1;
          return 0;

        case E_QImode:
          if (pattern70 (x1, pnum_clobbers, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_HImode:
          if (pattern70 (x1, pnum_clobbers, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x12 = XEXP (x3, 0);
      operands[1] = x12;
      x11 = XEXP (x9, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x5, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern38 (x1, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_HImode:
          if (pattern38 (x1, 
E_HImode) != 0)
            return -1;
          return 4;

        case E_SImode:
          if (pattern38 (x1, 
E_SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern101 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern110 (rtx x1, int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i2
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 147
          || GET_MODE (x5) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      if (pattern109 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 148)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 149
      || GET_MODE (x9) != E_SImode
      || !arith_reg_dest (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[2] = x11;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!arith_reg_dest (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !arith_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern147 (x1, 
E_SImode, 
0, 
147) != 0)
    return -1;
  return 0;
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!treg_set_expr (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!arith_reg_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != EQ
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 147
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  if (!arith_reg_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  if (!arith_reg_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != i1
      || GET_MODE (x1) != E_SImode
      || !arith_reg_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !arith_reg_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != AND
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 65280L)
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != AND
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ASHIFTRT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x9 = XEXP (x6, 1);
  if (GET_CODE (x9) != CONST_INT
      || XWINT (x9, 0) != 255L)
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_QImode:
      return 1;

    case E_HImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 148
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_logical_operand_1 (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!atomic_mem_operand_1 (operands[0], E_QImode)
          || pattern216 (x1, 
E_QImode) != 0)
        return -1;
      return 0;

    case E_HImode:
      if (!atomic_mem_operand_1 (operands[0], E_HImode)
          || pattern216 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (!atomic_mem_operand_1 (operands[0], E_SImode)
          || pattern216 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      return pattern185 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern185 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern185 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern237 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x7, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern252 (x1); /* [-1, 1] */
}

int
pattern257 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern266 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  if (!scratch_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x6, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LSHIFTRT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x6, 0);
      if (!arith_reg_operand (x8, E_SImode))
        return -1;
      operands[0] = x8;
      if (pattern200 (x1) == 0
          && 
#line 2673 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        {
          *pnum_clobbers = 1;
          return 84; /* smulsi3_highpart_i */
        }
      operands[1] = x8;
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 2687 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 2;
      return 85; /* smulsi3_highpart */

    case ZERO_EXTEND:
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 0);
      if (!arith_reg_operand (x8, E_SImode))
        return -1;
      operands[0] = x8;
      if (pattern200 (x1) == 0
          && 
#line 2705 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
        {
          *pnum_clobbers = 1;
          return 86; /* umulsi3_highpart_i */
        }
      operands[1] = x8;
      x9 = XEXP (x1, 0);
      operands[0] = x9;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 2718 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 87; /* umulsi3_highpart */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern95 (x1) != 0)
    return -1;
  if (
#line 4275 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && (unsigned)shl_sext_kind (operands[2], operands[3], 0) - 1 < 5))
    {
      *pnum_clobbers = 1;
      return 145; /* shl_sext_ext */
    }
  if (!
#line 4305 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && (shl_sext_kind (operands[2], operands[3], 0) & ~1) == 6))
    return -1;
  *pnum_clobbers = 1;
  return 146; /* shl_sext_sub */
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern8 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[0] = x5;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!arith_reg_operand (operands[0], E_SImode)
                  || !arith_or_int_operand (operands[1], E_SImode)
                  || !
#line 553 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && (can_create_pseudo_p () || arith_reg_operand (operands[1], SImode)
       || satisfies_constraint_K08 (operands[1]))))
                return -1;
              return 1; /* tstsi_t */

            case E_DImode:
              if (!arith_reg_operand (operands[0], E_DImode)
                  || !arith_operand (operands[1], E_DImode)
                  || !
#line 1328 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 28; /* *sh.md:1323 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!arith_reg_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          operands[1] = x8;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 804 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 11; /* *tstsi_t_shift_mask */

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) == SUBREG)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == AND)
            {
              x3 = XEXP (x2, 1);
              if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern150 (x4))
                    {
                    case 0:
                      if (
#line 728 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                        return 2; /* *tstqi_t */
                      break;

                    case 1:
                      if (
#line 728 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                        return 3; /* *tsthi_t */
                      break;

                    case 2:
                      if (
#line 750 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()))
                        return 4; /* *tstqi_t_subregs */
                      break;

                    case 3:
                      if (
#line 750 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_LITTLE_ENDIAN && can_create_pseudo_p ()))
                        return 5; /* *tsthi_t_subregs */
                      break;

                    case 4:
                      if (
#line 766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()))
                        return 6; /* *tstqi_t_subregs */
                      break;

                    case 5:
                      if (
#line 766 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_BIG_ENDIAN && can_create_pseudo_p ()))
                        return 7; /* *tsthi_t_subregs */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      operands[0] = x4;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!arith_reg_operand (operands[0], E_SImode)
              || !arith_operand (operands[1], E_SImode)
              || !
#line 817 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 12; /* cmpeqsi_t */

        case E_DImode:
          if (!arith_reg_operand (operands[0], E_DImode)
              || !arith_reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1340 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 29; /* cmpeqdi_t */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x6;
      switch (pattern151 (x2))
        {
        case 0:
          if (
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 8; /* *tstqi_t_zero_extract */
          break;

        case 1:
          if (
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 9; /* *tsthi_t_zero_extract */
          break;

        case 2:
          if (
#line 784 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 10; /* *tstsi_t_zero_extract */
          break;

        default:
          break;
        }
      if (XWINT (x6, 0) != 1L
          || pattern152 (x2) != 0
          || !
#line 1147 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && (INTVAL (operands[2]) == 15
       || INTVAL (operands[2]) == 23 || INTVAL (operands[2]) == 29
       || INTVAL (operands[2]) == 30 || INTVAL (operands[2]) == 31)))
        return -1;
      return 24; /* *cmp_div0s_8 */

    case 3:
      x2 = XEXP (x1, 1);
      switch (pattern104 (x2))
        {
        case 0:
          if (!
#line 1029 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 18; /* *cmp_div0s_2 */

        case 1:
          if (!
#line 1079 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 22; /* *cmp_div0s_6 */

        default:
          return -1;
        }

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern105 (x2, 
0) != 0
          || !
#line 1041 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 19; /* *cmp_div0s_3 */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[2] = x4;
      if (!arith_reg_operand (operands[2], E_DImode)
          || pattern96 (x1) != 0
          || !
#line 1545 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 36; /* adddi3 */

    case LABEL_REF:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != LABEL_REF
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!
#line 7190 "../../gcc/config/sh/sh.md"
(TARGET_SH2
   && (! INSN_UID (operands[1])
       || prev_real_insn (as_a<rtx_insn *> (operands[1])) == insn)))
        return -1;
      return 249; /* casesi_jump_2 */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  if (REGNO (x5) == 149)
    {
      switch (pattern107 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) == SIGN_EXTEND
              && pattern106 (x3, 
SIGN_EXTEND) == 0
              && 
#line 2453 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 72; /* mulhisi3 */
          operands[1] = x6;
          if (arith_reg_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              if (arith_reg_operand (operands[2], E_SImode)
                  && 
#line 2531 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
                return 79; /* mulsi3_i */
            }
          break;

        case 1:
          if (
#line 2465 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 73; /* umulhisi3 */
          break;

        default:
          break;
        }
    }
  if (REGNO (x5) != 147
      || pattern108 (x1) != 0
      || !
#line 8467 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  return 299; /* *movt_msb */
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[2] = x4;
  switch (pattern87 (x1))
    {
    case 0:
      if (
#line 3600 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_ashlsi_clobbers_t_reg_p (operands[2])))
        return 121; /* ashlsi3_n_clobbers_t */
      break;

    case 1:
      if (
#line 3691 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return 125; /* *ashlhi3_n */
      break;

    default:
      break;
    }
  if (XWINT (x4, 0) != 1L)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (pattern110 (x1, 
0, 
LT))
    {
    case 0:
      if (!
#line 3633 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 122; /* shll */

    case 1:
      if (!
#line 3752 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 126; /* ashldi3_k */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 147
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (pattern137 (x4))
        {
        case 0:
          if (!
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 154; /* abssi2 */

        case 1:
          if (!
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          return 155; /* absdi2 */

        default:
          return -1;
        }

    case USE:
      switch (pattern100 (x1))
        {
        case 0:
          if (!
#line 9541 "../../gcc/config/sh/sh.md"
(TARGET_FPU_SH4_300))
            return -1;
          return 345; /* abssf2_fpscr */

        case 1:
          if (!
#line 9788 "../../gcc/config/sh/sh.md"
(TARGET_FPU_SH4_300))
            return -1;
          return 359; /* absdf2_fpscr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern101 (x1, 
147) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (pattern225 (x4))
    {
    case 0:
      if (!
#line 988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
        return -1;
      *pnum_clobbers = 3;
      return 478; /* atomic_notqi_hard */

    case 1:
      if (!
#line 988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
        return -1;
      *pnum_clobbers = 3;
      return 479; /* atomic_nothi_hard */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case USE:
      if (pattern97 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      switch (pattern158 ())
        {
        case 0:
          if (!
#line 5584 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE
   && (arith_reg_operand (operands[0], DFmode)
       || arith_reg_operand (operands[1], DFmode))))
            return -1;
          return 212; /* movdf_i4 */

        case 1:
          if (!
#line 6066 "../../gcc/config/sh/sh.md"
(TARGET_SH2E
   && (arith_reg_operand (operands[0], SFmode)
       || fpul_operand (operands[0], SFmode)
       || arith_reg_operand (operands[1], SFmode)
       || fpul_operand (operands[1], SFmode))))
            return -1;
          return 214; /* movsf_ie */

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 33)
        return -1;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      x9 = XVECEXP (x7, 0, 0);
      switch (GET_CODE (x9))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
        case TRUNCATE:
          operands[2] = x9;
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case SET:
              if (pnum_clobbers == NULL
                  || pattern142 (x5) != 0)
                return -1;
              switch (pattern236 (x7))
                {
                case 0:
                  if (!
#line 532 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 416; /* atomic_exchangesi_hard */

                case 1:
                  if (!
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 417; /* atomic_exchangeqi_hard */

                case 2:
                  if (!
#line 556 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 418; /* atomic_exchangehi_hard */

                default:
                  return -1;
                }

            case CLOBBER:
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              if (!scratch_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern215 (x7, 
E_QImode) != 0
                      || !
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  return 427; /* atomic_exchangeqi_soft_imask */

                case E_HImode:
                  if (pattern215 (x7, 
E_HImode) != 0
                      || !
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  return 428; /* atomic_exchangehi_soft_imask */

                case E_SImode:
                  if (pattern215 (x7, 
E_SImode) != 0
                      || !
#line 647 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                    return -1;
                  return 429; /* atomic_exchangesi_soft_imask */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL)
            return -1;
          x10 = XEXP (x9, 1);
          operands[2] = x10;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case SET:
              if (pattern142 (x5) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern175 (x7, 
E_SImode) != 0
                      || !
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 430; /* atomic_fetch_addsi_hard */

                case E_QImode:
                  if (pattern175 (x7, 
E_QImode) != 0
                      || !
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 436; /* atomic_fetch_addqi_hard */

                case E_HImode:
                  if (pattern175 (x7, 
E_HImode) != 0
                      || !
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 441; /* atomic_fetch_addhi_hard */

                default:
                  return -1;
                }

            case USE:
              switch (pattern218 (x1))
                {
                case 0:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 498; /* atomic_fetch_addqi_soft_tcb */

                case 1:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 503; /* atomic_fetch_addhi_soft_tcb */

                case 2:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 508; /* atomic_fetch_addsi_soft_tcb */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          if (pnum_clobbers == NULL)
            return -1;
          x10 = XEXP (x9, 1);
          operands[2] = x10;
          x11 = XEXP (x9, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x5))
            {
            case SET:
              if (pattern142 (x5) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern178 (x7, 
E_SImode) != 0
                      || !
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 431; /* atomic_fetch_subsi_hard */

                case E_QImode:
                  if (pattern178 (x7, 
E_QImode) != 0
                      || !
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 437; /* atomic_fetch_subqi_hard */

                case E_HImode:
                  if (pattern178 (x7, 
E_HImode) != 0
                      || !
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  *pnum_clobbers = 1;
                  return 442; /* atomic_fetch_subhi_hard */

                default:
                  return -1;
                }

            case USE:
              switch (pattern219 (x1))
                {
                case 0:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 499; /* atomic_fetch_subqi_soft_tcb */

                case 1:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 504; /* atomic_fetch_subhi_soft_tcb */

                case 2:
                  if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                    return -1;
                  *pnum_clobbers = 2;
                  return 509; /* atomic_fetch_subsi_soft_tcb */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IOR:
          switch (pattern167 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              *pnum_clobbers = 1;
              return 432; /* atomic_fetch_orsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 438; /* atomic_fetch_orqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 443; /* atomic_fetch_orhi_hard */

            case 3:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 500; /* atomic_fetch_orqi_soft_tcb */

            case 4:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 505; /* atomic_fetch_orhi_soft_tcb */

            case 5:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 510; /* atomic_fetch_orsi_soft_tcb */

            default:
              return -1;
            }

        case XOR:
          switch (pattern167 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              *pnum_clobbers = 1;
              return 433; /* atomic_fetch_xorsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 439; /* atomic_fetch_xorqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 444; /* atomic_fetch_xorhi_hard */

            case 3:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 501; /* atomic_fetch_xorqi_soft_tcb */

            case 4:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 506; /* atomic_fetch_xorhi_soft_tcb */

            case 5:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 511; /* atomic_fetch_xorsi_soft_tcb */

            default:
              return -1;
            }

        case AND:
          switch (pattern167 (x1, pnum_clobbers))
            {
            case 0:
              if (!
#line 772 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              *pnum_clobbers = 1;
              return 434; /* atomic_fetch_andsi_hard */

            case 1:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 440; /* atomic_fetch_andqi_hard */

            case 2:
              if (!
#line 830 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 445; /* atomic_fetch_andhi_hard */

            case 3:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 502; /* atomic_fetch_andqi_soft_tcb */

            case 4:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 507; /* atomic_fetch_andhi_soft_tcb */

            case 5:
              if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 2;
              return 512; /* atomic_fetch_andsi_soft_tcb */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x11 = XEXP (x9, 0);
          switch (GET_CODE (x11))
            {
            case MEM:
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x5))
                {
                case SET:
                  if (pattern142 (x5) != 0
                      || pattern183 (x7, 
E_SImode) != 0
                      || !
#line 798 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 435; /* atomic_fetch_notsi_hard */

                case USE:
                  switch (pattern220 (x1))
                    {
                    case 0:
                      if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 528; /* atomic_fetch_notqi_soft_tcb */

                    case 1:
                      if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 529; /* atomic_fetch_nothi_soft_tcb */

                    case 2:
                      if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 530; /* atomic_fetch_notsi_soft_tcb */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case AND:
              x12 = XEXP (x11, 1);
              operands[2] = x12;
              x13 = XEXP (x11, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x5 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x5))
                {
                case SET:
                  if (pattern142 (x5) != 0)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern185 (x7, 
E_SImode) != 0
                          || !
#line 1292 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                        return -1;
                      *pnum_clobbers = 1;
                      return 552; /* atomic_fetch_nandsi_hard */

                    case E_QImode:
                      if (pattern185 (x7, 
E_QImode) != 0
                          || !
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 553; /* atomic_fetch_nandqi_hard */

                    case E_HImode:
                      if (pattern185 (x7, 
E_HImode) != 0
                          || !
#line 1326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                        return -1;
                      *pnum_clobbers = 1;
                      return 554; /* atomic_fetch_nandhi_hard */

                    default:
                      return -1;
                    }

                case USE:
                  switch (pattern227 (x1))
                    {
                    case 0:
                      if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 564; /* atomic_fetch_nandqi_soft_tcb */

                    case 1:
                      if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 565; /* atomic_fetch_nandhi_soft_tcb */

                    case 2:
                      if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      *pnum_clobbers = 2;
                      return 566; /* atomic_fetch_nandsi_soft_tcb */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case PLUS:
              res = recog_42 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MINUS:
              res = recog_44 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MULT:
              res = recog_45 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case TRUNCATE:
              res = recog_46 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ROTATERT:
              res = recog_47 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ROTATE:
              res = recog_48 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case IOR:
              res = recog_51 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ASHIFT:
              res = recog_52 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case LT:
              if (GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x3, 1);
                  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      && pattern88 (x1, 
CLOBBER, 
147) == 0)
                    {
                      x5 = XEXP (x3, 0);
                      operands[0] = x5;
                      if (arith_reg_operand (operands[0], E_SImode))
                        {
                          x6 = XVECEXP (x1, 0, 1);
                          x7 = XEXP (x6, 0);
                          operands[1] = x7;
                          if (scratch_operand (operands[1], E_SImode)
                              && 
#line 3641 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && cse_not_expected))
                            return 123; /* *ashlsi_c_void */
                        }
                    }
                }
              break;

            case ASHIFTRT:
              res = recog_53 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case LSHIFTRT:
              switch (pattern22 (x2))
                {
                case 0:
                  x4 = XEXP (x3, 1);
                  operands[2] = x4;
                  if (not_p27_rshift_count_operand (operands[2], E_SImode))
                    {
                      x6 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x6) == CLOBBER
                          && pattern109 (x1, 
E_SImode) == 0
                          && 
#line 4051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_lshrsi_clobbers_t_reg_p (operands[2])))
                        return 139; /* lshrsi3_n_clobbers_t */
                    }
                  if (XWINT (x4, 0) == 1L)
                    {
                      switch (pattern110 (x1, 
1, 
AND))
                        {
                        case 0:
                          if (
#line 4081 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                            return 140; /* shlr */
                          break;

                        case 1:
                          if (
#line 4104 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                            return 141; /* lshrdi3_k */
                          break;

                        default:
                          break;
                        }
                    }
                  break;

                case 1:
                  x6 = XVECEXP (x1, 0, 1);
                  if (pattern33 (x6, 
147, 
CLOBBER) == 0
                      && pattern201 (x3) == 0)
                    {
                      x5 = XEXP (x3, 0);
                      x8 = XEXP (x5, 1);
                      operands[4] = x8;
                      if (const_int_operand (operands[4], E_SImode))
                        {
                          x4 = XEXP (x3, 1);
                          operands[5] = x4;
                          if (const_int_operand (operands[5], E_SImode)
                              && 
#line 4205 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                            return 144; /* and_shl_scratch */
                        }
                    }
                  break;

                default:
                  break;
                }
              break;

            case AND:
              res = recog_54 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case SIGN_EXTRACT:
              if (pattern24 (x1) == 0)
                {
                  if (
#line 4275 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && (unsigned)shl_sext_kind (operands[2], operands[3], 0) - 1 < 5))
                    return 145; /* shl_sext_ext */
                  if (
#line 4305 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && (shl_sext_kind (operands[2], operands[3], 0) & ~1) == 6))
                    return 146; /* shl_sext_sub */
                }
              break;

            case NEG:
              res = recog_56 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ABS:
              res = recog_57 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case IF_THEN_ELSE:
              res = recog_59 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ZERO_EXTEND:
              if (pattern25 (x1) == 0
                  && 
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 185; /* *movhi_index_disp_load */
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case SIGN_EXTEND:
            case HIGH:
              res = recog_62 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case UNSPEC:
              res = recog_64 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CALL:
              if (pnum_clobbers != NULL)
                {
                  x5 = XEXP (x3, 0);
                  if (GET_CODE (x5) == MEM
                      && GET_MODE (x5) == E_SImode
                      && pattern51 (x1, 
154, 
USE) == 0)
                    {
                      x9 = XEXP (x5, 0);
                      operands[1] = x9;
                      if (arith_reg_operand (operands[1], E_SImode))
                        {
                          x4 = XEXP (x3, 1);
                          operands[2] = x4;
                          if (
#line 6591 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
                            {
                              *pnum_clobbers = 1;
                              return 229; /* call_valuei */
                            }
                        }
                    }
                }
              break;

            case EQ:
              res = recog_65 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case XOR:
              res = recog_66 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case NOT:
              res = recog_67 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || pattern26 (x1, 
E_SImode, 
147) != 0)
            return -1;
          operands[1] = x3;
          if (treg_set_expr (operands[1], E_VOIDmode)
              && 
#line 8607 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 304; /* any_treg_expr_to_reg */
          if (GET_MODE (x3) != E_SImode)
            return -1;
          switch (pattern139 (x3))
            {
            case 0:
              if (!
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
                return -1;
              return 315; /* *sminsi3 */

            case 1:
              if (!
#line 8846 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
                return -1;
              return 316; /* *smaxsi3 */

            case 2:
              if (!
#line 8906 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && can_create_pseudo_p ()))
                return -1;
              return 318; /* clipu_one */

            case 3:
              if (!
#line 10227 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()
   && exact_log2 (INTVAL (operands[3])) >= 0))
                return -1;
              return 380; /* *zero_extract_3 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (!scratch_operand (x7, E_SImode))
            return -1;
          switch (XVECLEN (x2, 0))
            {
            case 2:
              if (XINT (x2, 1) != 11)
                return -1;
              x10 = XVECEXP (x2, 0, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x11 = XVECEXP (x2, 0, 1);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              operands[2] = x7;
              if (!
#line 5311 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
                return -1;
              return 192; /* ic_invalidate_line_i */

            case 1:
              if (XINT (x2, 1) != 7)
                return -1;
              x10 = XVECEXP (x2, 0, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              operands[1] = x7;
              return 284; /* eh_set_ra_si */

            default:
              return -1;
            }

        case CALL:
          if (pnum_clobbers == NULL)
            return -1;
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE
              || pattern101 (x1, 
154) != 0)
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!
#line 6482 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
            return -1;
          *pnum_clobbers = 1;
          return 224; /* calli */

        default:
          return -1;
        }

    case 7:
      return recog_85 (x1, insn, pnum_clobbers);

    case 14:
      x2 = XVECEXP (x1, 0, 0);
      if (pattern2 (x2) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || pattern45 (x1, 
CLOBBER, 
146, 
147) != 0
          || pattern223 (x1, 
0, 
E_DFmode, 
68, 
66, 
64) != 0
          || pattern279 (x1, 
USE, 
155, 
5, 
4, 
1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x13) != USE)
        return -1;
      x14 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x14) != USE)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 154
          || GET_MODE (x15) != E_SImode)
        return -1;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x16 = XVECEXP (x1, 0, 11);
      x17 = XEXP (x16, 0);
      operands[1] = x17;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x18 = XEXP (x13, 0);
      operands[2] = x18;
      if (!
#line 2229 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && ! TARGET_FPU_SINGLE))
        return -1;
      return 64; /* udivsi3_i4 */

    case 12:
      x2 = XVECEXP (x1, 0, 0);
      if (pattern2 (x2) != 0
          || pattern75 (x1, 
146, 
147) != 0
          || pattern213 (x1, 
68, 
E_DFmode, 
66, 
64, 
CLOBBER) != 0
          || pattern273 (x1, 
5, 
4, 
1, 
0, 
E_DFmode) != 0)
        return -1;
      x19 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x19) != USE)
        return -1;
      x16 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x16) != USE)
        return -1;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x20 = XEXP (x19, 0);
      operands[1] = x20;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x16, 0);
      operands[2] = x17;
      if (!
#line 2251 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && TARGET_FPU_SINGLE))
        return -1;
      return 65; /* udivsi3_i4_single */

    case 8:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || GET_MODE (x7) != E_SImode
          || pattern91 (x1) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x21) != CLOBBER)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || GET_MODE (x22) != E_SImode)
        return -1;
      x23 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x23) != USE)
        return -1;
      x12 = XEXP (x2, 0);
      if (!register_operand (x12, E_SImode))
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_CODE (x3))
        {
        case DIV:
          if (pattern226 (x1, 
155, 
E_DFmode, 
66, 
64, 
146) != 0)
            return -1;
          x24 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x24) != USE)
            return -1;
          x25 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x25) != USE)
            return -1;
          x26 = XEXP (x23, 0);
          if (GET_CODE (x26) != REG
              || REGNO (x26) != 154
              || GET_MODE (x26) != E_SImode)
            return -1;
          operands[0] = x12;
          x27 = XEXP (x24, 0);
          operands[1] = x27;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x28 = XEXP (x25, 0);
          operands[2] = x28;
          if (!
#line 2363 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && ! TARGET_FPU_SINGLE))
            return -1;
          return 69; /* divsi3_i4 */

        case MULT:
          if (pattern226 (x1, 
3, 
E_SImode, 
146, 
147, 
149) != 0
              || pattern257 (x1, 
1, 
E_SImode, 
2) != 0)
            return -1;
          operands[1] = x12;
          x26 = XEXP (x23, 0);
          operands[0] = x26;
          if (!arith_reg_operand (operands[0], E_SImode)
              || !
#line 2505 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 76; /* mulsi3_call */

        default:
          return -1;
        }

    case 3:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          return recog_76 (x1, insn, pnum_clobbers);

        case CALL:
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern33 (x6, 
154, 
USE) != 0)
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x29 = XEXP (x12, 0);
          switch (GET_CODE (x29))
            {
            case REG:
            case SUBREG:
            case SIGN_EXTEND:
              operands[0] = x29;
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x30 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x30))
                {
                case CLOBBER:
                  x31 = XEXP (x30, 0);
                  if (pattern173 (x31, 
146) != 0
                      || !
#line 6482 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
                    return -1;
                  return 224; /* calli */

                case USE:
                  if (pnum_clobbers == NULL)
                    return -1;
                  x31 = XEXP (x30, 0);
                  if (pattern173 (x31, 
12) != 0
                      || !
#line 6502 "../../gcc/config/sh/sh.md"
(TARGET_FDPIC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 225; /* calli_fdpic */

                case RETURN:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 6799 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && !TARGET_FDPIC))
                    return -1;
                  return 234; /* sibcalli */

                default:
                  return -1;
                }

            case SYMBOL_REF:
              if (pnum_clobbers == NULL)
                return -1;
              operands[0] = x29;
              if (!symbol_ref_operand (operands[0], E_SImode))
                return -1;
              x30 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x30) != USE)
                return -1;
              x31 = XEXP (x30, 0);
              operands[2] = x31;
              if (scratch_operand (operands[2], E_VOIDmode)
                  && 
#line 6525 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh2a_is_function_vector_call (operands[0])))
                {
                  *pnum_clobbers = 1;
                  return 226; /* calli_tbr_rel */
                }
              if (GET_CODE (x31) != REG
                  || REGNO (x31) != 12
                  || GET_MODE (x31) != E_SImode
                  || GET_MODE (x12) != E_SImode
                  || !
#line 6567 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return -1;
              *pnum_clobbers = 2;
              return 228; /* call_pcrel */

            case UNSPEC:
              if (XVECLEN (x29, 0) != 1
                  || XINT (x29, 1) != 23
                  || GET_MODE (x29) != E_SImode)
                return -1;
              x30 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x30) != RETURN
                  || GET_MODE (x12) != E_SImode)
                return -1;
              x32 = XVECEXP (x29, 0, 0);
              operands[0] = x32;
              if (!symbol_ref_operand (operands[0], E_SImode)
                  || !
#line 6863 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 238; /* sibcalli_thunk */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      return recog_82 (x1, insn, pnum_clobbers);

    case 4:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          return recog_81 (x1, insn, pnum_clobbers);

        case CALL:
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x29 = XEXP (x12, 0);
          operands[0] = x29;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
            case SIGN_EXTEND:
              x30 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x30) != USE)
                return -1;
              x31 = XEXP (x30, 0);
              if (GET_CODE (x31) != REG)
                return -1;
              if (REGNO (x31) == 12
                  && GET_MODE (x31) == E_SImode)
                {
                  res = recog_80 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (REGNO (x31) != 154
                  || GET_MODE (x31) != E_SImode)
                return -1;
              x33 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x33) != RETURN
                  || GET_MODE (x12) != E_SImode
                  || !arith_reg_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!
#line 6827 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && !TARGET_FDPIC))
                return -1;
              return 236; /* sibcalli_pcrel */

            case SYMBOL_REF:
              if (!symbol_ref_operand (operands[0], E_SImode))
                return -1;
              switch (pattern129 (x1))
                {
                case 0:
                  x33 = XVECEXP (x1, 0, 3);
                  if (pattern146 (x33, 
E_SImode, 
146, 
CLOBBER) != 0)
                    return -1;
                  x30 = XVECEXP (x1, 0, 2);
                  x31 = XEXP (x30, 0);
                  operands[2] = x31;
                  if (!scratch_operand (operands[2], E_VOIDmode)
                      || !
#line 6525 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh2a_is_function_vector_call (operands[0])))
                    return -1;
                  return 226; /* calli_tbr_rel */

                case 1:
                  x33 = XVECEXP (x1, 0, 3);
                  if (GET_CODE (x33) != RETURN
                      || GET_MODE (x12) != E_SImode)
                    return -1;
                  x30 = XVECEXP (x1, 0, 2);
                  x31 = XEXP (x30, 0);
                  operands[2] = x31;
                  if (!scratch_operand (operands[2], E_SImode)
                      || !
#line 6878 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && !TARGET_FDPIC))
                    return -1;
                  return 239; /* sibcall_pcrel */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 9:
      return recog_83 (x1, insn, pnum_clobbers);

    case 10:
      if (pattern4 (x1) != 0
          || pattern213 (x1, 
147, 
E_SImode, 
146, 
6, 
USE) != 0
          || pattern273 (x1, 
0, 
6, 
5, 
4, 
E_SImode) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x30 = XVECEXP (x1, 0, 2);
      x31 = XEXP (x30, 0);
      operands[1] = x31;
      if (!
#line 8965 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_HARD_SH4))
        return -1;
      return 320; /* block_lump_real */

    case 13:
      if (pattern4 (x1) != 0)
        return -1;
      x33 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x33) != USE
          || pattern223 (x1, 
4, 
E_SImode, 
147, 
146, 
6) != 0
          || pattern279 (x1, 
CLOBBER, 
1, 
0, 
6, 
5) != 0)
        return -1;
      x16 = XVECEXP (x1, 0, 11);
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 2
          || GET_MODE (x17) != E_SImode)
        return -1;
      x13 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x18 = XEXP (x13, 0);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 3
          || GET_MODE (x18) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x30 = XVECEXP (x1, 0, 2);
      x31 = XEXP (x30, 0);
      operands[1] = x31;
      if (!
#line 9003 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
        return -1;
      return 322; /* block_lump_real_i4 */

    case 6:
      return recog_84 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
