/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!logical_operator (operands[3], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!t_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 33)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  return 0;
}

int
pattern26 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2SFmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 14
      || GET_MODE (x4) != E_SFmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_SFmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != FLOAT
      || GET_MODE (x6) != E_SFmode)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 12
      || GET_MODE (x7) != E_SFmode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != MULT
      || GET_MODE (x8) != E_SFmode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != FLOAT
      || GET_MODE (x9) != E_SFmode)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 155
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != USE)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 154
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x2, 0);
  operands[0] = x14;
  if (!fp_arith_reg_operand (operands[0], E_V2SFmode))
    return -1;
  x15 = XEXP (x6, 0);
  operands[1] = x15;
  if (!fpul_fsca_operand (operands[1], E_SImode))
    return -1;
  x16 = XEXP (x5, 1);
  operands[2] = x16;
  if (!fsca_scale_factor (operands[2], E_SFmode))
    return -1;
  x17 = XEXP (x9, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  x18 = XEXP (x8, 1);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 1
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 0
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER
      || pattern67 (x1, 
154, 
155, 
USE) != 0)
    return -1;
  return 0;
}

int
pattern72 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != MEM)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return pattern71 (x1, pnum_clobbers); /* [-1, 5] */
}

int
pattern84 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 147
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern88 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 151
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern103 (rtx x1, int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != -2147483648L)
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!t_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

int
pattern128 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern127 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 147
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!arith_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 2);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[2] = x5;
      if (!treg_set_expr (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case NOT:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[2] = x5;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case MINUS:
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!treg_set_expr (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      if (!arith_reg_operand (operands[3], E_SImode))
        return -1;
      return 2;

    case AND:
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 1);
      if (GET_CODE (x5) != CONST_INT
          || XWINT (x5, 0) != 2147483647L)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern188 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !atomic_mem_operand_1 (operands[1], i1)
      || !atomic_arith_operand_1 (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern165 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern165 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern165 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern203 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!atomic_mem_operand_1 (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !atomic_arith_operand_1 (operands[1], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return pattern209 (x1); /* [-1, 5] */
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      return pattern175 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern175 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (pattern175 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fp_arith_reg_operand (operands[0], E_SFmode)
          || !fp_arith_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fp_arith_reg_operand (operands[0], E_DFmode)
          || !fp_arith_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_mem_operand_1 (operands[1], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (!gbr_displacement (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case MEM:
      operands[1] = x6;
      operands[2] = x3;
      return pattern172 (x1); /* [-1, 2] */

    case AND:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 1);
      x9 = XVECEXP (x8, 0, 0);
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != AND)
        return -1;
      x11 = XEXP (x6, 0);
      operands[1] = x11;
      x12 = XEXP (x6, 1);
      operands[2] = x12;
      operands[3] = x3;
      x13 = XEXP (x10, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x10, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      res = pattern242 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern261 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern261 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern117 (x5, 
i1); /* [-1, 0] */
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == ZERO_EXTEND)
        {
          if (pnum_clobbers != NULL)
            {
              switch (pattern55 (x1))
                {
                case 0:
                  if (
#line 2465 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 73; /* umulhisi3 */
                    }
                  break;

                case 1:
                  if (
#line 2647 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 2;
                      return 83; /* umulsidi3_compact */
                    }
                  break;

                default:
                  break;
                }
            }
          if (GET_MODE (x4) == E_SImode
              && pattern56 (x1) == 0
              && 
#line 2478 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 74; /* umulhisi3_i */
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL
      || GET_MODE (x2) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != -2147483648L)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (!t_reg_operand (operands[1], E_SImode)
      || !
#line 8467 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  *pnum_clobbers = 1;
  return 299; /* *movt_msb */
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      res = recog_14 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!arith_reg_operand (operands[1], E_SImode)
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[2] = x5;
  if (shift_count_operand (operands[2], E_SImode)
      && 
#line 3524 "../../gcc/config/sh/sh.md"
(TARGET_DYNSHIFT))
    return 118; /* ashlsi3_d */
  if (!not_p27_shift_count_operand (operands[2], E_SImode))
    return -1;
  if (
#line 3576 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! sh_ashlsi_clobbers_t_reg_p (operands[2])))
    return 120; /* ashlsi3_n */
  if (pnum_clobbers == NULL
      || !
#line 3600 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && sh_ashlsi_clobbers_t_reg_p (operands[2])))
    return -1;
  *pnum_clobbers = 1;
  return 121; /* ashlsi3_n_clobbers_t */
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern58 (x3, pnum_clobbers, 
E_DImode) == 0
              && 
#line 4382 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            {
              *pnum_clobbers = 1;
              return 151; /* negdi2 */
            }
          break;

        case E_SImode:
          if (arith_reg_dest (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode
              && arith_reg_operand (operands[1], E_SImode)
              && 
#line 4398 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 152; /* negsi2 */
          break;

        case E_SFmode:
          if (fp_arith_reg_operand (operands[0], E_SFmode)
              && GET_MODE (x3) == E_SFmode
              && fp_arith_reg_operand (operands[1], E_SFmode)
              && 
#line 9419 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && !TARGET_FPU_SH4_300))
            return 339; /* negsf2_no_fpscr */
          break;

        case E_DFmode:
          if (fp_arith_reg_operand (operands[0], E_DFmode)
              && GET_MODE (x3) == E_DFmode
              && fp_arith_reg_operand (operands[1], E_DFmode)
              && 
#line 9742 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && !TARGET_FPU_SH4_300))
            return 356; /* negdf2_no_fpscr */
          break;

        default:
          break;
        }
      break;

    case ABS:
      if (pnum_clobbers != NULL)
        {
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern98 (x3, 
E_SImode) == 0
                  && 
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 156; /* *negabssi2 */
                }
              break;

            case E_DImode:
              if (pattern98 (x3, 
E_DImode) == 0
                  && 
#line 4485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 157; /* *negabsdi2 */
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  operands[1] = x4;
  if (!treg_set_expr (operands[1], E_VOIDmode)
      || !
#line 8406 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
    return -1;
  *pnum_clobbers = 1;
  return 296; /* mov_neg_si_t */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      if (XWINT (x5, 0) == 0L)
        {
          res = recog_27 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != NEG
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern214 (x6, 
E_SImode) != 0
              || !
#line 4515 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH))
            return -1;
          return 158; /* negsi_cond */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern214 (x6, 
E_DImode) != 0
              || !
#line 4554 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 159; /* negdi_cond */

        default:
          return -1;
        }

    case NE:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 147
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !arith_reg_dest (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!general_movsrc_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[2] = x6;
      if (!arith_reg_operand (operands[2], E_SImode)
          || !
#line 1489 "../../gcc/config/sh/sh.md"
(TARGET_PRETEND_CMOVE
   && (arith_reg_operand (operands[1], SImode)
       || (immediate_operand (operands[1], SImode)
	   && satisfies_constraint_I08 (operands[1])))))
        return -1;
      return 35; /* *movsicc_t_true */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      res = recog_29 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_33 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_35 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (negt_reg_shl31_operand (operands[1], E_SImode))
    {
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (arith_reg_dest (operands[0], E_SImode)
          && 
#line 8485 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 300; /* *negt_msb */
    }
  if (GET_CODE (x2) != IF_THEN_ELSE
      || GET_MODE (x2) != E_SImode)
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (cbranch_treg_value (operands[1], E_SImode))
    {
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (arith_reg_operand (operands[2], E_SImode)
          && 
#line 8534 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH))
        return 302; /* *cset_zero */
    }
  if (pnum_clobbers == NULL
      || !treg_set_expr_not_const01 (operands[1], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[0])
      || !
#line 8556 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && TARGET_ZDCBRANCH && can_create_pseudo_p ()))
    return -1;
  *pnum_clobbers = 1;
  return 303; /* *cset_zero */
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) == REG
      && REGNO (x6) == 147
      && GET_MODE (x6) == E_SImode)
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (arith_reg_dest (operands[0], E_SImode))
        {
          operands[1] = x4;
          x8 = XEXP (x3, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern170 (x8) == 0
                  && 
#line 1634 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 40; /* *addc */
              break;

            case REG:
            case SUBREG:
            case SIGN_EXTEND:
              operands[2] = x8;
              if (arith_reg_operand (operands[2], E_SImode)
                  && treg_set_expr_not_const01 (operands[1], E_VOIDmode)
                  && 
#line 1713 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 43; /* *addc_t_r */
              break;

            default:
              break;
            }
          if (arith_reg_operand (operands[1], E_SImode))
            {
              operands[2] = x8;
              if (treg_set_expr_not_const01 (operands[2], E_VOIDmode)
                  && 
#line 1725 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return 44; /* *addc_r_t */
            }
        }
    }
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!arith_reg_dest (operands[0], E_SImode))
    return -1;
  operands[1] = x4;
  if (arith_reg_operand (operands[1], E_SImode))
    {
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      if (arith_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x6;
          if (scratch_operand (operands[3], E_SImode)
              && 
#line 1832 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 49; /* addsi3_scr */
        }
    }
  if (treg_set_expr (operands[1], E_VOIDmode)
      && pattern132 (x1) == 0
      && 
#line 1739 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return 45; /* *addc_2r_t */
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 147
      || GET_MODE (x6) != E_SImode)
    return -1;
  if (GET_MODE (x4) == E_SImode)
    {
      switch (pattern164 (x3))
        {
        case 0:
          if (
#line 1752 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 46; /* *addc_2r_t */
          break;

        case 1:
          if (
#line 2033 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 56; /* *subc */
          break;

        case 2:
          if (
#line 2106 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 59; /* *subc_negreg_t */
          break;

        case 3:
          if (
#line 8314 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 293; /* *mov_t_msb_neg */
          break;

        default:
          break;
        }
    }
  x8 = XEXP (x3, 1);
  if (GET_CODE (x8) != CONST_INT
      || XWINT (x8, 0) != 2147483647L)
    return -1;
  operands[1] = x4;
  if (!treg_set_expr (operands[1], E_VOIDmode)
      || !
#line 8328 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
    return -1;
  return 294; /* *mov_t_msb_neg */
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      if (pattern25 (x1) == 0
          && 
#line 5036 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return 184; /* *movhi_index_disp_load */
      break;

    case REG:
    case SUBREG:
      operands[0] = x3;
      if (register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PC)
            {
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) == USE)
                {
                  x6 = XEXP (x5, 0);
                  if (GET_CODE (x6) == LABEL_REF)
                    {
                      x7 = XEXP (x6, 0);
                      operands[1] = x7;
                      if (
#line 7180 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                        return 248; /* casesi_jump_1 */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (pattern51 (x1, 
147, 
CLOBBER) != 0)
    return -1;
  switch (pattern144 ())
    {
    case 0:
      if (!
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 186; /* *movhi_index_disp_store */

    case 1:
      if (!
#line 5083 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 187; /* *movsi_index_disp_store */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (pattern146 (x4, 
E_SImode, 
0, 
CLOBBER) != 0)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 5);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 6);
  x12 = XEXP (x11, 0);
  operands[6] = x12;
  if (!scratch_operand (operands[6], E_SImode))
    return -1;
  x13 = XEXP (x3, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (pattern289 (x2, 
E_QImode) != 0
          || !
#line 356 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
        return -1;
      return 405; /* atomic_compare_and_swapqi_hard_1 */

    case E_HImode:
      if (pattern289 (x2, 
E_HImode) != 0
          || !
#line 356 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
        return -1;
      return 406; /* atomic_compare_and_swaphi_hard_1 */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  res = recog_69 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  if (fpscr_movsrc_operand (operands[0], E_SImode)
      && pattern92 (x1, 
12) == 0)
    {
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) == REG
          && REGNO (x5) == 155
          && GET_MODE (x5) == E_SImode)
        {
          x6 = XVECEXP (x1, 0, 2);
          if (pattern140 (x6, 
154, 
11) == 0
              && 
#line 9107 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY))
            return 324; /* lds_fpscr */
        }
    }
  switch (GET_CODE (x3))
    {
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      if (GET_MODE (x3) == E_BLKmode
          && pattern3 (x1) == 0)
        {
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          if (arith_reg_operand (operands[0], E_SImode))
            {
              x6 = XVECEXP (x1, 0, 2);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (
#line 8946 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_HARD_SH4))
                {
                  *pnum_clobbers = 2;
                  return 319; /* block_move_real */
                }
              if (
#line 8981 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
                {
                  *pnum_clobbers = 4;
                  return 321; /* block_move_real_i4 */
                }
            }
        }
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 1
          || XINT (x8, 1) != 33
          || pattern143 (x1) != 0)
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      x10 = XEXP (x3, 0);
      operands[1] = x10;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x8, 0, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[2] = x12;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern258 (x1, 
E_QImode) != 0
                  || !
#line 581 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 419; /* atomic_exchangeqi_hard_1 */

            case E_HImode:
              if (pattern258 (x1, 
E_HImode) != 0
                  || !
#line 581 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 420; /* atomic_exchangehi_hard_1 */

            default:
              return -1;
            }

        case PLUS:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          x14 = XEXP (x12, 1);
          operands[2] = x14;
          switch (pattern260 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 446; /* atomic_fetch_addqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 451; /* atomic_fetch_addhi_hard_1 */

            default:
              return -1;
            }

        case MINUS:
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          x14 = XEXP (x12, 1);
          operands[2] = x14;
          switch (pattern262 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 447; /* atomic_fetch_subqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 452; /* atomic_fetch_subhi_hard_1 */

            default:
              return -1;
            }

        case IOR:
          switch (pattern253 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 448; /* atomic_fetch_orqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 453; /* atomic_fetch_orhi_hard_1 */

            default:
              return -1;
            }

        case XOR:
          switch (pattern253 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 449; /* atomic_fetch_xorqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 454; /* atomic_fetch_xorhi_hard_1 */

            default:
              return -1;
            }

        case AND:
          switch (pattern253 (x1))
            {
            case 0:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 450; /* atomic_fetch_andqi_hard_1 */

            case 1:
              if (!
#line 865 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                return -1;
              *pnum_clobbers = 3;
              return 455; /* atomic_fetch_andhi_hard_1 */

            default:
              return -1;
            }

        case NOT:
          x13 = XEXP (x12, 0);
          switch (GET_CODE (x13))
            {
            case MEM:
              x15 = XEXP (x13, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern267 (x1, 
E_QImode) != 0
                      || !
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 476; /* atomic_fetch_notqi_hard */

                case E_HImode:
                  if (pattern267 (x1, 
E_HImode) != 0
                      || !
#line 950 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 477; /* atomic_fetch_nothi_hard */

                default:
                  return -1;
                }

            case AND:
              x15 = XEXP (x13, 0);
              if (GET_CODE (x15) != MEM)
                return -1;
              x16 = XEXP (x13, 1);
              operands[2] = x16;
              switch (pattern269 (x1))
                {
                case 0:
                  if (!
#line 1361 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 555; /* atomic_fetch_nandqi_hard_1 */

                case 1:
                  if (!
#line 1361 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
                    return -1;
                  *pnum_clobbers = 3;
                  return 556; /* atomic_fetch_nandhi_hard_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      if (REGNO (x3) != 151
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern66 (x1, 
154, 
USE, 
155) != 0
          || !fpscr_movdst_operand (operands[0], E_SImode)
          || !
#line 9120 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY))
        return -1;
      return 325; /* sts_fpscr */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ASHIFTRT:
      if (pattern46 (x1) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!arith_reg_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!symbol_ref_operand (operands[2], E_SImode)
          || !
#line 3841 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 131; /* *ashrsi2_31 */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      res = recog_78 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_BLKmode
          || pattern73 (x1) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x8) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (pattern146 (x6, 
E_SImode, 
6, 
USE) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (
#line 8965 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_HARD_SH4))
        {
          *pnum_clobbers = 6;
          return 320; /* block_lump_real */
        }
      if (!
#line 9003 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
        return -1;
      *pnum_clobbers = 9;
      return 322; /* block_lump_real_i4 */

    case CALL:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != USE)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != USE)
            return -1;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != REG)
            return -1;
          if (REGNO (x11) == 12
              && GET_MODE (x11) == E_SImode)
            {
              res = recog_79 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (REGNO (x11) != 154
              || GET_MODE (x11) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != RETURN
              || !arith_reg_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          if (!
#line 7003 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && !TARGET_FDPIC))
            return -1;
          return 243; /* sibcall_valuei_pcrel */

        case SYMBOL_REF:
          if (!symbol_ref_operand (operands[1], E_SImode))
            return -1;
          switch (pattern129 (x1))
            {
            case 0:
              x6 = XVECEXP (x1, 0, 3);
              if (pattern146 (x6, 
E_SImode, 
146, 
CLOBBER) != 0)
                return -1;
              x8 = XVECEXP (x1, 0, 2);
              x11 = XEXP (x8, 0);
              operands[3] = x11;
              if (!scratch_operand (operands[3], E_VOIDmode)
                  || !
#line 6636 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && sh2a_is_function_vector_call (operands[1])))
                return -1;
              return 231; /* call_valuei_tbr_rel */

            case 1:
              if (pattern44 (x1, 
RETURN, 
1) != 0
                  || !
#line 7044 "../../gcc/config/sh/sh.md"
(TARGET_SH2 && !TARGET_FDPIC))
                return -1;
              return 245; /* sibcall_value_pcrel */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || GET_MODE (x7) != E_SImode)
            return -1;
          switch (XINT (x3, 1))
            {
            case 18:
              if (GET_MODE (x3) != E_SImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 144
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x8 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x8) != USE
                  || pattern47 (x1, 
0, 
12) != 0
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x14 = XVECEXP (x3, 0, 0);
              operands[1] = x14;
              return 257; /* tls_initial_exec */

            case 33:
              x8 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x8) != CLOBBER
                  || pattern47 (x1, 
1, 
0) != 0)
                return -1;
              x10 = XEXP (x9, 0);
              if (!gbr_displacement (x10, E_SImode))
                return -1;
              x14 = XVECEXP (x3, 0, 0);
              switch (GET_CODE (x14))
                {
                case PLUS:
                  x15 = XEXP (x14, 1);
                  operands[1] = x15;
                  operands[2] = x10;
                  switch (pattern204 (x3))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 513; /* atomic_addqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 518; /* atomic_addhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 523; /* atomic_addsi_soft_tcb */

                    default:
                      return -1;
                    }

                case MINUS:
                  x15 = XEXP (x14, 1);
                  operands[1] = x15;
                  operands[2] = x10;
                  switch (pattern206 (x3))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 514; /* atomic_subqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 519; /* atomic_subhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 524; /* atomic_subsi_soft_tcb */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern232 (x1))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 515; /* atomic_orqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 520; /* atomic_orhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 525; /* atomic_orsi_soft_tcb */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern232 (x1))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 516; /* atomic_xorqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 521; /* atomic_xorhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 526; /* atomic_xorsi_soft_tcb */

                    default:
                      return -1;
                    }

                case AND:
                  switch (pattern232 (x1))
                    {
                    case 0:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 517; /* atomic_andqi_soft_tcb */

                    case 1:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 522; /* atomic_andhi_soft_tcb */

                    case 2:
                      if (!
#line 1115 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                        return -1;
                      return 527; /* atomic_andsi_soft_tcb */

                    default:
                      return -1;
                    }

                case NOT:
                  x16 = XEXP (x14, 0);
                  switch (GET_CODE (x16))
                    {
                    case MEM:
                      if (!rtx_equal_p (x16, operands[0]))
                        return -1;
                      operands[1] = x10;
                      switch (pattern194 (x3))
                        {
                        case 0:
                          if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 531; /* atomic_notqi_soft_tcb */

                        case 1:
                          if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 532; /* atomic_nothi_soft_tcb */

                        case 2:
                          if (!
#line 1165 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 533; /* atomic_notsi_soft_tcb */

                        default:
                          return -1;
                        }

                    case AND:
                      x17 = XEXP (x16, 1);
                      operands[1] = x17;
                      operands[2] = x10;
                      switch (pattern217 (x3))
                        {
                        case 0:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 567; /* atomic_nandqi_soft_tcb */

                        case 1:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 568; /* atomic_nandhi_soft_tcb */

                        case 2:
                          if (!
#line 1516 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                            return -1;
                          return 569; /* atomic_nandsi_soft_tcb */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (pattern94 (x1) != 0
              || !
#line 7923 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 278; /* casesi_worker_0 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pattern36 (x1) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 147
          || GET_MODE (x11) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!arith_reg_dest (operands[0], E_SImode))
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      operands[1] = x14;
      x18 = XVECEXP (x3, 0, 1);
      operands[2] = x18;
      x19 = XVECEXP (x3, 0, 2);
      operands[3] = x19;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x20 = XEXP (x9, 1);
          switch (pattern283 (x20))
            {
            case 0:
              if (!
#line 279 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
                return -1;
              return 402; /* atomic_compare_and_swapsi_hard */

            case 1:
              if (!
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 403; /* atomic_compare_and_swapqi_hard */

            case 2:
              if (!
#line 326 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 404; /* atomic_compare_and_swaphi_hard */

            default:
              return -1;
            }

        case USE:
          if (pnum_clobbers == NULL)
            return -1;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (!gbr_displacement (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              x20 = XEXP (x9, 1);
              if (pattern282 (x20, 
E_QImode) != 0
                  || !
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 3;
              return 410; /* atomic_compare_and_swapqi_soft_tcb */

            case E_HImode:
              x20 = XEXP (x9, 1);
              if (pattern282 (x20, 
E_HImode) != 0
                  || !
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 3;
              return 411; /* atomic_compare_and_swaphi_soft_tcb */

            case E_SImode:
              x20 = XEXP (x9, 1);
              if (pattern282 (x20, 
E_SImode) != 0
                  || !
#line 421 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
                return -1;
              *pnum_clobbers = 3;
              return 412; /* atomic_compare_and_swapsi_soft_tcb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern48 (x1, 
PLUS))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern188 (x1, 
E_QImode) != 0
                  || !
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 579; /* atomic_add_fetchqi_hard */

            case E_HImode:
              if (pattern188 (x1, 
E_HImode) != 0
                  || !
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 584; /* atomic_add_fetchhi_hard */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern188 (x1, 
E_QImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 601; /* atomic_add_fetchqi_soft_gusa */

            case E_HImode:
              if (pattern188 (x1, 
E_HImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 606; /* atomic_add_fetchhi_soft_gusa */

            case E_SImode:
              if (pattern188 (x1, 
E_SImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 611; /* atomic_add_fetchsi_soft_gusa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      switch (pattern48 (x1, 
MINUS))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern190 (x1, 
E_QImode) != 0
                  || !
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 580; /* atomic_sub_fetchqi_hard */

            case E_HImode:
              if (pattern190 (x1, 
E_HImode) != 0
                  || !
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                return -1;
              return 585; /* atomic_sub_fetchhi_hard */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern190 (x1, 
E_QImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 602; /* atomic_sub_fetchqi_soft_gusa */

            case E_HImode:
              if (pattern190 (x1, 
E_HImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 607; /* atomic_sub_fetchhi_soft_gusa */

            case E_SImode:
              if (pattern190 (x1, 
E_SImode) != 0
                  || !
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 612; /* atomic_sub_fetchsi_soft_gusa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern49 (x1, 
IOR))
        {
        case 0:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 581; /* atomic_or_fetchqi_hard */

        case 1:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 586; /* atomic_or_fetchhi_hard */

        case 2:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 603; /* atomic_or_fetchqi_soft_gusa */

        case 3:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 608; /* atomic_or_fetchhi_soft_gusa */

        case 4:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 613; /* atomic_or_fetchsi_soft_gusa */

        default:
          return -1;
        }

    case XOR:
      switch (pattern49 (x1, 
XOR))
        {
        case 0:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 582; /* atomic_xor_fetchqi_hard */

        case 1:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 587; /* atomic_xor_fetchhi_hard */

        case 2:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 604; /* atomic_xor_fetchqi_soft_gusa */

        case 3:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 609; /* atomic_xor_fetchhi_soft_gusa */

        case 4:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 614; /* atomic_xor_fetchsi_soft_gusa */

        default:
          return -1;
        }

    case AND:
      switch (pattern49 (x1, 
AND))
        {
        case 0:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 583; /* atomic_and_fetchqi_hard */

        case 1:
          if (!
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
            return -1;
          return 588; /* atomic_and_fetchhi_hard */

        case 2:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 605; /* atomic_and_fetchqi_soft_gusa */

        case 3:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 610; /* atomic_and_fetchhi_soft_gusa */

        case 4:
          if (!
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 615; /* atomic_and_fetchsi_soft_gusa */

        default:
          return -1;
        }

    case NOT:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x20 = XEXP (x9, 1);
      if (pattern61 (x20, 
NOT) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (pattern138 (x1))
        {
        case 0:
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER
              || pattern47 (x1, 
1, 
0) != 0)
            return -1;
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 616; /* atomic_not_fetchqi_soft_gusa */

            case 1:
              if (!
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 617; /* atomic_not_fetchhi_soft_gusa */

            case 2:
              if (!
#line 1790 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                return -1;
              return 618; /* atomic_not_fetchsi_soft_gusa */

            default:
              return -1;
            }

        case 1:
          x8 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x8))
            {
            case SET:
              x21 = XEXP (x8, 1);
              if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern47 (x1, 
0, 
147) != 0)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern241 (x1, 
E_QImode) != 0
                      || !
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  return 656; /* atomic_nand_fetchqi_hard */

                case E_HImode:
                  if (pattern241 (x1, 
E_HImode) != 0
                      || !
#line 1988 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    return -1;
                  return 657; /* atomic_nand_fetchhi_hard */

                default:
                  return -1;
                }

            case CLOBBER:
              x11 = XEXP (x8, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 0
                  || GET_MODE (x11) != E_SImode
                  || REGNO (x7) != 1)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern272 (x1, 
E_QImode) != 0
                      || !
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 660; /* atomic_nand_fetchqi_soft_gusa */

                case E_HImode:
                  if (pattern272 (x1, 
E_HImode) != 0
                      || !
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 661; /* atomic_nand_fetchhi_soft_gusa */

                case E_SImode:
                  if (pattern272 (x1, 
E_SImode) != 0
                      || !
#line 2054 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
                    return -1;
                  return 662; /* atomic_nand_fetchsi_soft_gusa */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      if (pattern43 (x1) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (pattern146 (x6, 
E_SImode, 
0, 
CLOBBER) != 0
          || pattern266 (x1, 
E_SImode) != 0
          || !
#line 2229 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK && !TARGET_ENABLE_TAS))
        return -1;
      return 672; /* atomic_test_and_set_soft_imask */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (arith_reg_dest (operands[0], E_SImode))
    {
      x2 = PATTERN (peep2_next_insn (1));
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (arith_reg_dest (operands[2], E_SImode))
        {
          if (simple_mem_operand (operands[1], E_VOIDmode))
            {
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) == ZERO_EXTEND
                  && GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x4, 0);
                  operands[3] = x5;
                  if (arith_reg_operand (operands[3], E_VOIDmode)
                      && 
#line 4779 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && GET_MODE (operands[1]) == GET_MODE (operands[3])
   && (GET_MODE (operands[1]) == QImode || GET_MODE (operands[1]) == HImode)
   && REGNO (operands[0]) == REGNO (operands[3])
   && (REGNO (operands[2]) == REGNO (operands[0])
       || peep2_reg_dead_p (2, operands[0]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_4 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          x4 = XEXP (x2, 1);
          if (rtx_equal_p (x4, operands[0]))
            {
              if (movsrc_no_disp_mem_operand (operands[1], E_QImode)
                  && 
#line 10782 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_30 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (movsrc_no_disp_mem_operand (operands[1], E_HImode)
                  && 
#line 10782 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_31 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
    }
  if (peep2_current_count < 3
      || !bitwise_memory_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return NULL;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 1);
  operands[3] = x7;
  if (!arith_reg_operand (operands[3], E_VOIDmode))
    return NULL;
  x8 = XEXP (x6, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return NULL;
  switch (GET_CODE (x4))
    {
    case IOR:
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 10469 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS
   && satisfies_constraint_Pso (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_6 (insn, operands);

    case AND:
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 10485 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS
   && satisfies_constraint_Psz (operands[2])
   && REGNO (operands[0]) == REGNO (operands[3])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_7 (insn, operands);

    default:
      return NULL;
    }
}
