/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return 0;

    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTRACT:
      return 2;

    case LSHIFTRT:
      return 3;

    case GE:
      return 4;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern23 (x1) != 0)
    return -1;
  return 0;
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 155
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 154
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!fpul_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!gbr_displacement (operands[3], E_SImode))
    return -1;
  return pattern39 (x1); /* [-1, 2] */
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 147
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET
      || pattern42 (x7) != 0)
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern54 (x3, 
E_HImode, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern54 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 3
      || XINT (x1, 1) != 13
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  return 0;
}

int
pattern70 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_logical_operand_1 (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern77 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x5, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 147
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 0
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 0);
  x11 = XEXP (x10, 1);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  x13 = XEXP (x11, 1);
  operands[2] = x13;
  x14 = XEXP (x4, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x4, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x2, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 147
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!arith_reg_dest (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!arith_reg_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!arith_reg_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!arith_reg_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern113 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern113 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern113 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 2);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!arith_reg_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!arith_reg_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!arith_reg_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!arith_reg_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[1] = x8;
  if (!arith_reg_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[2] = x9;
  return 0;
}

int
pattern140 (rtx x1, unsigned int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern10 (); /* [-1, 2] */
}

int
pattern158 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!general_movdst_operand (operands[0], E_DFmode)
          || !general_movsrc_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!general_movdst_operand (operands[0], E_SFmode)
          || !general_movsrc_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 147
          || GET_MODE (x9) != E_SImode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern165 (x3, 
E_SImode); /* [-1, 0] */

        case E_QImode:
          if (pattern165 (x3, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_HImode:
          if (pattern165 (x3, 
E_HImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case USE:
      res = pattern166 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern190 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern190 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern190 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 33
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != REG
      || REGNO (x1) != i1
      || GET_MODE (x1) != E_SImode
      || !arith_reg_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, rtx_code i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != i5)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i4
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i1)
    return -1;
  return 0;
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ASHIFT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !arith_reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!arith_reg_or_treg_set_expr (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      operands[3] = x1;
      if (!negt_reg_shl31_operand (operands[3], E_SImode)
          || !arith_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 146
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !atomic_mem_operand_1 (operands[1], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  return pattern240 (x6, 
i1); /* [-1, 0] */
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1)
      || !atomic_mem_operand_1 (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !arith_reg_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !atomic_logical_operand_1 (operands[1], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1
      || !logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern117 (x5, 
i1); /* [-1, 0] */
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!arith_reg_dest (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !logical_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode)
      || !arith_reg_dest (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case ASHIFT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !arith_reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      if (!arith_reg_or_treg_set_expr (operands[3], E_VOIDmode)
          || !
#line 3051 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 105; /* *rotcr */

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      operands[3] = x6;
      if (!negt_reg_shl31_operand (operands[3], E_SImode)
          || !arith_reg_operand (operands[1], E_SImode)
          || !
#line 3431 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 116; /* *rotcr_neg_t */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[1] = x4;
      if (!arith_reg_operand (operands[1], E_SImode)
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (logical_operand (operands[2], E_SImode)
          && 
#line 2797 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && !(TARGET_SH2A && satisfies_constraint_Pso (operands[2]))))
        return 90; /* *iorsi3_compact */
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 2806 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_Pso (operands[2])))
        return -1;
      return 91; /* *iorsi3_bset */

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      if (pnum_clobbers != NULL)
        {
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      if (!arith_reg_operand (x7, E_SImode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 31L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ASHIFT
              || GET_MODE (x5) != E_SImode)
            return -1;
          operands[3] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3315 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 110; /* *rotcl */

        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT
              || XWINT (x5, 0) != -2147483648L)
            return -1;
          operands[1] = x7;
          if (!
#line 3397 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return -1;
          *pnum_clobbers = 1;
          return 114; /* *rotcr */

        case 16L:
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ASHIFT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!arith_reg_operand (operands[2], E_SImode)
              || !
#line 4338 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 148; /* xtrct_right */

        default:
          return -1;
        }

    case ASHIFT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          operands[1] = x7;
          if (!arith_reg_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_11 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XWINT (x6, 0) != 16L)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != LSHIFTRT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!arith_reg_operand (operands[2], E_SImode)
              || !
#line 4328 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return -1;
          return 147; /* xtrct_left */

        case CONST_INT:
          if (XWINT (x7, 0) != 1L
              || !bitwise_memory_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (!const_int_operand (operands[1], E_QImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (!rtx_equal_p (x5, operands[0])
              || !
#line 10281 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && TARGET_BITOPS && satisfies_constraint_K03 (operands[1])))
            return -1;
          return 383; /* bset_m2a */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case NE:
        case EQ:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          if (GET_MODE (x5) != E_SImode)
            return -1;
          switch (XWINT (x6, 0))
            {
            case 1L:
              if (pnum_clobbers == NULL
                  || GET_CODE (x5) != ASHIFT
                  || !arith_reg_or_t_reg_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[2] = x8;
              if (!arith_reg_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode)
                  || !
#line 3281 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 108; /* *rotcl */

            case -2147483648L:
              if (pnum_clobbers == NULL
                  || GET_CODE (x5) != LSHIFTRT)
                return -1;
              x9 = XEXP (x5, 1);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || !arith_reg_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[2] = x8;
              if (!arith_reg_operand (operands[2], E_SImode)
                  || !
#line 3380 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                return -1;
              *pnum_clobbers = 1;
              return 113; /* *rotcr */

            case -65536L:
              if (GET_CODE (x5) != IOR
                  || pattern187 (x5) != 0
                  || !arith_reg_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              x10 = XEXP (x8, 0);
              x11 = XEXP (x10, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x9 = XEXP (x5, 1);
              x12 = XEXP (x9, 0);
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1])
                  || !
#line 4605 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 160; /* swapbsi2 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x14 = XEXP (x7, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          switch (pattern163 (x3))
            {
            case 0:
              if (!
#line 4625 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! reload_in_progress && ! reload_completed && can_create_pseudo_p ()))
                return -1;
              return 161; /* *swapbisi2_and_shl8 */

            case 1:
              if (!
#line 4647 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! reload_in_progress && ! reload_completed && can_create_pseudo_p ()))
                return -1;
              return 162; /* *swapbhisi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
    case PLUS:
    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x4;
      if (!negt_reg_shl31_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LSHIFTRT
          || GET_MODE (x5) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!arith_reg_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 3414 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      *pnum_clobbers = 1;
      return 115; /* *rotcr_neg_t */

    case MEM:
      if (!rtx_equal_p (x4, operands[0])
          || !bitwise_memory_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_QImode)
          || !
#line 10291 "../../gcc/config/sh/sh.md"
(TARGET_SH2A && satisfies_constraint_Pso (operands[1]) && TARGET_BITOPS))
        return -1;
      return 384; /* bsetmem_m2a */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 1L)
    return -1;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case ASHIFT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (pattern156 (x8, 
1, 
AND) != 0)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 147
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x6, 0);
      operands[2] = x10;
      if (!t_reg_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      x12 = XEXP (x11, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 3026 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
        return -1;
      return 103; /* rotcr */

    case CONST_INT:
      if (XWINT (x6, 0) != -2147483648L)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (pattern33 (x8, 
147, 
CLOBBER) != 0
          || !
#line 3397 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
        return -1;
      return 114; /* *rotcr */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern33 (x6, 
147, 
CLOBBER) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      if (
#line 4152 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && shl_and_kind (operands[2], operands[3], 0) == 1))
        return 142; /* *sh.md:4146 */
      if (!
#line 4178 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && shl_and_kind (operands[2], operands[3], 0) == 2))
        return -1;
      return 143; /* *sh.md:4172 */

    case MEM:
      switch (pattern86 (x1, pnum_clobbers, 
AND))
        {
        case 0:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 605; /* atomic_and_fetchqi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 641; /* atomic_and_fetchqi_soft_imask */

        case 1:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 610; /* atomic_and_fetchhi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 646; /* atomic_and_fetchhi_soft_imask */

        case 2:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 615; /* atomic_and_fetchsi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 651; /* atomic_and_fetchsi_soft_imask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case NE:
    case EQ:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      operands[1] = x4;
      if (t_reg_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x6 = XVECEXP (x1, 0, 1);
              if (pattern33 (x6, 
147, 
USE) == 0)
                {
                  x7 = XEXP (x2, 0);
                  operands[0] = x7;
                  if (arith_reg_dest (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode
                      && 
#line 8292 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return 292; /* movrt_xor */
                }
            }
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 151
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || pattern92 (x1, 
11) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 154
          || GET_MODE (x8) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 1048576L:
          if (!
#line 9168 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 326; /* toggle_sz */

        case 524288L:
          if (!
#line 9179 "../../gcc/config/sh/sh.md"
(TARGET_SH4A_FP || TARGET_FPU_SH4_300))
            return -1;
          return 327; /* toggle_pr */

        default:
          return -1;
        }

    case MEM:
      if (pattern62 (x1, pnum_clobbers, 
XOR) != 0)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern39 (x1))
        {
        case 0:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 604; /* atomic_xor_fetchqi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 640; /* atomic_xor_fetchqi_soft_imask */

        case 1:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 609; /* atomic_xor_fetchhi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 645; /* atomic_xor_fetchhi_soft_imask */

        case 2:
          if (
#line 1769 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            {
              *pnum_clobbers = 2;
              return 614; /* atomic_xor_fetchsi_soft_gusa */
            }
          if (!
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
            return -1;
          *pnum_clobbers = 1;
          return 650; /* atomic_xor_fetchsi_soft_imask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern67 (x1, 
154, 
155, 
USE) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern159 (x4, 
E_SFmode) != 0
              || !
#line 9220 "../../gcc/config/sh/sh.md"
(TARGET_SH2E))
            return -1;
          return 329; /* subsf3_i */

        case E_DFmode:
          if (pattern159 (x4, 
E_DFmode) != 0
              || !
#line 9583 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE))
            return -1;
          return 347; /* subdf3_i */

        default:
          return -1;
        }

    case MEM:
      x7 = XVECEXP (x1, 0, 1);
      if (pattern16 (x7, 
MINUS) != 0)
        return -1;
      switch (pattern196 (x1))
        {
        case 0:
          if (!arith_reg_dest (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          operands[1] = x6;
          if (!atomic_mem_operand_1 (operands[1], E_SImode)
              || !arith_reg_operand (operands[2], E_SImode)
              || pattern69 (x7) != 0
              || !
#line 1620 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS
   || (TARGET_SH4A && TARGET_ATOMIC_ANY && !TARGET_ATOMIC_STRICT)))
            return -1;
          return 574; /* atomic_sub_fetchsi_hard */

        case 1:
          if (pattern255 (x1, pnum_clobbers, 
E_QImode) != 0)
            return -1;
          operands[1] = x6;
          if (atomic_mem_operand_1 (operands[1], E_QImode))
            {
              x8 = XEXP (x7, 1);
              x9 = XVECEXP (x8, 0, 0);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x7, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 580; /* atomic_sub_fetchqi_hard */
                    }
                }
            }
          x12 = XEXP (x6, 0);
          operands[1] = x12;
          if (pattern275 (x7, 
E_QImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 590; /* atomic_sub_fetchqi_hard_1 */

        case 2:
          if (pattern255 (x1, pnum_clobbers, 
E_HImode) != 0)
            return -1;
          operands[1] = x6;
          if (atomic_mem_operand_1 (operands[1], E_HImode))
            {
              x8 = XEXP (x7, 1);
              x9 = XVECEXP (x8, 0, 0);
              x10 = XEXP (x9, 0);
              if (rtx_equal_p (x10, operands[1]))
                {
                  x11 = XEXP (x7, 0);
                  if (rtx_equal_p (x11, operands[1])
                      && 
#line 1660 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS && can_create_pseudo_p ()))
                    {
                      *pnum_clobbers = 1;
                      return 585; /* atomic_sub_fetchhi_hard */
                    }
                }
            }
          x12 = XEXP (x6, 0);
          operands[1] = x12;
          if (pattern275 (x7, 
E_HImode) != 0
              || !
#line 1696 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_HARD_LLCS))
            return -1;
          *pnum_clobbers = 3;
          return 595; /* atomic_sub_fetchhi_hard_1 */

        case 3:
          x11 = XEXP (x7, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern190 (x1, 
E_QImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 638; /* atomic_sub_fetchqi_soft_imask */

            case E_HImode:
              if (pattern190 (x1, 
E_HImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 643; /* atomic_sub_fetchhi_soft_imask */

            case E_SImode:
              if (pattern190 (x1, 
E_SImode) != 0
                  || !
#line 1879 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_IMASK))
                return -1;
              return 648; /* atomic_sub_fetchsi_soft_imask */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == E_BLKmode
      && pattern73 (x1) == 0
      && pattern199 (x1, 
0, 
146, 
USE) == 0)
    {
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      operands[0] = x5;
      if (arith_reg_operand (operands[0], E_SImode))
        {
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (
#line 8946 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && ! TARGET_HARD_SH4))
            return 319; /* block_move_real */
        }
    }
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (pattern74 (x4) != 0)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x11 = XEXP (x4, 1);
  x12 = XVECEXP (x11, 0, 0);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
    case SIGN_EXTEND:
      operands[2] = x12;
      if (pattern120 (x1) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      x14 = XEXP (x13, 0);
      operands[3] = x14;
      if (!gbr_displacement (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern215 (x11, 
E_QImode) != 0
              || !
#line 627 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 424; /* atomic_exchangeqi_soft_tcb */

        case E_HImode:
          if (pattern215 (x11, 
E_HImode) != 0
              || !
#line 627 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 425; /* atomic_exchangehi_soft_tcb */

        case E_SImode:
          if (pattern215 (x11, 
E_SImode) != 0
              || !
#line 627 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 426; /* atomic_exchangesi_soft_tcb */

        default:
          return -1;
        }

    case PLUS:
      if (REGNO (x9) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (pattern198 (x13, 
1) != 0)
        return -1;
      switch (pattern245 (x1))
        {
        case 0:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 480; /* atomic_fetch_addqi_soft_gusa */

        case 1:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 485; /* atomic_fetch_addhi_soft_gusa */

        case 2:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 490; /* atomic_fetch_addsi_soft_gusa */

        case 3:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 498; /* atomic_fetch_addqi_soft_tcb */

        case 4:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 503; /* atomic_fetch_addhi_soft_tcb */

        case 5:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 508; /* atomic_fetch_addsi_soft_tcb */

        default:
          return -1;
        }

    case MINUS:
      if (REGNO (x9) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (pattern198 (x13, 
1) != 0)
        return -1;
      switch (pattern247 (x1))
        {
        case 0:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 481; /* atomic_fetch_subqi_soft_gusa */

        case 1:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 486; /* atomic_fetch_subhi_soft_gusa */

        case 2:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 491; /* atomic_fetch_subsi_soft_gusa */

        case 3:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 499; /* atomic_fetch_subqi_soft_tcb */

        case 4:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 504; /* atomic_fetch_subhi_soft_tcb */

        case 5:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 509; /* atomic_fetch_subsi_soft_tcb */

        default:
          return -1;
        }

    case IOR:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 482; /* atomic_fetch_orqi_soft_gusa */

        case 1:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 487; /* atomic_fetch_orhi_soft_gusa */

        case 2:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 492; /* atomic_fetch_orsi_soft_gusa */

        case 3:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 500; /* atomic_fetch_orqi_soft_tcb */

        case 4:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 505; /* atomic_fetch_orhi_soft_tcb */

        case 5:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 510; /* atomic_fetch_orsi_soft_tcb */

        default:
          return -1;
        }

    case XOR:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 483; /* atomic_fetch_xorqi_soft_gusa */

        case 1:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 488; /* atomic_fetch_xorhi_soft_gusa */

        case 2:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 493; /* atomic_fetch_xorsi_soft_gusa */

        case 3:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 501; /* atomic_fetch_xorqi_soft_tcb */

        case 4:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 506; /* atomic_fetch_xorhi_soft_tcb */

        case 5:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 511; /* atomic_fetch_xorsi_soft_tcb */

        default:
          return -1;
        }

    case AND:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 484; /* atomic_fetch_andqi_soft_gusa */

        case 1:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 489; /* atomic_fetch_andhi_soft_gusa */

        case 2:
          if (!
#line 1019 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 494; /* atomic_fetch_andsi_soft_gusa */

        case 3:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 502; /* atomic_fetch_andqi_soft_tcb */

        case 4:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 507; /* atomic_fetch_andhi_soft_tcb */

        case 5:
          if (!
#line 1082 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 512; /* atomic_fetch_andsi_soft_tcb */

        default:
          return -1;
        }

    case NOT:
      if (REGNO (x9) != 0)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (pattern198 (x13, 
1) != 0)
        return -1;
      switch (pattern250 (x1))
        {
        case 0:
          if (!
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 495; /* atomic_fetch_notqi_soft_gusa */

        case 1:
          if (!
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 496; /* atomic_fetch_nothi_soft_gusa */

        case 2:
          if (!
#line 1049 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 497; /* atomic_fetch_notsi_soft_gusa */

        case 3:
          if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 528; /* atomic_fetch_notqi_soft_tcb */

        case 4:
          if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 529; /* atomic_fetch_nothi_soft_tcb */

        case 5:
          if (!
#line 1138 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 530; /* atomic_fetch_notsi_soft_tcb */

        case 6:
          if (!
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 561; /* atomic_fetch_nandqi_soft_gusa */

        case 7:
          if (!
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 562; /* atomic_fetch_nandhi_soft_gusa */

        case 8:
          if (!
#line 1449 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_GUSA))
            return -1;
          return 563; /* atomic_fetch_nandsi_soft_gusa */

        case 9:
          if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 564; /* atomic_fetch_nandqi_soft_tcb */

        case 10:
          if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 565; /* atomic_fetch_nandhi_soft_tcb */

        case 11:
          if (!
#line 1483 "../../gcc/config/sh/sync.md"
(TARGET_ATOMIC_SOFT_TCB))
            return -1;
          return 566; /* atomic_fetch_nandsi_soft_tcb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case GT:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 147
                  && GET_MODE (x3) == E_SImode)
                {
                  switch (pattern80 (x2))
                    {
                    case 0:
                      if (
#line 912 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                        return 13; /* cmpgtsi_t */
                      break;

                    case 1:
                      if (
#line 1387 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                        return 30; /* cmpgtdi_t */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case GE:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LSHIFTRT:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTRACT:
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case GEU:
          switch (pattern0 (x1))
            {
            case 0:
              if (arith_reg_operand (operands[0], E_SImode)
                  && arith_reg_or_0_operand (operands[1], E_SImode)
                  && 
#line 1280 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 26; /* cmpgeusi_t */
              break;

            case 1:
              if (arith_reg_operand (operands[0], E_DImode)
                  && arith_reg_operand (operands[1], E_DImode)
                  && 
#line 1437 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return 32; /* cmpgeudi_t */
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (pattern0 (x1))
            {
            case 0:
              if (arith_reg_operand (operands[0], E_SImode)
                  && arith_reg_operand (operands[1], E_SImode)
                  && 
#line 1291 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 27; /* cmpgtusi_t */
              break;

            case 1:
              if (arith_reg_operand (operands[0], E_DImode)
                  && arith_reg_operand (operands[1], E_DImode)
                  && 
#line 1452 "../../gcc/config/sh/sh.md"
(TARGET_SH2))
                return 33; /* cmpgtudi_t */
              break;

            default:
              break;
            }
          break;

        case UNSPEC:
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UDIV:
          if (pattern1 (x1) == 0
              && 
#line 2185 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return 62; /* udivsi3_sh2a */
          break;

        case DIV:
          if (pattern1 (x1) == 0
              && 
#line 2334 "../../gcc/config/sh/sh.md"
(TARGET_SH2A))
            return 67; /* divsi3_sh2a */
          break;

        case MULT:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case TRUNCATE:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
        case IOR:
        case XOR:
          switch (GET_CODE (x2))
            {
            case XOR:
              res = recog_8 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case AND:
              res = recog_9 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case IOR:
              res = recog_12 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[3] = x2;
          if (pattern7 (x1) == 0
              && 
#line 2827 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
            return 93; /* *logical_op_t */
          break;

        case ROTATERT:
          if (pnum_clobbers != NULL
              && pattern5 (x1, 
1) == 0
              && 
#line 2903 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            {
              *pnum_clobbers = 1;
              return 97; /* *rotrsi3_1 */
            }
          break;

        case ROTATE:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ASHIFT:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LT:
          if (pnum_clobbers != NULL
              && GET_MODE (x2) == E_SImode)
            {
              x4 = XEXP (x2, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x3 = XEXP (x1, 0);
                  if (GET_CODE (x3) == REG
                      && REGNO (x3) == 147
                      && GET_MODE (x3) == E_SImode)
                    {
                      x5 = XEXP (x2, 0);
                      operands[0] = x5;
                      if (arith_reg_operand (operands[0], E_SImode)
                          && 
#line 3641 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && cse_not_expected))
                        {
                          *pnum_clobbers = 1;
                          return 123; /* *ashlsi_c_void */
                        }
                    }
                }
            }
          break;

        case ASHIFTRT:
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SIGN_EXTRACT:
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NEG:
          res = recog_18 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case NOT:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arith_reg_dest (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 0);
                  operands[1] = x5;
                  if (arith_reg_operand (operands[1], E_SImode)
                      && 
#line 4405 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                    return 153; /* one_cmplsi2 */
                }
            }
          break;

        case ABS:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern58 (x2, pnum_clobbers, 
E_SImode) == 0
                  && 
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 154; /* abssi2 */
                }
              break;

            case E_DImode:
              if (pattern58 (x2, pnum_clobbers, 
E_DImode) == 0
                  && 
#line 4463 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 155; /* absdi2 */
                }
              break;

            case E_SFmode:
              if (fp_arith_reg_operand (operands[0], E_SFmode)
                  && GET_MODE (x2) == E_SFmode
                  && fp_arith_reg_operand (operands[1], E_SFmode)
                  && 
#line 9533 "../../gcc/config/sh/sh.md"
(TARGET_FPU_ANY && !TARGET_FPU_SH4_300))
                return 344; /* abssf2_no_fpscr */
              break;

            case E_DFmode:
              if (fp_arith_reg_operand (operands[0], E_DFmode)
                  && GET_MODE (x2) == E_DFmode
                  && fp_arith_reg_operand (operands[1], E_DFmode)
                  && 
#line 9780 "../../gcc/config/sh/sh.md"
(TARGET_FPU_DOUBLE && !TARGET_FPU_SH4_300))
                return 358; /* absdf2_no_fpscr */
              break;

            default:
              break;
            }
          break;

        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) == 1
              && XINT (x2, 1) == 8
              && pattern18 (x1, 
144) == 0
              && arith_reg_operand (operands[0], E_SImode)
              && 
#line 7686 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 259; /* load_gbr */
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case NE:
        case EQ:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          switch (GET_CODE (x2))
            {
            case EQ:
              res = recog_19 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ZERO_EXTEND:
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case SIGN_EXTEND:
            case HIGH:
              res = recog_26 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (t_reg_operand (operands[1], E_SImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arith_reg_dest (operands[0], E_SImode)
                  && 
#line 8160 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return 288; /* movt */
            }
          if (GET_CODE (x2) == REG
              && REGNO (x2) == 147
              && pattern19 (x1, 
147) == 0
              && 
#line 8427 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
            return 297; /* *treg_noop_move */
          break;

        case IF_THEN_ELSE:
        case PLUS:
        case MINUS:
          res = recog_36 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (arith_reg_dest (operands[0], E_SImode))
            {
              operands[1] = x2;
              if (treg_set_expr (operands[1], E_VOIDmode)
                  && 
#line 8607 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && can_create_pseudo_p ()))
                {
                  *pnum_clobbers = 1;
                  return 304; /* any_treg_expr_to_reg */
                }
            }
        }
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return recog_37 (x1, insn, pnum_clobbers);

    case PARALLEL:
      return recog_86 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x6 = XVECEXP (x1, 0, 0);
          operands[0] = x6;
          x7 = XVECEXP (x1, 0, 1);
          operands[1] = x7;
          switch (XINT (x1, 1))
            {
            case 11:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 5311 "../../gcc/config/sh/sh.md"
(TARGET_HARD_SH4))
                return -1;
              *pnum_clobbers = 1;
              return 192; /* ic_invalidate_line_i */

            case 2:
              if (!general_operand (operands[0], E_SImode))
                return -1;
              return 305; /* consttable_2 */

            case 3:
              if (general_operand (operands[0], E_SImode))
                return 306; /* consttable_4 */
              if (!general_operand (operands[0], E_SFmode))
                return -1;
              return 308; /* consttable_sf */

            case 4:
              if (general_operand (operands[0], E_SImode))
                return 307; /* consttable_8 */
              if (!general_operand (operands[0], E_DFmode))
                return -1;
              return 309; /* consttable_df */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x1, 1))
            {
            case 11:
              x6 = XVECEXP (x1, 0, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 5324 "../../gcc/config/sh/sh.md"
(TARGET_SH4A || TARGET_SH4_300))
                return -1;
              return 193; /* ic_invalidate_line_sh4a */

            case 7:
              if (pnum_clobbers == NULL)
                return -1;
              x6 = XVECEXP (x1, 0, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 284; /* eh_set_ra_si */

            case 0:
              x6 = XVECEXP (x1, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 285; /* blockage */

            case 1:
              x6 = XVECEXP (x1, 0, 0);
              operands[0] = x6;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 310; /* align_log */

            case 6:
              x6 = XVECEXP (x1, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 311; /* consttable_end */

            case 5:
              x6 = XVECEXP (x1, 0, 0);
              operands[0] = x6;
              return 312; /* consttable_window_end */

            case 10:
              x6 = XVECEXP (x1, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 10983 "../../gcc/config/sh/sh.md"
(TARGET_SH1))
                return -1;
              return 398; /* sp_switch_2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 251; /* nop */

    case RETURN:
      if (
#line 8050 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && reload_completed
   && ! sh_cfun_trap_exit_p ()))
        return 281; /* *return_i */
      if (!
#line 8066 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && reload_completed))
        return -1;
      return 283; /* *return_trapa */

    case SIMPLE_RETURN:
      if (!
#line 8050 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && reload_completed
   && ! sh_cfun_trap_exit_p ()))
        return -1;
      return 282; /* *simple_return_i */

    case PREFETCH:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      operands[1] = x2;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x1, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11004 "../../gcc/config/sh/sh.md"
((TARGET_SH2A || TARGET_SH3) && ! TARGET_VXWORKS_RTP))
        return -1;
      return 399; /* *prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (arith_reg_dest (operands[0], E_SImode))
    {
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!const_logical_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return NULL;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return NULL;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return NULL;
  switch (GET_CODE (x5))
    {
    case AND:
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return NULL;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 10679 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (3, operands[0]) && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_19 (insn, operands);

    case IOR:
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return NULL;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 10679 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (3, operands[0]) && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_20 (insn, operands);

    case XOR:
      x9 = XEXP (x5, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return NULL;
      x10 = XEXP (x5, 1);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 10679 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (3, operands[0]) && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_21 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return NULL;
  operands[1] = x3;
  res = peephole2_3 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode
      || !arith_reg_dest (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!arith_reg_operand (operands[1], E_SImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!arith_reg_operand (operands[2], E_SImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (1));
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x7, 1);
  operands[4] = x9;
  switch (GET_MODE (x3))
    {
    case E_QImode:
      if (!arith_reg_dest (operands[3], E_QImode)
          || !arith_reg_operand (operands[4], E_QImode)
          || !
#line 10610 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && REGNO (operands[0]) == REGNO (operands[4])
   && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case E_HImode:
      if (!arith_reg_dest (operands[3], E_HImode)
          || !arith_reg_operand (operands[4], E_HImode)
          || !
#line 10624 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && REGNO (operands[0]) == REGNO (operands[4])
   && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      if (GET_MODE (x3) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      if (!rtx_equal_p (x4, operands[0]))
        return NULL;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case AND:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT
              || XWINT (x6, 0) != -65536L)
            return NULL;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != IOR
              || GET_MODE (x7) != E_SImode
              || pattern187 (x7) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!arith_reg_operand (operands[1], E_SImode))
            return NULL;
          x9 = XEXP (x7, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return NULL;
          x12 = XEXP (x7, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return NULL;
          x15 = XEXP (x2, 0);
          operands[2] = x15;
          if (!arith_reg_dest (operands[2], E_SImode)
              || !
#line 4675 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x5, operands[0]))
            return NULL;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          if (!arith_reg_dest (operands[1], E_SImode))
            return NULL;
          x15 = XEXP (x2, 0);
          if (!rtx_equal_p (x15, operands[1])
              || !
#line 10693 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_23 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !arith_reg_dest (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x15 = XEXP (x2, 0);
      operands[2] = x15;
      switch (GET_CODE (operands[1]))
        {
        case MEM:
          if (!displacement_mem_operand (operands[1], E_VOIDmode)
              || !nonimmediate_operand (operands[2], E_VOIDmode))
            return NULL;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (!arith_reg_operand (operands[3], E_VOIDmode)
              || !
#line 4759 "../../gcc/config/sh/sh.md"
(TARGET_SH2A
   && REGNO (operands[0]) == REGNO (operands[3])
   && peep2_reg_dead_p (2, operands[0])
   && GET_MODE_SIZE (GET_MODE (operands[2]))
      <= GET_MODE_SIZE (GET_MODE (operands[1]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          if (!arith_reg_dest (operands[2], E_SImode))
            return NULL;
          x4 = XEXP (x2, 1);
          if (!rtx_equal_p (x4, operands[0]))
            return NULL;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!arith_reg_operand (operands[1], E_QImode)
                  || !
#line 10638 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case E_HImode:
              if (!arith_reg_operand (operands[1], E_HImode)
                  || !
#line 10638 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return NULL;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x16 = XEXP (x3, 2);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode)
        return NULL;
      x17 = XEXP (x4, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return NULL;
      x18 = XEXP (x4, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return NULL;
      x15 = XEXP (x2, 0);
      if (!rtx_equal_p (x15, operands[1])
          || !
#line 9945 "../../gcc/config/sh/sh.md"
(TARGET_SH4A && REGNO (operands[0]) != REGNO (operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_5 (insn, operands);

    case AND:
      if (pattern79 (x3) != 0
          || !
#line 10693 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_22 (insn, operands);

    case XOR:
      if (pattern79 (x3) != 0
          || !
#line 10693 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_24 (insn, operands);

    case PLUS:
      if (pattern79 (x3) != 0
          || !
#line 10693 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_25 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case SIGN_EXTEND:
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case REG:
        case SUBREG:
        case SIGN_EXTEND:
          res = peephole2_6 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MEM:
          operands[1] = x3;
          x15 = XEXP (x2, 0);
          operands[2] = x15;
          x4 = XEXP (x2, 1);
          if (rtx_equal_p (x4, operands[0]))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode)
                      && movsrc_no_disp_mem_operand (operands[1], E_QImode)
                      && register_operand (operands[2], E_QImode)
                      && 
#line 10771 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_28 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode)
                      && movsrc_no_disp_mem_operand (operands[1], E_HImode)
                      && register_operand (operands[2], E_HImode)
                      && 
#line 10771 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_29 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      if (general_movsrc_operand (operands[1], E_SImode)
          && arith_reg_dest (operands[0], E_SImode))
        {
          x15 = XEXP (x2, 0);
          operands[2] = x15;
          if (arith_reg_dest (operands[2], E_SImode))
            {
              x4 = XEXP (x2, 1);
              if (rtx_equal_p (x4, operands[0])
                  && 
#line 10760 "../../gcc/config/sh/sh.md"
(TARGET_SH1 && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_27 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 3
          || !arith_reg_dest (operands[1], E_VOIDmode)
          || !arith_reg_dest (operands[0], E_VOIDmode))
        return NULL;
      x15 = XEXP (x2, 0);
      operands[2] = x15;
      if (!arith_reg_dest (operands[2], E_SImode))
        return NULL;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      x19 = PATTERN (peep2_next_insn (2));
      if (pattern162 (x19) != 0
          || !
#line 10802 "../../gcc/config/sh/sh.md"
(TARGET_SH1
   && peep2_reg_dead_p (3, operands[0])
   && !reg_overlap_mentioned_p (operands[0], operands[3])
   && (REGNO (operands[0]) == REGNO (operands[4])
       || REGNO (operands[0]) == REGNO (operands[5]))
   && (REGNO (operands[2]) == REGNO (operands[4])
       || REGNO (operands[2]) == REGNO (operands[5]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_32 (insn, operands);

    default:
      return NULL;
    }
}
