/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  if (!logical_shift_operator (operands[4], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (pattern20 (x2))
    {
    case 0:
      return 99; /* movsicc_internal0 */

    case 1:
      return 101; /* movsfcc_internal0 */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (mask_operand (operands[2], E_SImode))
        return 35; /* andsi3 */
      if (const_int_operand (operands[2], E_SImode))
        {
          if (
#line 773 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)))
            return 37; /* *andsi3_const_pow2_minus_one */
          if (
#line 797 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[2])), 12, 31)))
            return 38; /* *andsi3_const_negative_pow2 */
        }
      if (!shifted_mask_operand (operands[2], E_SImode)
          || !
#line 817 "../../gcc/config/xtensa/xtensa.md"
(! xtensa_simm12b (INTVAL (operands[2]))))
        return -1;
      return 39; /* *andsi3_const_shifted_mask */

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 36; /* *andsi3_bitcmpl */

    case ASHIFT:
    case LSHIFTRT:
      if (pattern14 (x2) != 0
          || !
#line 1086 "../../gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[3])) > 0))
        return -1;
      return 49; /* *extzvsi-1bit_ashlsi3 */

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 137; /* *round_up_to_even */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!boolean_operator (x3, E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return NULL;
  x5 = XEXP (x2, 2);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return NULL;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[0] = x7;
      if (register_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) == CONST_INT
              && XWINT (x8, 0) == -2147483648L)
            {
              operands[2] = x3;
              x9 = XEXP (x4, 0);
              operands[1] = x9;
              if ((
#line 1977 "../../gcc/config/xtensa/xtensa.md"
(TARGET_ABS) && 
#line 1979 "../../gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_27 (insn, operands);
            }
        }
      if (!subreg_HQI_lowpart_operator (x7, E_VOIDmode))
        return NULL;
      operands[3] = x7;
      x10 = XEXP (x7, 0);
      if (GET_CODE (x10) != NOT
          || GET_MODE (x10) != E_SImode)
        return NULL;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x3;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      return gen_split_29 (insn, operands);

    case AND:
      if (GET_MODE (x7) != E_SImode)
        return NULL;
      x12 = XEXP (x7, 1);
      operands[1] = x12;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return NULL;
          x8 = XEXP (x3, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          operands[3] = x3;
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode))
            return NULL;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          if (!(
#line 2100 "../../gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[1])) < 0) && 
#line 2102 "../../gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_28 (insn, operands);

        case REG:
        case SUBREG:
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          operands[4] = x3;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x4, 0);
          operands[3] = x9;
          if (const_int_operand (operands[1], E_SImode))
            {
              if ((
#line 2153 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[1]) + 1), 17, 31)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) << (32 - floor_log2 (INTVAL (operands[1]) + 1)))) && 
#line 2157 "../../gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_30 (insn, operands);
              if ((
#line 2193 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[1])), 1, 30)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) >> floor_log2 (-INTVAL (operands[1])))) && 
#line 2197 "../../gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return gen_split_31 (insn, operands);
            }
          if (!shifted_mask_operand (operands[1], E_SImode)
              || !(
#line 2228 "../../gcc/config/xtensa/xtensa.md"
(/* (INTVAL (operands[2]) & ((1 << ctz_hwi (INTVAL (operands[1]))) - 1)) == 0  // can be omitted
   && */ xtensa_b4const_or_zero ((uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])))) && 
#line 2231 "../../gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
            return NULL;
          return gen_split_32 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
