/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 4
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 0
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) == EQ)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_CCmode)
              && GET_MODE (x3) == E_CCmode
              && register_operand (operands[1], E_SFmode)
              && 
#line 2519 "../../gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return 103; /* seq_sf */
          break;

        case CONST_INT:
          if (XWINT (x5, 0) == 0L
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode
              && register_operand (operands[1], E_SImode)
              && 
#line 3214 "../../gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
            return 139; /* eq_zero_NSA */
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != CONST_INT
      || !boolean_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 140; /* eqne_zero */

        case -2147483648L:
          if (!
#line 3298 "../../gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
            return -1;
          return 142; /* *eqne_INT_MIN */

        default:
          return -1;
        }

    case AND:
      if (pattern15 (x3) != 0
          || !
#line 3270 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)
   || IN_RANGE (exact_log2 (-INTVAL (operands[2])), 1, 30)))
        return -1;
      return 141; /* *eqne_zero_masked_bits */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_14 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 1);
              switch (GET_CODE (x3))
                {
                case BSWAP:
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  x6 = XEXP (x3, 0);
                  operands[1] = x6;
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern17 (x3, 
E_HImode) != 0)
                        return -1;
                      return 30; /* bswaphi2 */

                    case E_SImode:
                      if (pattern17 (x3, 
E_SImode) != 0
                          || !
#line 651 "../../gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize > 1 && !optimize_size))
                        return -1;
                      return 31; /* bswapsi2_internal */

                    default:
                      return -1;
                    }

                case UNSPEC_VOLATILE:
                  if (pattern9 (x2) != 0)
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x8 = XVECEXP (x3, 0, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (!scratch_operand (operands[1], E_SImode))
                    return -1;
                  return 120; /* eh_set_a0_windowed */

                case REG:
                case SUBREG:
                case MEM:
                  switch (GET_CODE (x3))
                    {
                    case MEM:
                      res = recog_12 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    case REG:
                    case SUBREG:
                      res = recog_13 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                      break;

                    default:
                      break;
                    }
                  operands[1] = x3;
                  if (!mem_operand (operands[1], E_SImode))
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != SET)
                    return -1;
                  x9 = XEXP (x4, 1);
                  if (GET_CODE (x9) != UNSPEC_VOLATILE
                      || XVECLEN (x9, 0) != 3
                      || XINT (x9, 1) != 3
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XVECEXP (x9, 0, 1);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x11 = XVECEXP (x9, 0, 2);
                  operands[3] = x11;
                  if (!register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XVECEXP (x9, 0, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  x7 = XEXP (x4, 0);
                  if (!rtx_equal_p (x7, operands[1])
                      || !
#line 3099 "../../gcc/config/xtensa/xtensa.md"
(TARGET_S32C1I))
                    return -1;
                  return 136; /* sync_compare_and_swapsi */

                case NE:
                case EQ:
                  operands[2] = x3;
                  if (!boolean_operator (operands[2], E_SImode))
                    return -1;
                  x13 = XEXP (x3, 1);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) != CLOBBER)
                    return -1;
                  x5 = XEXP (x2, 0);
                  operands[0] = x5;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x6 = XEXP (x3, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x4, 0);
                  operands[3] = x7;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  return 140; /* eqne_zero */

                default:
                  return -1;
                }

            case RETURN:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 0
                  || GET_MODE (x7) != E_SImode
                  || !
#line 2713 "../../gcc/config/xtensa/xtensa.md"
(reload_completed
   && (TARGET_WINDOWED_ABI
       || compute_frame_size (get_frame_size ()) == 0
       || epilogue_completed)))
                return -1;
              return 118; /* return */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 4)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x14 = XVECEXP (x2, 0, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              return 121; /* eh_set_a0_call0 */

            default:
              return -1;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != IF_THEN_ELSE)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != NE)
            return -1;
          x15 = XEXP (x6, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x13 = XEXP (x3, 1);
          if (GET_CODE (x13) != LABEL_REF)
            return -1;
          x16 = XEXP (x3, 2);
          if (GET_CODE (x16) != PC)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x17 = XEXP (x9, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x18 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x18) != UNSPEC
              || XVECLEN (x18, 0) != 1)
            return -1;
          x19 = XVECEXP (x18, 0, 0);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XEXP (x6, 0);
          operands[2] = x20;
          x21 = XEXP (x13, 0);
          operands[1] = x21;
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[0]))
            return -1;
          switch (XINT (x18, 1))
            {
            case 10:
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 2280 "../../gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 94; /* zero_cost_loop_start */

            case 11:
              if (pnum_clobbers != NULL
                  && nonimmediate_operand (operands[2], E_SImode)
                  && nonimmediate_operand (operands[0], E_SImode)
                  && 
#line 2297 "../../gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                {
                  *pnum_clobbers = 1;
                  return 95; /* zero_cost_loop_end */
                }
              if (!register_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 2313 "../../gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
                return -1;
              return 96; /* loop_end */

            default:
              return -1;
            }

        case 4:
          if (pattern6 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x3 = XEXP (x2, 1);
          x6 = XEXP (x3, 0);
          x20 = XEXP (x6, 0);
          operands[2] = x20;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x3, 1);
          x21 = XEXP (x13, 0);
          operands[1] = x21;
          x4 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x23 = XVECEXP (x1, 0, 3);
          x24 = XEXP (x23, 0);
          operands[3] = x24;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          x22 = XEXP (x9, 0);
          if (!rtx_equal_p (x22, operands[0])
              || !
#line 2297 "../../gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize))
            return -1;
          return 95; /* zero_cost_loop_end */

        default:
          return -1;
        }

    case CALL:
      x25 = XEXP (x1, 0);
      if (GET_CODE (x25) != MEM)
        return -1;
      x26 = XEXP (x25, 0);
      operands[0] = x26;
      if (!call_insn_operand (operands[0], E_SImode))
        return -1;
      x27 = XEXP (x1, 1);
      operands[1] = x27;
      if (
#line 2607 "../../gcc/config/xtensa/xtensa.md"
(!SIBLING_CALL_P (insn)))
        return 113; /* call_internal */
      if (GET_MODE (x25) != E_SImode
          || !
#line 2649 "../../gcc/config/xtensa/xtensa.md"
(!TARGET_WINDOWED_ABI && SIBLING_CALL_P (insn)))
        return -1;
      return 115; /* sibcall_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 119; /* nop */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 4:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 121; /* eh_set_a0_call0 */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 122; /* blockage */

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2973 "../../gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR))
            return -1;
          return 128; /* set_thread_pointersi */

        default:
          return -1;
        }

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x27 = XEXP (x1, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 124; /* trap */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 126; /* *unspec_nop */

    default:
      return -1;
    }
}
