/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !add_operand (operands[2], E_SImode))
            return -1;
          return 1; /* addsi3 */

        case E_SFmode:
          if (pattern10 (x2, 
E_SFmode) != 0
              || !
#line 249 "../../gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 3; /* addsf3 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 408 "../../gcc/config/xtensa/xtensa.md"
(TARGET_MAC16))
        return -1;
      return 12; /* muladdhisi */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SFmode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      if (!fpmem_offset_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x5, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XEXP (x4, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 1487 "../../gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC))
        return -1;
      return 66; /* *lsiu */

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      if (!fpmem_offset_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x12 = XEXP (x4, 0);
      if (!rtx_equal_p (x12, operands[1])
          || !
#line 1519 "../../gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC))
        return -1;
      return 68; /* *lsip */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || peep2_current_count < 4)
        return NULL;
      operands[6] = x3;
      if (!reload_operand (operands[6], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x4, 1);
      operands[7] = x6;
      if (!reload_operand (operands[7], E_SImode))
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SFmode))
        return NULL;
      x9 = XEXP (x7, 1);
      operands[4] = x9;
      if (!register_operand (operands[4], E_SFmode))
        return NULL;
      x10 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x10) != SET)
        return NULL;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_SFmode))
        return NULL;
      x12 = XEXP (x10, 1);
      operands[5] = x12;
      if (!register_operand (operands[5], E_SFmode)
          || !
#line 3331 "../../gcc/config/xtensa/xtensa.md"
(REGNO (operands[0]) == REGNO (operands[4])
   && REGNO (operands[1]) == REGNO (operands[5])
   && peep2_reg_dead_p (4, operands[0])
   && peep2_reg_dead_p (4, operands[1])))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_1 (insn, operands);

    case CONST_INT:
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != PLUS
          || GET_MODE (x6) != E_SImode)
        return NULL;
      x13 = XEXP (x6, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return NULL;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x7 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x7) != SET)
        return NULL;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return NULL;
      x15 = XEXP (x9, 0);
      operands[4] = x15;
      if (!register_operand (operands[4], E_SImode))
        return NULL;
      x16 = XEXP (x9, 1);
      if (!rtx_equal_p (x16, operands[0])
          || !
#line 3414 "../../gcc/config/xtensa/xtensa.md"
(IN_RANGE (INTVAL (operands[1]) + INTVAL (operands[2]),
	     (-128 - 32768), (127 + 32512))
   && REGNO (operands[0]) != REGNO (operands[3])
   && REGNO (operands[0]) != REGNO (operands[4])
   && peep2_reg_dead_p (3, operands[0])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_2 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_VOIDmode)
          || !register_operand (operands[0], E_VOIDmode)
          || !
#line 3441 "../../gcc/config/xtensa/xtensa.md"
(REG_NREGS (operands[0]) == 1 && GP_REG_P (REGNO (operands[0]))
   && REG_NREGS (operands[1]) == 1 && GP_REG_P (REGNO (operands[1]))
   && peep2_reg_dead_p (1, operands[1])))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_3 (insn, operands);

    default:
      return NULL;
    }
}
