/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 11)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (nonimmed_operand (operands[0], E_DImode)
              && move_operand (operands[1], E_DImode)
              && 
#line 1242 "../../gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)))
            return 61; /* movdi_internal */
          break;

        case E_SImode:
          if (nonimmed_operand (operands[0], E_SImode)
              && move_operand (operands[1], E_SImode)
              && 
#line 1284 "../../gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (SImode, operands)))
            return 62; /* movsi_internal */
          break;

        case E_HImode:
          if (nonimmed_operand (operands[0], E_HImode)
              && move_operand (operands[1], E_HImode)
              && 
#line 1356 "../../gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (HImode, operands)))
            return 63; /* movhi_internal */
          break;

        case E_QImode:
          if (nonimmed_operand (operands[0], E_QImode)
              && move_operand (operands[1], E_QImode)
              && 
#line 1386 "../../gcc/config/xtensa/xtensa.md"
(xtensa_valid_move (QImode, operands)))
            return 64; /* movqi_internal */
          break;

        case E_SFmode:
          if (nonimmed_operand (operands[0], E_SFmode)
              && move_operand (operands[1], E_SFmode)
              && 
#line 1458 "../../gcc/config/xtensa/xtensa.md"
(((register_operand (operands[0], SFmode)
     || register_operand (operands[1], SFmode))
    && !(FP_REG_P (xt_true_regnum (operands[0]))
	 && (constantpool_mem_p (operands[1]) || CONSTANT_P (operands[1]))))))
            return 65; /* movsf_internal */
          break;

        case E_DFmode:
          if (nonimmed_operand (operands[0], E_DFmode)
              && move_operand (operands[1], E_DFmode)
              && 
#line 1588 "../../gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)))
            return 70; /* movdf_internal */
          break;

        default:
          break;
        }
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (register_operand (operands[0], E_SImode))
        return 111; /* indirect_jump_internal */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LABEL_REF
      || GET_CODE (x2) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  return 110; /* jump */
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_CODE (x3))
        {
        case PLUS:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) == ASHIFT
              && GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  if (addsubx_operand (operands[3], E_SImode)
                      && const_int_operand (operands[2], E_SImode)
                      && 
#line 207 "../../gcc/config/xtensa/xtensa.md"
(TARGET_ADDX && can_create_pseudo_p ()))
                    return gen_split_1 (insn, operands);
                }
            }
          break;

        case MINUS:
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_SImode)
              && (
#line 272 "../../gcc/config/xtensa/xtensa.md"
(xtensa_simm8 (-INTVAL (operands[1]))
   || xtensa_simm8x256 (-INTVAL (operands[1]))) && 
#line 275 "../../gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_2 (insn, operands);
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return NULL;
  x6 = XEXP (x5, 0);
  if (!logical_shift_operator (x6, E_SImode))
    return NULL;
  operands[6] = x6;
  operands[5] = x3;
  if (!addsub_operator (operands[5], E_SImode))
    return NULL;
  x8 = XEXP (x6, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x6, 1);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || !(
#line 1119 "../../gcc/config/xtensa/xtensa.md"
(TARGET_ADDX
   && IN_RANGE (exact_log2 (INTVAL (operands[4])), 1, 3)) && 
#line 1122 "../../gcc/config/xtensa/xtensa.md"
( reload_completed)))
    return NULL;
  return gen_split_10 (insn, operands);
}
